<?php
/*-----------------------------------------------------------------------------
**-----------------------------------------------------------------------------
*/

include_once("../function.php");

$interface = 'admin.block';
$interface_title = 'DarkPortal Admin - Content/Block Management';
$interface_cols = array('id', 'theme', 'user_block', 'grp', 'zone', 
                        'interface', 'operation', 'title', 'content',
                        ' code', 'ord');
$plugin = 'admin';

include("$include_path/$plugin/function.php");
include("$include_path/$plugin/config.php");

if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

class LocalInterface extends Interface{

  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;

    $this->template =& $theme;
    $interface = $this->interface;

    $theme->assign('idata', $this->interface_data);
  }

  function zoneScript() {
    global $dbh;

    $out = <<<END_JSCRIPT
<script language="JavaScript"><!--
var zonename = new Array();
var zonevalue = new Array();
var zoneSelected = "{$this->interface_data[zone]}";

END_JSCRIPT;

    $sql = "select name, theme from zone order by theme, name";
    $result = $dbh->Execute($sql);
    while($data = $result->fields) {
      $result->MoveNext();
      if ($zone[$data[theme]][flag] < 1) {
        $out .= "\nzonename[$data[theme]] = new Array();\n";
        $out .= "\nzonevalue[$data[theme]] = new Array();\n";
        $zone[$data[theme]][flag] = 0;
      }
      $out .= "zonename[$data[theme]][{$zone[$data[theme]][flag]}] = \"$data[name]\";\n";
      $zone[$data[theme]][flag]++;
    }
    
    $out .= <<<END_JSCRIPT
getZones();
function getZones() {
  formMain = top.document.forms[0];
  tSelect = formMain.form_theme;
  zSelect = formMain.form_zone;
  tIndex = tSelect.options[tSelect.selectedIndex].value;
  zSelect.options.length = 0;
  selectIndex = 0;
  for (var i = 0 ; i < zonename[tIndex].length; i++){
    zSelect.options[i] = new Option(zonename[tIndex][i], zonename[tIndex][i]);
    if ((zonename[tIndex][i] == zoneSelected)) {
      selectIndex = i;
    }
  }
  zSelect.options[selectIndex].selected = true;
}
//-->
</script>
END_JSCRIPT;

    return $out;
  }    

  function edit() {
    global $dbh;
    $this->interface_data[JSCRIPT] = $this->zoneScript(); 
    $this->theme->assign('idata', $this->interface_data);
  }

  function add() {
    $this->interface_data[JSCRIPT] = $this->zoneScript(); 
    if ($this->search[key] == 'theme') {
      $this->interface_data[theme] = $this->search[id];
    } elseif ($this->search[key] == 'zone') {
      $this->interface_data[zone] = $this->search[id];
    } elseif ($this->search[key] == 'group') {
      $this->interface_data[grp] = $this->search[id];
    }
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function copy() {
    $theme =& $this->theme;
    $this->interface_data[JSCRIPT] = $this->zoneScript(); 
    $theme->assign('idata', $this->interface_data);
  }

  function doAdd() {
    global $dbh;
    unset ($this->form_data[id]);
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $this->form_data[content] = preg_replace("/<\[({$this->theme->tconfig[tags]})([^>]*)\]>/", "\{\\1\\2\}", $this->form_data[content]);
    $sql = "insert into block ";
    while (list($k, $v) = each($this->form_data)) {
  		$dbfields[] = $k;
  		if ($k != 'password') {
  			$dbvalues[] = $this->command->db_quote($v);
  		} else {
  			$dbvalues[] = "encrypt( " . $this->command->db_quote($v) . ")";
  		}
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error = "Block addition failed -- " . $dbh->ErrorMsg() : '';
    $this->interface_data[error] = $error;
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function doEdit() {
    global $dbh;
    $dbfields = array();
    $error = '';
    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $sql = "update block set ";
      while (list($k,$v) = each ($this->form_data)) {
        $dbfields[] = "$k = " . $this->command->db_quote($v);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where id = ". $this->command->db_quote($this->form_data[id]);
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Block modification failed -- " . $dbh->ErrorMsg() : '';
    } else {
        $error = "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }

  function doDelete() {
    global $dbh;
    $error = '';
    /// Need to set the search key and id in the interface block
    if(isset($this->interface_data[id]) ) { // Valid delete ID lookup
      $sql = "delete from block where id = {$this->interface_data[id]}";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Block delete failed -- " . $dbh->ErrorMsg() : '';
    } else {
      $error = "Invalid block id selected.";
    }
    if ($error = '') { $this->interface_data = array(); }
    $this->interface_data[error] = $error;
  }

  function doCopy() {
    global $dbh;
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $this->form_data[content] = preg_replace("/<\[({$this->theme->tconfig[tags]})([^>]*)\]>/", "\{\\1\\2\}", $this->form_data[content]);
    $sql = "insert into block ";
    while (list($k, $v) = each($this->form_data)) {
      if ($k == 'id') { continue; }
      $dbfields[] = $k;
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? die ( "Block copy failed -- " . $dbh->ErrorMsg()) : '';
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function validateFormLocal() {
    // Add a check to ensure that the theme name stays unique (db and code);
    $error = '';
    $this->interface_data[error] = $error;
    $this->theme->assign('idata', $this->interface_data);
    if ($error == '') { return 1; } else { return 0; }    
  }
}

$gui = new LocalInterface();
$gui->Initialize();

if (preg_match("/^search/i", $operation)) {
  $gui->search();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  if ($form__operation == 'delete') {
    $gui->doDelete();
  } elseif ($gui->validateForm()){
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'copy') {
      $gui->doCopy();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'copy') {
      $gui->copy;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/i", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/i", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/i", $operation)) {
  $gui->delete();
} elseif (preg_match("/^copy/i", $operation)) {
  $gui->copy();
}
print $gui->display();

?>
