<?php
/*
* Dynamic Forms Manager
*
* @version  0.4.0beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001,2002
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin';    // Plugin Name
include_once("../function.php");

$interface = 'admin.dynaform'; 
$interface_title = 'DarkPortal - Dynamic Forms Manager';
$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* API Interface 
*/
class LocalInterface extends Interface {


/**
* API Interface Constructor
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
*/
	function initializeLocal() {
	}

  function finalizeLocal() {
  }

/**
* Main Zone Callback Method
*/
  function main(&$theme) {
    global $dbh, $config, $userinfo; 
    $theme->assign('idata', $this->interface_data);
    //$addParsedBlock();
  }

  function add() {
  }
  
  function doAdd() {
    global $dbh, $config, $userinfo;
    // When adding, we need not worry about elements.
    list ($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form"));
    $sql = "insert into $dbt ";
    while (list($k, $v) = each($dbc)) {
  		$dbfields[] = $dbc[$k];
			$dbvalues[] = $this->command->db_quote($this->form_data[$k]);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql) or trigger_error("Dynamic Form addition failed -- " . $dbh->ErrorMsg(), FATAL);
    $this->interface_data[error] = $error;
    $this->operation = '';
    $this->Initialize();
  }
  
  function edit() {
  }
  
  function doEdit() {
    global $dbh, $config, $userinfo;
    // Editing the form does not entail any details on elements.
    if ($this->form_data[id] == $this->interface_data[id]) {
      $dbfields = array();
      list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form"));
      $sql = "update $dbt set ";
      while (list($k,$v) = each ($dbc)) {
        $dbfields[] = "$dbc[$k] = " . $this->command->db_quote($this->form_data[$k]);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where $dbc[id] = ". $this->command->db_quote($this->form_data[id]);
      $dbh->Execute($sql) or trigger_error("Dynamic form modification failed -- " . $dbh->ErrorMsg(), FATAL);
      
      // if the name was changed and transpose elements is selected, we need to 
      //  update the elements tables.
      if ($this->form_data[change_elements] == 1) {
        list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form_element"));
        // If name is set and has changed, set
        if (isset($this->form_data[name]) && $this->form_data[name] != $this->interface_data[name]) {
          $name_sql = "$dbc[form_name] = " . $this->command->db_quote($this->form_data[name]) . ", ";
        }
        $name_q = $this->command->db_quote($this->interface_data[name]);
        $sql = "update $dbt set $name_sql $dbc[ord] = $dbc[ord] where $dbc[form_name] = $name_q ";
        $dbh->Execute($sql) or trigger_error("Dynamic form element change failed -- $sql " . $dbh->ErrorMsg(), FATAL);
      }
    } else {
      trigger_error("Form improperly submitted", FATAL);
      return 0;
    }
    $this->operation = "view.dyna_form";
    $this->Initialize();
  }
  
  function delete() {
    $this->interface_data[form_item] = "Dynamic Form";
    $this->interface_data[verify][remove_elements] = "Delete form elements";
  }
  
  function doDelete() {
    global $dbh, $config, $userinfo;
    // It is probably a good idea to delete elements with the form.
    if ($this->form_data[id] == $this->interface_data[id]) {
      $id_q = $this->command->db_quote($this->form_data[id]);
      list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form"));
      $sql = "delete from $dbt where $dbc[id] = $id_q ";
      $dbh->Execute($sql) or trigger_error("Dynamic form removal failed -- " . $dbh->ErrorMsg(), FATAL);

      if ($this->form_data[remove_elements] == 1) {
        list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form_element"));
        $name_q = (isset($this->interface_data[name]) && $this->interface_data[name] != '') ? $this->command->db_quote($this->interface_data[name]) : "'_NONE_'";
        $sql = "delete from $dbt where $dbc[form_name] = $name_q";
        $dbh->Execute($sql) or trigger_error("Dynamic form element purge failed -- " . $dbh->ErrorMsg(), FATAL);
      }
    }
    $this->operation = '';
    $this->Initialize();
  }
  
  function copy () {
    // Copy is not implemented yet
  }
  
  function doCopy() {
    global $dbh, $config, $userinfo;

    list ($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form"));
    $sql = "insert into $dbt ";
    while (list($k, $v) = each($dbc)) {
  		$dbfields[] = $dbc[$k];
			$dbvalues[] = $this->command->db_quote($this->form_data[$k]);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql) or trigger_error("Dynamic Form addition failed -- " . $dbh->ErrorMsg(), FATAL);
    $this->interface_data[error] = $error;
    
    // When copying, remember to move/copy elements.
    if ($this->form_data[remove_elements] == 1) {
      list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form_element"));
      $name_q = (isset($this->interface_data[name]) && $this->interface_data[name] != '') ? $this->command->db_quote($this->interface_data[name]) : "'_NONE_'";
      $sql = <<<END_SQL
select * from $dbt where $dbc[form_name] = $name_q
END_SQL;
      $dbh->Execute($sql) or trigger_error("Dynamic form element purge failed -- " . $dbh->ErrorMsg(), FATAL);
    }
    
    $this->operation = '';
    $this->Initialize();
  }
}

/*
* Interface Initialization
*/
$gui = new LocalInterface();

$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;
$gui->Initialize();

/*-----------------------------------------------------------------------------
* Operation Logic
*/

if (preg_match("/^search/i", $operation)) {
  $gui->search();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'copy') {
      $gui->doCopy();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'copy') {
      $gui->copy;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^copy/", $operation)) {
  $gui->copy();
}

/*-----------------------------------------------------------------------------
* Interface Display
*/
print $gui->display();
$gui->Finalize();

?>
