<?php
/*
* Dynamic Forms Manager
*
* @version  0.4.0beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001,2002
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin';    // Plugin Name
include_once("../function.php");

$interface = 'admin.dynaform_select'; 
$interface_title = 'DarkPortal - Dynamic Forms Select';
$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* API Interface 
*/
class LocalInterface extends Interface {


/**
* API Interface Constructor
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
*/
	function initializeLocal() {
	}

  function finalizeLocal() {
  }

/**
* Main Zone Callback Method
*/
  function main(&$theme) {
    global $dbh, $config, $userinfo; 
    if ($this->search[name] == 'form_field') {
      $this->interface_data[form_field] = $this->search[id];
    }
    $theme->assign('idata', $this->interface_data);
    //$addParsedBlock();
  }

  function add() {
  }
  
  function doAdd() {
    global $dbh, $config, $userinfo;
    list ($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form_select"));
    $sql = "insert into $dbt ";
    while (list($k, $v) = each($dbc)) {
  		$dbfields[] = $dbc[$k];
			$dbvalues[] = $this->command->db_quote($this->form_data[$k]);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql) or trigger_error("Dynamic Form addition failed -- " . $dbh->ErrorMsg(), FATAL);
    $this->interface_data[error] = $error;
    $this->operation = "view.dyna_form_select";
    $this->search[id] = $this->form_data[form_field];
    $this->search[key] = $dbt;
    $this->search[cols] = $dbc;
    $this->search[name] = "form_field";
    unset($this->interface_data);
    $this->Initialize();
  }
  
  function edit() {
  }
  
  function doEdit() {
    global $dbh, $config, $userinfo;
    // Editing the form does not entail any details on elements.
    list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form_select"));
    if ($this->form_data[id] == $this->interface_data[id]) {
      $dbfields = array();
      $sql = "update $dbt set ";
      while (list($k,$v) = each ($dbc)) {
      	if (isset($this->form_data[$k])) {
          $dbfields[] = "$dbc[$k] = " . $this->command->db_quote($this->form_data[$k]);
        }
      }
      $sql .= join(',', $dbfields);
      $sql .= " where $dbc[id] = ". $this->command->db_quote($this->form_data[id]);
      $dbh->Execute($sql) or trigger_error("Dynamic form modification failed -- " . $dbh->ErrorMsg(), FATAL);
    } else {
      trigger_error("Form improperly submitted", FATAL);
      return 0;
    }
    $this->operation = "view.dyna_form_select";
    $this->search[id] = $this->interface_data[form_field];
    $this->search[name] = "form_field";
    $this->search[key] = $dbt;
    unset($this->interface_data);
    $this->Initialize();
  }
  
  function delete() {
    $this->interface_data[form_item] = "Dynamic Form";
  }
  
  function doDelete() {
    global $dbh, $config, $userinfo;
    // It is probably a good idea to delete elements with the form.
    if ($this->form_data[id] == $this->interface_data[id]) {
      $id_q = $this->command->db_quote($this->form_data[id]);
      list($dbt, $dbc) = array_values($this->command->DBGetTable("dyna_form_select"));
      $sql = "delete from $dbt where $dbc[id] = $id_q ";
      $dbh->Execute($sql) or trigger_error("Dynamic form removal failed -- " . $dbh->ErrorMsg(), FATAL);

    }
    $this->operation = "view.dyna_form_select";
    $this->search[id] = $this->interface_data[form_field];
    $this->search[key] = $dbt;
    $this->search[name] = "form_field";
    unset($this->interface_data);
    $this->Initialize();
  }
  
  function copy () {
    // Copy is not implemented yet
  }
  
  function doCopy() {
    global $dbh, $config, $userinfo;
    // When copying, remember to move/copy elements.
  }
}

/*
* Interface Initialization
*/
$gui = new LocalInterface();

$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;
$gui->Initialize();

/*-----------------------------------------------------------------------------
* Operation Logic
*/

if (preg_match("/^search/i", $operation)) {
  $gui->search();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'copy') {
      $gui->doCopy();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'copy') {
      $gui->copy;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^copy/", $operation)) {
  $gui->copy();
}

/*-----------------------------------------------------------------------------
* Interface Display
*/
print $gui->display();
$gui->Finalize();

?>
