<?php
/*------------------------------------------------------------------------------
** 
**------------------------------------------------------------------------------
**------------------------------------------------------------------------------
*/

/*
TODO:
  Add ability to select multiple values and build configuration arrays.
  Add config group administration.
  Add config select administration.
 */

include_once ("../function.php");
$interface = 'admin.sysconfig';
$interface_title = 'DarkPortal Admin - System Configuration';
$interface_cols = array('id', 'name', 'value', 'grp' );
$plugin = 'admin';

include("$include_path/$plugin/function.php");
include("$include_path/$plugin/config.php");

if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset($searchby) ? $operation .=  ".$searchby" : '' ;
isset($form__operation) ? $operation .= ".$form__operation" : '';

/*------------------------------------------------------------------------------
** Interface class definition.
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/

class LocalInterface extends Interface{

  function LocalInterface() {
    $this->themeID = 1;
    $this->Interface();
    $this->flags[transpose] = true;
  }

  function initializeLocal() {
  }

  function main(&$theme) {
    global $dbh;
    global $config;
    global $userinfo;
    
    $this->template =& $theme;
    $interface = $this->interface;

    $theme->assign('idata', $this->interface_data);
  }

  function doAdd() {
    global $dbh;
    unset ($this->form_data[id]);
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $sql = "insert into config ";
    while (list($k, $v) = each($this->form_data)) {
      $dbfields[] = $k;
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error = "Block addition failed ($sql) -- " . $dbh->ErrorMsg() : '';
    $this->interface_data[error] = $error;
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    if (empty ($error) || $error == '') {
      $this->search[key] = 'config';
      $this->search[name] = 'grp';
      isset($this->form_data[grp]) ? $this->search[id] = $this->form_data[grp] : $this->search[id] = 1;
      $this->operation = 'search.config';
    } else {
      $this->operation = 'add.config';
    }
    $this->Initialize();
  }

  function doEdit() {
    global $dbh;
    $dbfields = array();
    $error = '';
    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $sql = "update config set ";
      while (list($k,$v) = each ($this->form_data)) {
        $dbfields[] = "$k = " . $this->command->db_quote($v);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where id = ". $this->command->db_quote($this->form_data[id]);
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Block modification failed -- " . $dbh->ErrorMsg() : '';
    } else {
        $error = "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $theme =& $this->theme;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $theme->assign('idata', $this->interface_data);
  }

  function submit() {
    global $dbh;
    $dbfields = array();
    $error = '';
    while (list($k, $v) = each ($this->form_data)) {
      $sql = "update config set value = " . $this->command->db_quote($v) . " where name = " . $this->command->db_quote($k) ;
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Sysconfig failed -- " . $dbh->ErrorMsg() . "<br>$sql<br>\n" : '';
    }
    $this->interface_data[error] = $error;
    $this->theme->assign('idata', $this->interface_data);
  }

  function build() {
    global $dbh;
    global $config;

    if (isset($this->form_data[plugin]) ) {
      $plugin = $this->form_data[plugin] . '/';
    }

    $sql = 'select name, value, title, description from config where interface = ' . $this->command->db_quote($this->interface) . ' order by grp, ord';
    $result = $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error .= "Sysconfig failed -- " . $dbh->ErrorMsg() . "<br>$sql<br>\n" : '';
    print $sql;
    $out = <<<END_HTML
<?php
/*------------------------------------------------------------------------------
**------------------------------------------------------------------------------
*/
\$config = array(

END_HTML;
    while ($data = $result->fields) {
      $data[description] = wordwrap(strip_tags($data[description]), 76, "\n** ");
      $out .= <<<END_HTML
/* $data[name] - $data[title]
** $data[description]
*/
  	$data[name] => "$data[value]",

END_HTML;
      $result->MoveNext();
    }
    $out .= <<<END_HTML
);

class Config {
  var \$config = array();

  function Config() {
    global \$config;
    \$this->config = \$config;
  }
}
END_HTML;
    if (file_exists("$config[site_path]/{$plugin}config.php")) {
      // Make a backup of the existing config.
      $date = time();
      copy("$config[site_path]/{$plugin}config.php", "$config[site_path]/{$plugin}config.$date.php");
    }
   
    $fh = fopen("$config[site_path]/{$plugin}config.php", 'w');
    fwrite($fh, $out);
  }
}

$gui = new LocalInterface();
$gui->Initialize();
if (preg_match("/^submit/i",$operation)) {
  if ($gui->validateForm()) {
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } else {
      $gui->submit();
    }
  }
} elseif (preg_match("/^search/i", $operation)) {
  $gui->search();
} elseif (preg_match("/^build/i", $operation)) {
  $gui->build();
}

print $gui->display();

?>
