<?php

$plugin = 'admin';
include_once("../function.php");

$interface = 'admin.theme';
$interface_title = 'DarkPortal Admin - Layout/Theme Management';
$interface_cols = array();

if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

class LocalInterface extends Interface {

  function LocalInterface() {
    $this->themeID = 1;
    $this->Interface();
  }

  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;

    $this->template =& $theme;
    $interface = $this->interface;

    if (empty($this->operation)) {
      list ($dbt, $dbc) = array_values($this->command->DBGetTable('theme'));
      $sql = "select $dbc[name], $dbc[description] from $dbt";
      $result = $dbh->Execute($sql) ;
      !$result ? trigger_error($this->command->sqlError("Cannot load theme description.", $sql), FATAL) : '';
      while($this->interface_data[] = $result->fields) {
 	      $result->MoveNext();
      }
    } 
    $theme->assign('idata', $this->interface_data);
  }

  function search() {
    $this->interface_data[content_html] = $this->command->contentParser($this->interface_data[content_html]);
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function copy() {
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function doAdd() {
    global $dbh;
    global $config;

    unset ($this->form_data[id]);
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $this->form_data[content] = preg_replace("/<\[({$this->theme->tconfig[tags]})([^>]*)\]>/", "\{\\1\\2\}", $this->form_data[content]);
    list ($dbt, $dbc) = $this->command->DBGetTable('theme');
    $sql = "insert into $dbt ";
    while (list($k, $v) = each($this->form_data)) {
      $dbfields[] = $dbc[$k];
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme addition failed", $sql), FATAL);

    list($dbt, $dbc) = $this->command->DBTable('theme_config');
    $sql = "select $tid as $dbc[theme], $dbc[name], $dbc[value] from $dbt where $dbc[theme] = $config[site_theme]";
    $result = $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme configuration extract failed.", $sql), FATAL);
      
    while ($data = $result->fields){
        $result->MoveNext();
        $sql = "insert into $dbt ";
        $sql .= "values ('', '$data[theme]', '$data[name]', '$data[value]')";
        $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme configuration copy failed", $sql), FATAL);
      }
      
    list ($dbt, $dbc) = $this->command->DBGetTable('theme_meta');
      $sql = "select $dbc[name], $dbc[value], $tid as $dbc[theme] from $dbt where $dbc[theme] = $config[site_theme]";
      $result = $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme meta data extract failed.", $sql), FATAL);
      
      while ($data = $result->fields){
        $result->MoveNext();
        $sql = "insert into $dbt ";
        $sql .= "values ('', '$data[theme]', '$data[name]', '$data[value]')";
        $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme meta data copy failed", $sql), FATAL);
      }

    if (!$error && @mkdir("$config[site_path]/themes/{$this->form_data[name]}",0777)) {
      if ($dir = opendir("$config[site_path]/themes/default")) {
        while($file = readdir ($dir)) {
          if (is_dir($file) ||
              $file == '.' ||
              $file == '..' )
	    continue;
          copy("$config[site_path]/themes/default/$file",
               "$config[site_path]/themes/{$this->form_data[name]}/$file");
        }
      }
    } else {
      $error .= "Could not create theme directory";
    }
    $this->interface_data[error] = $error;
  }

  function doEdit() {
    global $dbh;
    $dbfields = array();
    $error = '';
    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $this->form_data[content] = preg_replace("/<\[({$this->theme->tconfig[tags]})([^>]*)\]>/", "\{\\1\\2\}", $this->form_data[content]);
      list($dbt, $dbc) = $this->command->DBGetTable('theme');
      $sql = "update $dbt set ";
      while (list($k,$v) = each ($this->form_data)) {
        $dbfields[] = "$dbc[$k] = " . $this->command->db_quote($v);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where $dbc[id] = ". $this->command->db_quote($this->form_data[id]);
      $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme modification failed", $sql), FATAL);
    } else {
      trigger_error("Form improperly submitted.", FATAL);
    }
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }

  function doDelete() {
    global $dbh;
    global $config;

    $error = '';
    // First, we simply delete the theme entry itself.
    if(isset($this->interface_data[id]) && $this->interface_data[id] != $config[base_theme]) { // Valid delete ID lookup
      list($dbt, $dbc) = $this->command->DBGetTable('theme');
      $sql = "delete from $dbt where $dbc[id] = {$this->interface_data[id]}";
      $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme removal failed", $sql), FATAL);
      
      list($dbt, $dbc) = $this->command->DBGetTable('theme_config');
      $sql = "delete from $dbt where $dbc[theme] = {$this->interface_data[id]}";
      $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme configuration removal failed", $sql), FATAL);
      
      list($dbt, $dbc) = $this->command->DBGetTable('theme_meta');
      $sql = "delete from $dbt where $dbc[theme] = {$this->interface_data[id]}";
      $dbh->Execute($sql) or trigger_error( $this->command->sqlError("Theme meta data removal failed", $sql), FATAL);
    } elseif($this->interface_data[id] == $config[base_theme]) {
      trigger_error( "Base theme cannot be removed without first setting a new base.", FATAL);
      return;
    } else {
      trigger_error( "Invalid theme id selected.", FATAL);
      return;
    }
    // Next, we update all users who have selected this theme and update 
    // their preferences to use the default.
    list($dbt, $dbc) = $this->command->DBGetTable('user_preference');
    $old_tid_q = $this->command->db_quote($this->interface_data[id]);
    $new_tid_q = $this->command->db_quote($config[site_theme]);
    $sql = "update $dbt set $dbc[value] = $new_tid_q where $dbc[name] = 'theme' and $dbc[value] = $old_tid_q";
    $dbh->Execute($sql) or trigger_error( $this->command->sqlError("User theme preference update failed.", $sql), FATAL);
    
    // Check if we are deleting everything
    if (isset($this->form_data[delete_all]) && $this->form_data[delete_all] == 1){
      list($dbt, $dbc) = $this->command->DBGetTable('zone');
      $sql = "delete from $dbt where $dbc[theme] = {$this->interface_data[id]}";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Theme removal of zones failed -- " . $dbh->ErrorMsg() : '';

      $sql = "delete from block where theme = {$this->interface_data[id]}";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Theme removal of blocks failed -- " . $dbh->ErrorMsg() : '';

      // When removing all, we must also remove the theme directory and contents.
      if ($dir = @opendir("$config[site_path]/themes/{$this->interface_data[name]}")) {
        while($file = readdir ($dir)) {
          if (is_dir($file) || $file == '.' || $file == '..' )
            continue;
          unlink("$config[site_path]/themes/{$this->interface_data[name]}/$file");
        }
        rmdir("$config[site_path]/themes/{$this->interface_data[name]}");
      }
    }
    
    if ($error = '') { $this->interface_data = array(); }
    $this->interface_data[error] = $error;
  }

  function doCopy() {
    global $dbh;
    global $config;

    $error = '';
    if(isset($this->interface_data[id])) { // Valid lookup ID
      list($dbt, $dbc) = $this->command->DBGetTable('theme');
      $sql = "insert into $dbt ";
      $sql .= " ($dbc[id], $dbc[name], $dbc[description], $dbc[content]) ";
      $sql .= " values (null, " . $this->command->db_quote($this->form_data[name]) . ", ".$this->command->db_quote($this->form_data[theme_desc]).", " . $this->command->db_quote($this->interface_data[content]) . ")";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Theme copy failed when inserting new theme -- " . $dbh->ErrorMsg() : '';

      $sql = "select $dbc[id] from $dbt where $dbc[name] = " . $this->command->db_quote($this->form_data[name]);
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Theme copy failed. Could not find newly inserted theme -- " . $dbh->ErrorMsg() : '';
      list ($tid) = $result->fields;
      
      list($dbt, $dbc) = $this->command->DBGetTable('zone');
      $sql = "insert into " . $dbt . "bak ";
      $sql .= "select $dbc[id], $dbc[theme], $dbc[name], $dbc[content], $dbc[blockdef], $dbc[active] from $dbt where $dbc[theme] = " . $this->command->db_quote($this->interface_data[id]);
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Theme copy failed while backing up zone -- " . $dbh->ErrorMsg() : '';
      
      $sql = "insert into $dbt ";
      $sql .= "select '', $dbc[theme], $dbc[name], $dbc[content], $dbc[blockdef], $dbc[active] from " . $dbt . "bak where $dbc[theme] = " . $this->command->db_quote($tid);
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Theme copy failed while copying backup zone -- " . $dbh->ErrorMsg() : '';
  
      list($dbt, $dbc) = $this->command->DBGetTable('theme_config');
      $sql = "select $tid as $dbc[theme], $dbc[name], $dbc[value] from $dbt where $dbc[theme] = " . $this->command->db_quote($this->interface_data[id]);
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Theme copy failed while extracting theme config -- " . $dbh->ErrorMsg() : '';
      
      while ($data = $result->fields){
        $result->MoveNext();
        $sql = "insert into $dbt ";
        $sql .= "values ('', " . $this->command->db_quote($data[theme]) . ', ' .
                $this->command->db_quote($data[name]) . ', ' .
                $this->command->db_quote($data[value]) . ')';
        $dbh->Execute($sql);
        $dbh->ErrorMsg() ? $error .= "Theme copy failed while creating config -- " . $dbh->ErrorMsg() : '';
      }
      
      list($dbt, $dbc) = $this->command->DBGetTable('theme_meta');
      $sql = "select $dbc[name], $dbc[value], $tid as $dbc[theme] from $dbt where $dbc[theme] = " . $this->command->db_quote($this->interface_data[id]);
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Theme copy failed extracting meta data -- " . $dbh->ErrorMsg() : '';
      
      while ($data = $result->fields){
        $result->MoveNext();
        $sql = "insert into $dbt ";
        $sql .= "values ('', " . $this->command->db_quote($data[theme]) .
                ', ' . $this->command->db_quote($data[name]) .
                ', ' . $this->command->db_quote($data[value]) .')';
        $dbh->Execute($sql);
        $dbh->ErrorMsg() ? $error .= "Theme copy failed while creating meta data -- " . $dbh->ErrorMsg() : '';
      }

      list($dbt, $dbc) = $this->command->DBGetTable('zone');
      $sql = "delete from " . $dbt . "bak where $dbc[theme] = " . $this->command->db_quote($tid);            
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Theme copy failed while deleting zone backup -- " . $dbh->ErrorMsg() : '';
      if (!$error && mkdir("$config[site_path]/themes/{$this->form_data[name]}", 0777)) {
          if ($dir = opendir("$config[site_path]/themes/{$this->interface_data[name]}")) {
            while($file = readdir ($dir)) {
              if (is_dir($file) || $file == '.' || $file == '..' )
	         continue;
              copy("$config[site_path]/themes/{$this->interface_data[name]}/$file",
                   "$config[site_path]/themes/{$this->form_data[name]}/$file");
            }
          }
        } else { 
	  $error .= "Could not create theme directory.";
	}

      if ($error != '') {
        $sql = "delete from theme where id = $tid";            
        $result = $dbh->Execute($sql);
        $sql = "delete from theme_config where theme = $tid";            
        $result = $dbh->Execute($sql);
        $sql = "delete from theme_meta where theme = $tid";            
        $result = $dbh->Execute($sql);
        $sql = "delete from zone where theme = $tid";            
        $result = $dbh->Execute($sql);
        $sql = "delete from zonebak where 1 = 1";            
        $result = $dbh->Execute($sql);
      }
    } else {
      $error = "Invalid theme id selected.";
    }      
    $this->interface_data[error] = $error;
    $theme =& $this->theme;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $theme->assign('idata', $this->interface_data);
  }

  function validateFormLocal() {
    // Add a check to ensure that the theme name stays unique (db and code);
    $error = '';
    if (isset($this->form_data[id]) && $this->form_data[id] != '') {
      $testint = (int) $this->form_data[id];
      if (!$testint){
      	$error .= 'Theme ID number is not an integer value.<br>';
      } 
    }
    if (isset($this->form_data[name]) && $this->form_data[name] != '') {
      $invalid_chars = "'\"\{\}\(\)\[;:<>.,/\\?+=~`!@#\$%^&*";
      if (preg_match_all("/([^a-zA-Z0-9_-])/", $this->form_data[name], $matches)) {
      	$badchars = join(",", $matches[1]);
      	$error .= "Theme name contains invalid characters (<tt>$badchars</tt>).<br>";
      }
    } else {
      $error .= 'A name for the template is required.<br>';
    }
    $this->interface_data[error] = $error;
    if ($error == '') { return 1; } else { return 0; }    
  }
}

$gui = new LocalInterface();
$gui->Initialize();

if (eregi("^search", $operation)) {
  $gui->search();
} elseif (eregi("^submit", $operation)) {
  if ($form__operation == 'delete') {
    $gui->doDelete();
  } elseif ($gui->validateForm()){
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'copy') {
      $gui->doCopy();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'copy') {
      $gui->copy;
    } else {
      $gui->unknownError();
    }
  }
} elseif (eregi("^add", $operation)) {
  $gui->add();
} elseif (eregi("^edit", $operation)) {
  $gui->edit();
} elseif (eregi("^delete", $operation)) {
  $gui->delete();
} elseif (eregi("^copy", $operation)) {
  $gui->copy();
}
print $gui->display();

?>
