<?php

include_once("../function.php");
$interface = 'admin.zone';
$interface_title = 'DarkPortal Admin - Layout/Zone Management';
$interface_cols = array('id', 'theme', 'name', 'content', 'active');
$plugin = 'admin';

include("$include_path/$plugin/function.php");
include("$include_path/$plugin/config.php");

if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

class LocalInterface extends Interface {

  function LocalInterface() {
    $this->themeID = 1;
    $this->Interface();
    $this->permission = 1;
  }

  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;

    $this->template =& $theme;
    $interface = $this->interface;

    $theme->assign('idata', $this->interface_data);
  }

  function add() {
    //TODO: Remove this, and add the test for the search stuff into the element.
    if ($this->search[key] == 'theme') {
      $this->interface_data[theme] = $this->search[id];
      $this->interface_data[theme_name] = $this->search[name];
    } elseif ($this->search[key] == 'zone') {
      $this->interface_data[zone] = $this->search[id];
      $this->interface_data[zone_name] = $this->search[name];
    } elseif ($this->search[key] == 'group') {
      $this->interface_data[grp] = $this->search[id];
      $this->interface_data[grp_name] = $this->search[name];
    }
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function copy() {
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function doAdd() {
    global $dbh;
    unset ($this->form_data[id]);
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $this->form_data[content] = preg_replace("/<\[({$this->theme->tconfig[tags]})([^>]*)\]>/", "\{\\1\\2\}", $this->form_data[content]);
    unset($this->form_data[blockdef]);
    $sql = "insert into zone ";
    while (list($k, $v) = each($this->form_data)) {
      $dbfields[] = $k;
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? die ( "Zone addition failed -- " . $dbh->ErrorMsg()) : '';
    $this->interface_data[error] = $error;
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function doEdit() {
    global $dbh;
    $dbfields = array();
    $error = '';
    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $this->form_data[content] = preg_replace("/<\[({$this->theme->tconfig[tags]})([^>]*)\]>/", "\{\\1\\2\}", $this->form_data[content]);
      unset($this->form_data[blockdef]);
      $sql = "update zone set ";
      while (list($k,$v) = each ($this->form_data)) {
        $dbfields[] = "$k = " . $this->command->db_quote($v);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where id = ". $this->command->db_quote($this->form_data[id]);
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Zone modification failed -- " . $dbh->ErrorMsg() : '';
    } else {
        $error = "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }

  function doDelete() {
    global $dbh;
    $error = '';
    if(isset($this->interface_data[id]) ) { // Valid delete ID lookup
      $sql = "delete from zone where id = {$this->interface_data[id]}";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error = "Zone delete failed -- " . $dbh->ErrorMsg() : '';
    } else {
      $error = "Invalid zone id selected.";
    }
    if ($error = '') { $this->interface_data = array(); }
    $this->interface_data[error] = $error;
  }

  function doCopy() {
    global $dbh;
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';
    $this->form_data[content] = $this->interface_data[content];
    unset($this->form_data[blockdef]);
    $sql = "insert into zone ";
    while (list($k, $v) = each($this->form_data)) {
      if ($k == 'id') { continue; }
      $dbfields[] = $k;
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? die ( "Zone copy failed -- " . $dbh->ErrorMsg()) : '';
    $this->interface_data[error] = $error;
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }

  function validateFormLocal () {
    // Add a check to ensure that the theme name stays unique (db and code);
    $error = '';
    if (isset($this->form_data[id]) && $this->form_data[id] != '') {
      $testint = (int) $this->form_data[id];
      if (!$testint){
      	$error .= 'Theme ID number is not an integer value.<br>';
      } 
    }
    $this->interface_data[error] = $error;
    if ($error == '') { return 1; } else { return 0; }    
  }
}

$gui = new LocalInterface();
$gui->Initialize();

if (eregi("^search", $operation)) {
  $gui->search();
} elseif (eregi("^submit", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  if ($form__operation == 'delete') {
    $gui->doDelete();
  } elseif ($gui->validateForm()){
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'copy') {
      $gui->doCopy();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'copy') {
      $gui->copy;
    } else {
      $gui->unknownError();
    }
  }
} elseif (eregi("^add", $operation)) {
  $gui->add();
} elseif (eregi("^edit", $operation)) {
  $gui->edit();
} elseif (eregi("^delete", $operation)) {
  $gui->delete();
} elseif (eregi("^copy", $operation)) {
  $gui->copy();
}
print $gui->display();
?>
