<?php
/**
* login.php - Portal Login Interface
*/
include_once("function.php"); 
$interface = 'login';
$interface_title = 'DarkPortal - Login';
$interface_cols = array('id', 'username', 'password', 'name', 'last_ip', 'login_count', 'login_date', 'email', 'alias', 'fakeemail');
$plugin = 'user';

include("$include_path/plugins/$plugin/function.php");
include("$include_path/plugins/$plugin/config.php");

isset ($searchby) ? $operation .= ".$searchby" : '';
//if (isset($form__operation) && preg_match("/^login/i", $form__operation)) { $operation .= ".$form__operation"; } 

/**
* Portal Login Interface
*
* Users of the portal may login and access their personal preferences and
* stored information. Login creates a user session object which is kept
* persistent in the database and keyed to a session ID cookie in the browser. 
*
* @version  0.1alpha
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package plugins.user.login
*/

class LocalInterface extends Interface {

/**
* Local Interface Constructor
*
* The local interface contructor should usually only call the super class
* constructor. In some cases, it may be useful to add some parameters such
* as static theme ID (admin interfaces) and so forth.
*
* @return void
*/
  function LocalInterface() {
    $this->Interface();
  }

  
/**
* Login Validation Method
*
* The login validation extracts the login information from the submitted form,
* and creates a SQL query against the database to lookup the user based on
* an encrypted password value. If the crypted passwords and usernames match, 
* an ID for the user will be returned. This validates the login and allows 
* the method to load the user authentication groups and update the user login
* statistics. If the attempt is unsuccessful, an error is generated and the
* login screen is displayed with the error.
* 
* @return void;
*/
  function login() {
    global $dbh;
    global $userinfo;
    global $HTTP_SERVER_VARS;
    
    $user_q = $this->command->db_quote($this->form_data[username]);
    $pass_q = $this->command->db_quote($this->form_data[password]);
    $sql = <<<END_SQL
      select id from users 
      where username = $user_q
      and password = password($pass_q)
END_SQL;
    $result = $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error = "Authentication failed -- " . $dbh->ErrorMsg() : '';

    if($result && $result->fields[id] != '' &&
       ($this->interface_data[id] == $result->fields[id])) {
      $userinfo = $this->interface_data;

      $sql = "select g.id, g.name from groups g, user_groups ug where ug.gid = g.id and ug.uid = $userinfo[id]";
      $result = $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $this->interface_data[error] .= "Authentication failed -- Could not load group data for user." : '';
      while(list($id, $name) = $result->fields) {
      	$userinfo[groups]['default'] = 0;
      	$userinfo[groups][$name] = $id;
      	$result->MoveNext();
      }
      $this->command->loadUserPrefs();
      session_register("userinfo") or die("Could not register session info");
      $userinfo[ip_address] = $HTTP_SERVER_VARS[REMOTE_ADDR];
      $sql = <<<END_SQL
      update users set
      login_date = now(),
      login_count = login_count + 1,
      last_ip = '$userinfo[ip_address]'
      where id = $userinfo[id]
END_SQL;
      $dbh->Execute($sql);
    } else {
      session_destroy();
      $userinfo = array();
      $userinfo[id] = -1;
      global $operation;
      $this->interface_data[error] .= "Invalid Username or Password";
      $this->operation = '';
    }
    $this->theme = $this->resetTheme();
    $this->theme->assign('idata', $this->interface_data);
  }

/** 
* Portal Logout Method
* 
* When a user chooses the option to logout of the portal, the system destroys
* the database session information and clears the session ID cookie from the
* user's browser.
*
* @return void
*/
  function logout() {
    session_destroy();
    global $userinfo;
    $userinfo = array();
    $userinfo[id] = 0;
    $this->operation = '';
    $this->theme = $this->resetTheme();
  }
}

$gui = new LocalInterface();
$searchid = $form_username;
$searchby = "users";
$searchname = "username";

$gui->Initialize();
if (preg_match("/^submit/i", $operation)) {
  $gui->login($username, $password);
} elseif (preg_match("/^logout/i", $operation)) {
  $gui->logout();
}

print $gui->display();

?>
