<?php
/* Nonsense -- Generates mt_random text from recursive datafiles.
**
** See the README for full details.
**
** Author: Fred Hirsch
**         From Original PERL by James Baughn
**
** Version: 0.1PHP (August 2001)
** License: GNU General Public License 2.0
**
** USAGE
**  Ideally, this script should only be called from a dedicated UI.
*/

$pool = array();         // Where the datafiles are slurped into
$static = array();       // Hash of persistent data (to maintain state)

$ignoreparameters = 0;   // Set this to 1 if you want Nonsense to ignore
                         // command-line or CGI parameters (for security
                         // reasons).  The program will use the hard-coded
                         // defaults below.  See the README first!
$evalokay = 1;           // By default, allow direct eval

mt_srand ((float) microtime() * 1000000);
header('Content-type: text/html');   
header('Pragma: no-cache');
empty($cmd) ? $cmd = 'Default' : '';
empty($iters) ? $iters = 1 : '';
empty($DEBUG) ? $DEBUG = 0 : '';
$datafiles = array_merge($datafiles, array('default.data'));
isset($allfiles) ? $datafiles = GlobCurrentDirectory() : '';
if (isset($theme) && $theme != '') {
  LoadTemplate($theme);
} else {
  $theme = '{' . ucfirst( $cmd ) . '}';
  $header = "<HTML><HEAD><TITLE>Nonsense</TITLE>";
  $header .= "<link rel=stylesheet href=\"nonsense.css\" type=text/css>\n";
  $header .= "</HEAD><BODY>\n";
  $footer = "</BODY></HTML>\n";
}

if (isset($spacer) && $spacer != "") {
  if( $spacer == 'P' || $spacer == 'p' ) {
    $spacer = "\n<P>\n";
  } elseif( preg_match("/^nl*$/i", $spacer)) {
    $spacer = "\n";
  } elseif( preg_match("/^br*$/i", $spacer)) { 
    $spacer = "<BR>\n";
  } 
} else {  // Literal
    $spacer = "<BR>\n";
}
if (isset($layout) && $layout != "") {
  if( preg_match("/^o/i", $layout)) { 
    $header .= "<OL>\n"; $footer = "</OL>\n$footer"; $bullet = "<LI>";
  } elseif( preg_match("/^[ul]/i", $layout )) { 
    $header .= "<UL>\n"; $footer = "</UL>\n$footer"; $bullet = "<LI>";
  }
}

// Check if there was any meta-data specified in the template file
if( $theme_meta != '' ) { 
   if( preg_match("/prereq\w*:\s*(.*)\n/i", $theme_meta, $match )) { 
      $newfiles = preg_split ("/\s*[,;]\s*/", $match[1]);
      $datafiles = array_merge( $datafiles, $newfiles );   // Add new prerequisite datafiles
   }
}                                       

while ( list(,$datafile) = each( $datafiles )) {
  LoadDataFile( $datafile );
}

print $header;

for( $i = 0; $i < $iters; $i++ ) { 
   $workcopy = $theme;
   $workcopy = preg_replace ("/{([^}]+)}/e", "Pick('$1')", $workcopy);  // The meat of the program
   print "${bullet}${workcopy}${spacer}";
}

print $footer;
exit;  // Done!

//////////// SUBROUTINES 

// Recursively process a command
function Pick($key) { 
  global $pool;
  global $static;

   // Number range
   if( preg_match("/^#(\d+)-(\d+)$/", $key, $match) ) {
      $pick = floor( mt_rand( 0, $match[2] - $match[1] ) + $match[1] );
      //print "$key#$match[1]#$match[2]#".($match[2] - $match[1])."#$pick##<BR>\n"; exit;
   // Current time (fed through strftime)
   } elseif( preg_match("/^\@([^|]+)$/", $key, $match) ) {
      $pick = strftime( $match[1], time() );
   // Time maintained by a state variable (and decreased by a mt_random value)
   } elseif( preg_match("/^\@(.*?)\|\$(\w+)\|(\d+)$/", $key, $match) ) {
      $usekey = strtoupper($match[2]); 
      $s = $match[1]; 
      $elapse = int( mt_rand( $match[3] ) );
      if( isset($static[$usekey]) ) { 
         $t = $static[$usekey] - $elapse;
      } else {
         $t = time - $elapse;
      }
      $pick = strftime( $s, $t );
      $static[$usekey] = $t;
      
   // Current time minus a mt_random value
   } elseif( preg_match("/^\@(.*?)\|(\d+)\|(\d+)$/", $key, $match) ) {
      $rmax = $match[3] - $match[2];
      $pick = 0;
      if ($rmax > 0) {
        $pick = floor( mt_rand(0,  $rmax ) + $match[3] );
      }
      $pick = strftime( $match[1], time() - $pick );
   // Direct eval (literal Perl code) -- Dangerous!
   } elseif( preg_match("/^;(.*)$/ ", $key, $match) ) {
      if( $evalokay ) { 
         $pick = eval( $match[1] );
      } else { 
         $pick = '';
      }
  
   // Literal list
   } elseif( preg_match("/^\[(.*)$/ ", $key, $match) ) {
      $temp = preg_split ("/\|/", $match[1]);
      if(sizeof ($temp) > 1) {              # More than one element
         $pick = $temp[ mt_rand (0, sizeof($temp)) ];
      } else {                            # ...Or single element
         $pick = floor(mt_rand(0,2)) ? array_shift($temp) : "";  # Pick it or pick nothing
      }

   // Embedded character
  } elseif( preg_match('/^\\\(.*)$/', $key, $match)) {
      $pick = EmbeddedCharacter( $match[1] );

   // Assignment (state variable:=command)
   } elseif( preg_match("/^(.*?):=(.*)$/", $key, $match) ) {
      $usekey = strtoupper( $match[1]); 
      $key = $match[2];
      $static[$usekey] = Pick($key); 
      $pick = '';
      
   // Literal assignment (state variable=literal string)
   } elseif( preg_match("/^(.*?)=(.*)$/", $key, $match) ) {
      $key = $match[2];
      $static[strtoupper($match[1])] = $key; 
      $pick = '';   

   // Retrieve a state variable
   } elseif( preg_match("/^[\$<](.*)$/", $key, $match) ) {
      $case = $match[1];
      $usekey = strtoupper($case);
      $usekey = preg_replace ("/\W/", '', $usekey);          # Strip special characters
      if( empty($static[$usekey]) ) { 
         $pick = Pick($usekey);    # Variable isn't defined
      } else {             
         $pick = $static[$usekey];
      }
      
   // Pick something from the pool a mt_random number of times [NEW]
   } elseif (preg_match("/^(.*?)#(\d+)-(\d+)$/", $key, $match) ) { 
      $usekey = $match[1]; 
      $pick = '';
      $num = floor( mt_rand( 0, $match[3] - $match[2] ) + $match[2] );
      for($i = 0; $i < $num; $i++ ) { 
         $pick .= Pick($usekey);
      }
      $case = $usekey;

   // Pick something from the pool (not a special case)
   } else {
      $usekey = strtoupper($key);
      $usekey = preg_replace("/\W/", '', $usekey);
      if( empty($pool[$usekey]) ) { 
         //print "$usekey not found\n";
         $pick = '';
      } else {
        $rmax = sizeof( $pool[ $usekey ] ) - 1;
        $rnum = 0;
        if ($rmax > 0 ) { 
          $rnum = floor (mt_rand (0, $rmax)); 
        } 
        $pick = $pool[$usekey][$rnum];
        $case = $key;
      }
   }

   // Print debugging info if necessary 
   if( $DEBUG == 1 ) { 
      if( $output_mode != 'text' ) {
         print "<!--$key-->";      # Output it as an unobtrusive HTML comment
      } else {
         print "[$key]";
      }
   } elseif( $DEBUG == 2 ) { 
      if( $output_mode != 'text' ) { 
         print "<!--$key=$pick-->\n";
      } else {
         print "[$key=$pick]\n";
      }
   }

   // Recursively process it
   $pick = preg_replace( "/{([^}]+)}/e", "Pick('$1')", $pick);
   
   // Handle lowercase/uppercase conversions
   if( empty($case) ) {                # No need to worry about case
      return $pick;
   } elseif( preg_match("/^[A-Z0-9]+$/", $case )) {   # UPPERCASE
      return strtoupper($pick);
    } elseif( preg_match("/^[a-z0-9]+$/", $case )) {   # UPPERCASE
     return strtolower($pick);
   } elseif( preg_match("/^\^/", $case) ) {           # begins with '^' -- Ucfirst
      return ucfirst ($pick);
   } else {                              # Mixed Case -- don't touch case
      return $pick;
   }
}


// Return a literal character
function EmbeddedCharacter($in) { 
   if( $in == 'n' ) {              # Newline
      return "\n";
   } elseif( $in == '0' ) {         # Null
      return '';
   } elseif( $in == 'L' ) {         # Left brace
      return '{';
   } elseif( $in == 'R' ) {         # Right brace
      return '}';
   } elseif( preg_match ("/^\d+/" , $in )) {      # ASCII code in decimal
      return chr( $in );
   }
   return '';                      # Character not in list   
}

// Load and parse a datafile, slurping the contents into the %pool hash
function LoadDataFile ($file) { 
  global $pool;
  
  $file = SafeFile($file); 
  $IN = fopen ($file, 'r'); 
  if (!$IN) { die ("Error opening $file... \n"); }   
  $data = fread($IN, filesize ($file));
  $grps = split("\n\n", $data) ;
  while (list(,$grp) = each($grps)) {
    $temp = split ("\n", $grp);
    $key = array_shift($temp);
    $pool[$key] = $temp;
  }
  fclose ($IN);
}
// Slurp a template file into core
function LoadTemplate($file) {
  global $theme;
  global $theme_meta;
  $theme_meta = '';

  $IN = fopen ($file, 'r'); 
  if (!$IN) { die ("Error opening $file... \n"); }   

  $theme = fread($IN, filesize($file)); 
  fclose ($IN);
  if( preg_match("/__BEGIN__/", $theme, $match)) {     # Check for a header
      list($theme_meta, $theme) = preg_split ("/__BEGIN__\s/", $theme, 2);
   }
}

// Remove special characters from a filename to prevent maliciousness
function SafeFile($file) {
   $newfile = preg_replace("/([^\w.-])/", '', $file);  # Ignore special characters except dots and hyphens
   if ($newfile != $file) 
    die("[" . date("F j, Y, g:i a") . "] [warning] [client " . getenv(REMOTE_ADDR) . "] Attempt to override filename safety feature!");
   return $newfile;
}

// Return all of the datafiles in the current directory
function GlobCurrentDirectory() {
  $datafiles = array();
  $DIR = opendir(".");
  while ($file = readdir($DIR) ) {
    if (preg_match("/\.data$/", $file ))
      $datafiles[] = $file;
  }
  closedir($DIR);
  return $datafiles;
}
?>