<?php
/*
* Article Comments Interface
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'article';    // Plugin Name
include_once("../../function.php");

$interface = 'comment'; 
$interface_title = 'DarkPortal - Comment Submission';

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
if (empty ($userinfo[groups][User])) {
  $reason = "Comments can only be posted by registered users.";
  include("$include_path/noaccess.php");
  exit;
}
isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Local Interface 
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
	function initializeLocal() {
	}

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;

    $this->template =& $theme;
    $interface = $this->interface;
    $theme->assign('idata', $this->interface_data);
  }

  function edit() {
  }
  
  function add() {
		global $dbh;
		
		if ($this->form_data[parent_id] > 0) {
			$sql = "select subject, content from article_comment where id = {$this->form_data[parent_id]}";
		} else {
			$sql = "select title as subject from article_comment where id = {$this->form_data[article_id]}";
	  }
		$result = $dbh->Execute($sql);
		
		$this->interface_data[parent] = $this->form_data[parent_id];
		$this->interface_data[aid] = $this->form_data[article_id];
		if ($this->form_data[parent_id] != 0) {
		    $this->interface_data[subject] = "Re: " . $result->fields[subject];
		}
		$this->interface_data[content] = $this->command->parseReplyContent($result->fields[content]);
		
    $this->theme->assign('idata', $this->interface_data);
  }
  
  function delete() {
  }
  
  function doEdit() {
  }
  
  function doAdd() {
  	global $dbh, $config;
  	global $userinfo;

		unset ($this->form_data[id]);
		unset ($this->form_data[name]);
    $this->form_data[uid] = $userinfo[id];
    $this->form_data[create_date] = $this->command->formatUNIXTimestamp();
    $this->form_data[rating] = 0;
		$error = '';

    list ($dbt, $dbc) = array_values($this->command->DBGetTable("article_comment"));
		
		$sql = "insert into $dbt ";
		while (list($k, $v) = each($dbc)) {
			$dbfields[] = $dbc[$k];
			$dbvalues[] = $this->command->db_quote($this->form_data[$k]);
		}

		$sql .= '(' . join(',', $dbfields) . ') ';
		$sql .= 'values(' . join(',', $dbvalues) . ')';
		$dbh->Execute($sql) or trigger_error ("Comment addition failed -- " . $dbh->ErrorMsg(), FATAL);
    header("Location: $config[site_url]/$config[plugin_path]/search.php?operation=search&searchby=article&searchid={$this->form_data[aid]}");
  }
  
  function doDelete() {
  }
  
}

/*
* Interface Initialization
*    The interface class itself is now initialized, the operation variable 
*    used here is always included from the user interface GET or POST request.
*    The Interface constructor creates the global interface variable which 
*    makes it available to the other classes which are initialized by the
*    Initialize method. We cannot initialize in the constructor, as the object
*    is not actually instantiated yet.
*/
$gui = new LocalInterface();
$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;
$gui->Initialize();

/*-----------------------------------------------------------------------------
* Operation Logic
*/

if (preg_match("/^search/i", $operation)) {
  $gui->search();
} elseif (preg_match("/^submit/i", $operation)) {
  // It is typical to set the form data into the interface class if the operation
  // is a submission of information. Form data fields typically take on the form
  // of form_<dataitem>. This transposition may be modified in future releases.
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  // If an operation does not require input validation, it is placed first.
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    // Once the form data is placed, it can be validated. 
    // The validation is interface dependent.
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
}

/*-----------------------------------------------------------------------------
* Interface Display
*    Once the operations (if any) are complete, the display method is called.
*    this enacts the object's theme to display its appropriate blocks.
*/
print $gui->display();

?>
