<?php
/*-----------------------------------------------------------------------------
** index.php (articles) - Primary article display interface.
**
** DESCRIPTION
** AUTHOR
**    Fred Hirsch
** COPYRIGHT
**    (C) 2001 Dark Hart Design
**    GNU Public License (see LICENSE file for details)
**-----------------------------------------------------------------------------
*/
/*-----------------------------------------------------------------------------
** Initializing the Interface classes
**    The first step in initialization is to load the core system function and
**    setup file. The "mainfile" loads all the configuration parameters, session
**    handler and database loader for the various sub-elements. Unlike other 
**    paths in the system, the mainfile include must be relative to the location
**    where the current script is running. From the mainfile, the core include
**    path is setup for all the secondary includes.
*/
$plugin = 'article';
include_once("../../function.php");

/*     The next variables set the interface name and the plugin name of the 
**     current script. The interface name describes shared functionality within
**     a specific plugin, while the plugin name is used to determine the 
**     location of helper scripts to the interfaces.
*/
$interface = 'article.search';
$interface_title = 'DarkPortal - Articles';
//$interface_cols = array('id', 'aid', 'time', 'title', 'text_intro', 'text_body', 'topic', 'informant', 'notes' );

/*-----------------------------------------------------------------------------
** Authentication Handling
**    In the case that a specific interface should limit access to its functions,
**    the following code sample can be used to limit access and provide the user
**    with a reason for the denial. This sample could be expanded to force the
**    user to be a member of specific group(s) or use a plugin config variable
**    to turn on group level authentication.
*/
/*if ($config[$plugin][authorize] == 1 && 
    $userinfo[groups][User] != 1) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}*/

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
** >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/*-----------------------------------------------------------------------------
** CLASS: LocalInterface
**-----------------------------------------------------------------------------
*/
class LocalInterface extends Interface {
  /*-----------------------------------------------------------------------------
  ** METHOD: void Interface()
  **-----------------------------------------------------------------------------
  */
  function LocalInterface() {
    $this->Interface();
  }

	function initializeLocal() {
		global $dbh, $config;
		
		if (isset($this->interface_data[id]) && $this->interface_data[id] != '') {
		  list($dbt, $dbc) = array_values($this->command->DBGetTable("article"));
		  $sql_update = "UPDATE $dbt SET $dbc[counter] = $dbc[counter] + 1 where $dbc[id]= {$this->interface_data[id]}";
      $dbh->Execute($sql_update) or trigger_error("Cannot update $dbt " . $dbh->ErrorMsg(), FATAL);

		  $this->interface_data[timet] = $this->command->formatDBTimestamp($this->interface_data[time]);
      if(isset($this->interface_data[text_body]) && $this->interface_data[text_body] != "") { 
        $this->interface_data[main_text] = "{$this->interface_data[text_intro]}<br><div class=mainblocknote>{$this->interface_data[notes]}</div><br><br>{$this->interface_data[text_body]}"; 
      } else { 
        $this->interface_data[main_text] = "{$this->interface_data[text_intro]}<br><div class=mainblocknote>{$this->interface_data[notes]}</div>"; 
      }
    }
		$this->topic_data = $this->command->getTopics($this->interface_data[id]);
    $this->theme->assign('tdata', $this->topic_data);
    $this->theme->assign('idata', $this->interface_data);
	}
	
  /*-----------------------------------------------------------------------------
  ** METHOD: void main(reference template)
  **-----------------------------------------------------------------------------
  */
  function main(&$theme) {
  }

  function rightblock(&$theme) {
    global $dbh;

    $sql = "select name, url from article_topic_related where topic = '{$this->topic_data[id]}'";
    $result=$dbh->Execute($sql);
    !$result ? trigger_error("SQL: $sql -- " . $dbh->ErrorMsg()) : '';
    
    while(list($name, $url) = $result->fields) {
      $this->interface_data[related] .= "<li><a href=\"$url\" target=\"_blank\">$name</a>\n";
      $result->MoveNext();
    }

    $theme->assign('idata', $this->interface_data);
    $theme->assign('tdata', $this->topic_data);
  }
}

$gui = new LocalInterface();
$gui->Initialize();
print $gui->display();


?>
