<?php
$plugin = 'chat';
include "../../function.php";

$interface = 'chat.admin';
$interface_cols = array('id','uid','aid','rid');

if ($config[chat][guest_entry] == false && empty($userinfo[groups][User])) {
  $reason = "You must be logged to a valid chat access account in to use the chat system.";
  include("$include_path/plugins/$plugin/noaccess.php");
  exit;
}

class LocalInterface extends Interface {

  function LocalInterface() {
    $this->Interface();
  }

	function display() {
		global $dbh;
		global $userinfo;
		
		$out = <<<END_HTML
<HTML>
<HEAD>
<TITLE>User Info Frame</TITLE>
<LINK REL=stylesheet HREF="chat_userlist.css" TYPE="text/css">
<SCRIPT LANGUAGE="JavaScript"><!--
{$this->JSCRIPT}
//-->
</SCRIPT></HEAD>
<BODY>
{$this->content}
</BODY></HTML>		
END_HTML;
		return $out;
	}
	
	function boot() {
		global $dbh;
		global $config;
		$id_q = $this->command->db_quote($this->search[id]);

    list($dbt, $dbc) = array_values($this->command->DBGetTable('alias'));
		$sql = <<<END_SQL
select $dbc[name] from $dbt where $dbc[id] = $id_q
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error("Could not extract user information for boot", FATAL);
		$this->content = <<<END_HTML
<form name="bootForm" method="post" action="$config[site_url]/plugins/chat/admin.php">
<input type="hidden" name="sid" value="{$this->sid}">
<input type="hidden" name="searchid" value="{$this->search[id]}">
<input type="hidden" name="operation" value="submit.boot">
<table width=100% cellspacing=0 cellpadding=2>
<tr><td class=tableHeader>
Boot Alias (ID: {$this->search[id]})
</td></tr>
<tr><td class=tableInfoExtra>
<textarea name="form_reason" rows="3" cols="15"></textarea>
</td></tr>
<tr><td align=center nowrap class=tableInfoExtra>
<input type=submit value="Boot">
<input type=submit value="Cancel" onClick="back();return false;">
</td></tr>
<tr><td class=tableInfoDesc>
To boot this character, enter a reason for the boot and click "Submit".
If no reason is entered, the boot will not execute.
</td></tr>
</table>
</form>
END_HTML;
	}
	
	function ban() {
		global $dbh;
		global $config;
		
		$id_q = $this->command->db_quote($this->search[id]);
    list($dbt, $dbc) = array_values($this->command->DBGetTable('chat_session'));
		$sql = <<<END_SQL
select $dbc[ip_address] from $dbt where $dbc[aid] = $id_q
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error("Could not extract user information for ban", FATAL);
		$this->content = <<<END_HTML
<form name="banForm" method="post" action="$config[site_url]/plugins/chat/admin.php">
<input type="hidden" name="sid" value="{$this->sid}">
<input type="hidden" name="searchid" value="{$this->search[id]}">
<input type="hidden" name="operation" value="submit.ban">
<table width=100% cellspacing=0 cellpadding=2>
  <tr><td class=tableHeader>
    Ban User (ID: {$this->search[uid]})
  </td></tr>
  <tr><td class="tableInfoDesc">
    Select the IP mask you wish to ban
  </td></tr>
  <tr><td class="tableInfoExtra">
    <input name=form_ip value="{$result->fields[ip_address]}" size="15">
  </td></tr>
  <tr><td class="tableInfoDesc">
    How long should the ban last (days)?
  </td></tr>
  <tr><td class="tableInfoExtra">
    <input name=form_duration value="{$config[chat][expiry_default_time]}" size="5">
  </td></tr>
  <tr><td class="tableInfoDesc">
    Reason for the ban.
  </td></tr>
  <tr><td class="tableInfoExtra">
    <textarea name="form_reason" rows="3" cols="15"></textarea>
  </td></tr>
  <tr><td align=center nowrap class="tableInfoExtra">
    <input type='submit' value='Ban'>
    <input type=submit value="Cancel" onClick="back();return false;">
  </td></tr>
</table>
</form>
END_HTML;

	}
	
	function disable() {
		global $dbh;
		global $config;
		
		$id_q = $this->command->db_quote($this->search[id]);
    list($dbt, $dbc) = array_values($this->command->DBGetTable('alias'));
		$sql = <<<END_SQL
select $dbc[name] from $dbt where $dbc[id] = $id_q
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error("Could not extract user information for disable", FATAL);
		$this->content = <<<END_HTML
<form name="disableForm" method="post" action="$config[site_url]/plugins/chat/admin.php">
<input type="hidden" name="sid" value="{$this->sid}">
<input type="hidden" name="searchid" value="{$this->search[id]}">
<input type="hidden" name="operation" value="submit.disable">
<table width=100% cellspacing=0 cellpadding=2>
<tr><td class=tableHeader>
Disable Alias (ID: {$this->search[id]})
</td></tr>
<tr><td class=tableInfoExtra>
<textarea name="form_reason" rows="3" cols="15"></textarea>
</td></tr>
<tr><td align=center nowrap class=tableInfoExtra>
<input type=submit value="Disable">
<input type=submit value="Cancel" onClick="back();return false;">
</td></tr>
<tr><td class=tableInfoDesc>
To disable this character, enter a reason for the removal and click "Submit".
If no reason is entered, the boot will not execute.
</td></tr>
</table>
</form>
END_HTML;

	}
	
	function doBoot() {
		global $dbh;
		global $config;

    $detail_q = $this->command->db_quote($this->form_data[reason]);
    $id_q = $this->command->db_quote($this->search[id]);

    list($dbt_sess, $scol) = array_values($this->command->DBGetTable('chat_session'));
    list($dbt_alias, $acol) = array_values($this->command->DBGetTable('alias'));
    list($dbt_room, $rcol) = array_values($this->command->DBGetTable('chat_room'));
    $session_data = $this->command->loadSessionByAlias($this->search[id], true);

    $sql = <<<END_SQL
update $dbt_sess
set $scol[status] = 200, 
  $scol[status_description] = $detail_q 
where $scol[aid] = $id_q
END_SQL;
    $dbh->Execute($sql) or trigger_error ("Boot session update failed.", FATAL);

		if (!$dbh->ErrorMsg()) {
		  $this->JSCRIPT = <<<END_JSCRIPT
window.alert("Boot was successful.");
this.document.location = "$config[site_url]/plugins/chat/userlist.php?sid={$this->sid}";
END_JSCRIPT;
  		$this->command->writeChatMessage($this->command->systemSession($this->chat_session), sprintf($config[chat][message_boot],$session_data[name],$session_data[roomname]));
    } else {
		  $this->JSCRIPT = <<<END_JSCRIPT
window.alert("Boot failed: $error");
this.document.location = "$config[site_url]/plugins/chat/userlist.php?sid={$this->sid}";
END_JSCRIPT;
    }
	}
	
	function doBan() {
		global $dbh;
		global $userinfo;
    global $config;

    list($dbt_sess, $scol) = array_values($this->command->DBGetTable('chat_session'));
    list($dbt_ban, $bcol) = array_values($this->command->DBGetTable('user_ban'));

    $sql = <<<END_SQL
select $scol[ip_address], $scol[uid]
from $dbt_sess where $scol[aid] = $id_q
END_SQL;
    $result = $dbh->Execute($sql) or trigger_error("Could not extract user data for ban", FATAL);

    $sql = <<<END_SQL
update $dbt_sess 
set $scol[status] = 201, 
  $scol[status_description] = $detail_q 
where $scol[aid] = $id_q
END_SQL;
    $dbh->Execute($sql) or trigger_error("Could not change session status to banned.", FATAL);

    $id_q = $this->command->db_quote($this->search[id]);
    $detail_q = $this->command->db_quote($this->form_data[reason]);
    $ip_q = $this->command->db_quote($this->form_data[ip]);
    $uid_q = $this->command->db_quote($result->fields[uid]);
    $euser_q = $this->command->db_quote($userinfo[id]);
    $entdt_q = $this->command->db_quote($this->command->formatUNIXTimestamp());
    $expdt_q = $this->command->db_quote($this->command->manipulateTime($this->command->formatUNIXTimestamp(), $this->form_data[duration], 'D'));
    $plugin_q = $this->command->db_quote($this->plugin);
    $interface_q = $this->command->db_quote($this->interface);
    $sql = <<<END_SQL
insert into $dbt_ban
($bcol[ip], $bcol[entry_date], $bcol[expiry_date], $bcol[reason], 
  $bcol[entry_user], $bcol[plugin], $bcol[interface]) 
values ($ip_q, $entdt_q, $expdt_q, $detail_q, $euser_q, $plugin_q, $interface_q)
END_SQL;
    $dbh->Execute($sql) or trigger_error('Boot entry failed.', FATAL);

    $session_data = $this->command->loadSessionByAlias($this->search[id], true);
    
		if (empty($error)) {
		  $this->JSCRIPT = <<<END_JSCRIPT
window.alert("User ban was successful.");
this.document.location = "$config[site_url]/plugins/chat/userlist.php?sid={$this->sid}";
END_JSCRIPT;
  		$this->command->writeChatMessage($this->command->systemSession($this->chat_session), sprintf($config[chat][message_ban],$session_data[name],$session_data[roomname]));  
    } else {
		  $this->JSCRIPT = <<<END_JSCRIPT
window.alert("User ban failed: $error");
this.document.location = "$config[site_url]/plugins/chat/userlist.php?sid={$this->sid}";
END_JSCRIPT;
    }
    
	}
	
	function doDisable() {
		global $dbh;
    global $config;

    list($dbt_sess, $scol) = array_values($this->command->DBGetTable('chat_session'));
    list($dbt_alias, $acol) = array_values($this->command->DBGetTable('alias'));

    $detail_q = $this->command->db_quote($this->interface_data[detail]);        
    $id_q = $this->command->db_quote($this->search[id]);
    $sql = <<<END_SQL
update $dbt_sess
set $scol[status] = 202, 
  $scol[status_description] = $detail_q 
where $scol[aid] = $id_q
END_SQL;
    $dbh->Execute($sql) or trigger_error('Session disable update failed. ', FATAL);

    $sql = <<<END_SQL
update $dbt_alias 
set $acol[activity] = 3 
where $acol[id] = $id_q
END_SQL;
    $dbh->Execute($sql) or trigger_error('Alias entry disable update failed. ', FATAL);

    $session_data = $this->command->loadSessionByAlias($this->search[id], true);

		if (empty($error)) {
		  $this->JSCRIPT = <<<END_JSCRIPT
window.alert("Character disable was successful.");
this.document.location = "$config[site_url]/plugins/chat/userlist.php?sid={$this->sid}";
END_JSCRIPT;
  		$this->command->writeChatMessage($this->command->systemSession($this->chat_session), sprintf($config[chat][message_disable],$session_data[name],$session_data[roomname]));  
    } else {
		  $this->JSCRIPT = <<<END_JSCRIPT
window.alert("Character disable failed: $error");
this.document.location = "$config[site_url]/plugins/chat/userlist.php?sid={$this->sid}";
END_JSCRIPT;
    }
	}
	
}

$searchname = 'aid';
$searchby = 'chat_session';

$gui = new LocalInterface();
$gui->Initialize();
$gui->sid = $sid;
$gui->chat_session = $gui->command->loadSession($gui->sid);
empty($gui->chat_session) ? $gui->command->forceLogout("Session load failed: {$gui->command->error}") : '';

$gui->interface_data[detail] = $message;
if (preg_match("/^submit/i", $operation)) {
	if (preg_match("/boot$/i", $operation)) {
		$gui->doBoot();
	} elseif (preg_match("/ban$/i", $operation)) {
		$gui->doBan();
	} elseif (preg_match("/disable$/i", $operation)) {
		$gui->doDisable();
	} else {
	}
} elseif ($operation == "boot" && $userinfo[chat][can_boot] == 2) {
	$gui->boot();
} elseif ($operation == "ban" && $userinfo[chat][can_ban] == 1) {
	$gui->ban();
} elseif ($operation == "disable" && $userinfo[chat][can_disable] == 1) {
	$gui->disable();
} else {
}
print $gui->display();

$JSCRIPT = '';
?>
