<?php
$plugin = 'chat';

include "../../function.php";
$interface = 'chat.elevator';
$interface_cols = array();

if ($config[chat][guest_entry] == false && empty($userinfo[groups][User])) {
  $reason = "You must be logged to a valid chat access account in to use the chat system.";
  include("$include_path/plugins/$plugin/noaccess.php");
  exit;
}

class LocalInterface extends Interface {

  function LocalInterface() {
    $this->Interface();
  }

	function display() {
	  global $dbh;
	  global $config;
	  
    $out = '';

    list ($dbt_alias, $acol) = array_values($this->command->DBGetTable('alias'));
    list ($dbt_log, $lcol) = array_values($this->command->DBGetTable('chat_log'));
    list ($dbt_mess, $mcol) = array_values($this->command->DBGetTable('chat_message'));
    list ($dbt_room, $rcol) = array_values($this->command->DBGetTable('chat_room'));
    list ($dbt_rmst, $rscol) = array_values($this->command->DBGetTable('chat_room_status'));
    list ($dbt_rmac, $racol) = array_values($this->command->DBGetTable('chat_room_access'));

    $newdt_q = $this->command->db_quote($this->chat_session[updated]);
    $lastr_q = $this->command->db_quote($this->chat_session[lastread]);
    $rid_q = $this->command->db_quote($this->chat_session[rid]);
    $aid_q = $this->command->db_quote($this->chat_session[aid]);
// Check for new users.
    $sql = <<<END_SQL
      select count($lcol[id]) from $dbt_log
      where $lcol[entry_date] >= $newdt_q
      and ($lcol[mid] >= 100 and $lcol[mid] <= 299)
END_SQL;
    $result = $dbh->Execute($sql) or trigger_error('Could not count new users', FATAL);
    $userCount = $result->fields[0];
    if ($result->fields[0] > 0) {
      $this->JSCRIPT[user] .= <<<END_JSCRIPT
    parent.userlist.document.location.reload();
END_JSCRIPT;
    }

// Check to ensure room status is still open.
		$sql = <<<END_SQL
select $rcol[status], $rcol[status_msg], $rscol[name] as roomstatus, 
  $rcol[private]
from $dbt_room, $dbt_rmst
where $rcol[id] = $rid_q
  and $rscol[id] = $rcol[status]
END_SQL;
    $result = $dbh->Execute($sql) or trigger_error('Could not verify room status.', FATAL);
		if ($result->fields[status] != 1 ) { $this->command->forceLogout("Room status is no longer open. Room is " . $result->fields[roomstatus] . ": " . $result->fields[status_msg]); }
    
// Make sure we still have private room access.
    if ($result->fields[private] == 1) {
  		$sql = <<<END_SQL
select $racol[rid], $racol[aid]
from $dbt_rmac
where $racol[rid] = $rid_q
  and $racol[aid] = $aid_q
END_SQL;
      $result = $dbh->Execute($sql) or trigger_error('Could not verify access to private room', FATAL);
  		if ($result->fields[rid] != $this->chat_session[rid] ) { $this->command->forceLogout("Private room access has been removed for your character."); }
    }

    $sql = <<<END_SQL
select $mcol[id], $mcol[aid], $acol[name], $acol[status], $mcol[message], 
  $mcol[postdate], $mcol[recipient], $mcol[from_room], $rcol[name] as roomname 
from $dbt_mess, $dbt_alias, $dbt_room
where $mcol[rid] = $rid_q
and $mcol[id] > $lastr_q
and $rcol[id] = $mcol[rid]
and $mcol[aid] = $acol[id]
order by $mcol[id]
END_SQL;
    $result = $dbh->Execute($sql) or trigger_error('Could not read newest messages', FATAL);
    $countUser = 0;
    $countMess = 0;

    $out .= <<<END_HTML
<HTML><HEAD>
<TITLE></TITLE>
<META HTTP-EQUIV="Refresh" CONTENT="10; URL=elevator.php?sid={$this->chat_session[id]}">
<SCRIPT LANGUAGE="JavaScript1.1"><!--

{$this->JSCRIPT[login]}

{$this->JSCRIPT[head]}
END_HTML;

    if (isset($result->fields[id]) && $result->fields[id] != "") {
      $out .= <<<END_HTML

var nameArr = new Array();
var dateArr = new Array();
var messArr = new Array();
var privArr = new Array();
var fromArr = new Array();

END_HTML;

    while ($data = $result->fields) {
      $private_flag = '';
      if (isset($data[recipient]) && $data[recipient] != '') {
        $recips = explode (',', $data[recipient]);
        $sql = <<<END_SQL
select $scol[aid], $acol[name], $scol[rid], $rcol[name] as roomname 
from $dbt_alias, $dbt_room, $dbt_sess
where $acol[id] in ($data[recipient])
  and $scol[aid] = $acol[id]
  and $scol[rid] = $rcol[id]
order by $acol[name]
END_SQL;
        $result2 = $dbh->Execute($sql) or trigger_error('Cannot determine message recipients', FATAL);

        if ($this->chat_session[aid] != $data[aid]) {
          for ($i = 0; $i < sizeof($recips) ; $i++) {
          	if ($recips[$i] == $this->chat_session[aid]) {
    	        while($data2 = $result2->fields) {
    	          if ($private_flag != '') {
    	            $private_flag .= ", $data2[name]";
    	          } else {
    	            $private_flag = $data2[name];
    	          }
    	          if ($data2[rid] != $this->chat_session[rid]) {
    	            $private_flag .= " ($data2[roomname])";
    	          }
    	          $result2->MoveNext();
    	        }
    	        break;
    	      }
          }
        } else {
          while($data2 = $result2->fields) {
          	if ($private_flag != '') {
          	  $private_flag .= ", $data2[name]";
          	} else {
          	  $private_flag = $data2[name];
          	}
          	if ($data2[rid] != $this->chat_session[rid]) {
          	  $private_flag .= " ($data2[roomname])";
          	}
          	$result2->MoveNext();
          }
        }
        if ($private_flag == '') {
          $result->MoveNext();
          continue;
        }
      }
      $data[message] = preg_replace('/([^\012\015]*)(\012\015?|\015\012?|012?)/', "\\1<br>", $data[message]);
      $data[message] = addslashes($data[message]);
      if (isset($data[from_room]) && $data[from_room] != '') {
        $data[room_to] = $data[from_room];
      }
      if ($data[status] == 1) {
        $data[message] = "<div class=systemMessage>Out of Character</div>$data[message]";
      }
      
      $out .= <<<END_HTML
  nameArr[$countMess] = "$data[name]";
  dateArr[$countMess] = "$data[postdate]";
  messArr[$countMess] = "$data[message]";
  privArr[$countMess] = "$private_flag";
  fromArr[$countMess] = "$data[room_to]";
END_HTML;
      $result->MoveNext();
      $this->chat_session[lastread] = $data[id];
      $countMess++;
    }

    $out .= <<<END_HTML
var messageSize = $countMess;
{$this->JSCRIPT[submit]}
parent.code.loadMessageData();
parent.code.buildMessageWindow();

END_HTML;
    } 
    $this->command->updateSession($this->chat_session);
    $this->command->chatCleanup($this->session);
    $out .= <<<END_HTML
{$this->JSCRIPT[user]}
//-->
</SCRIPT>
</HEAD><BODY BGCOLOR=#E0E0E0>
###
</BODY>
</HTML>
END_HTML;
    return $out;
  }

  function setJscriptLogin() {
    $this->JSCRIPT[login] = <<<END_JSCRIPT
    var login_flag = 1;
    parent.code.nameArr = new Array();
    parent.code.dateArr = new Array();
    parent.code.messArr = new Array();
    parent.code.privArr = new Array();
    parent.code.fromArr = new Array();
END_JSCRIPT;
  }

  function sendMessage($message, $room, $recipients) {
    global $config;
    $tmp_session = $this->chat_session;
    if (isset($room[Name]) && $room[Name] != '' &&
      $this->chat_session[rid] != $room[ID]) {
      $this->command->writeChatMessage($this->chat_session, sprintf($config[chat][page_internal], $message), $recipients);
      $tmp_session[from_room] = $this->chat_session[roomname];
      $tmp_session[rid] = $room[ID];
    }
    $this->command->writeChatMessage($tmp_session, $message, $recipients);
    $this->JSCRIPT[submit] = <<<END_JSCRIPT
  parent.submit.document.submitForm.message.value='';
  parent.submit.document.submitForm.message.focus();
END_JSCRIPT;
  }

  function doLogout() {
    global $dbh;
    global $config;

    list ($dbt_sess, $scol) = array_values($this->command->DBGetTable('chat_session'));
    
    $message = sprintf($config[chat][message_exit], $this->chat_session[name], $this->chat_session[roomname], addslashes($this->chat_session[exit_message]));
    $this->command->writeChatMessage($this->command->systemSession($this->chat_session), $message);
    $id_q = $this->command->db_quote($this->chat_session[id]);
    $sql = "delete from $dbt_sess where $scol[id] = $id_q";
    $result = $dbh->Execute($sql);
    !$result ? die ("SQL: $sql -- " . $dbh->ErrorMsg()) : '';
    $this->command->logMessage($this->chat_session, $config[chat][log_session_exit]);
    $this->command->forceLogout('User submitted logout.');
  }
  
}

$gui = new LocalInterface();
$gui->Initialize();
$gui->sid = $sid;
$gui->chat_session = $gui->command->loadSession($gui->sid);
empty($gui->chat_session) ? $gui->command->forceLogout("Session load failed: {$gui->command->error}") : '';

$gui->JSCRIPT[login] = '';
$gui->JSCRIPT[submit] = '';
$gui->JSCRIPT[head] = '';

/* CONDITIONAL OPERATIONS */
if (isset($login_flag) && $login_flag != '') { 
  $gui->setJscriptLogin();
} else {
  $gui->JSCRIPT[login] = "var login_flag = 0;\n";
}

if (isset($submit_x) && $submit_x > 0) {
  $gui->sendMessage($message, array(Name => $roomName, ID => $roomID), $recipients);
} elseif (isset($logout_x) && $logout_x > 0) {
  $gui->doLogout();
}

print $gui->display();

/*
//
//
*/
?>
