<?php
/*-----------------------------------------------------------------------------
** logout.php - DarkConverse chat logout interface
**
** DESCRIPTION
**    
** AUTHOR
**    Fred Hirsch
** COPYRIGHT
**    (C) 2001 Dark Hart Design
**    GNU Public License (see LICENSE file for details)
**-----------------------------------------------------------------------------
*/
/*-----------------------------------------------------------------------------
** Initializing the Interface classes
**    The first step in initialization is to load the core system function and
**    setup file. The "mainfile" loads all the configuration parameters, session
**    handler and database loader for the various sub-elements. Unlike other 
**    paths in the system, the mainfile include must be relative to the location
**    where the current script is running. From the mainfile, the core include
**    path is setup for all the secondary includes.
*/
$plugin = 'chat';
include("../../function.php");

$interface = 'chat.logout';
$interface_title = 'DarkPortal Admin - DarkConvers Chat';
$interface_cols = array();

if ($config[chat][guest_entry] == false && empty($userinfo[groups][User])) {
  $reason = "You must be logged to a valid chat access account in to use the chat system.";
  include("$include_path/noaccess.php");
  exit;
}

class LocalInterface extends Interface {

  function LocalInterface() {
    $this->Interface();
  }

  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;
    
    $theme->assign('userinfo', $userinfo);
  }
}

$gui = new LocalInterface();
$gui->Initialize();
if ($operation == 'logout') {
	$error = "Thank you for using DarkConvers. Come again";
} elseif ($operation == 'boot') {
	$error = "Your session was kicked from the chat.<BR> The reason for this removal: $message<BR> You may login again to continue chatting, but do not repeat the offensive behavior";
} elseif ($operation == 'ban') {
	$error = "Your IP address has been banned. No users from your computer or network may login to this service. This action is taken due to repeated violations of rules on this service. You may petition the owners of this site to have the ban removed.";
} elseif ($operation == 'disable') {
	$error = "This user account has had chat access disabled. You are either not permitted to use the chat service, or your access has been removed. You may petition the owners of this site to have the account activated.";
} else {
	$error = "Your access to the chat has been cancelled: $message";
}

$gui->interface_data[error] = $error;
$gui->theme->assign('idata', $gui->interface_data);
print $gui->display();


?>
