<?php
$plugin = 'chat';
include "../../function.php";

$interface = 'chat.roominfo';
$interface_cols = array();

if ($config[chat][guest_entry] == false && empty($userinfo[groups][User])) {
  $reason = "You must be logged to a valid chat access account in to use the chat system.";
  include("$include_path/plugins/$plugin/noaccess.php");
  exit;
}


class LocalInterface extends Interface {

  function LocalInterface() {
    $this->Interface();
  }

	function display() {
		global $dbh;
    global $config;
    global $userinfo;

    list($dbt_alias, $acol) = array_values($this->command->DBGetTable('alias'));
    list($dbt_room , $rcol) = array_values($this->command->DBGetTable('chat_room'));
    list($dbt_rmac , $racol) = array_values($this->command->DBGetTable('chat_room_access'));

    $rid_q = $this->command->db_quote($this->chat_session[rid]);
		if (isset($this->error) && $this->error != '') {
			$this->JSCRIPT = "window.alert(\"" . nl2br($this->error) . "\");\n";
		}
		
		$sql = <<<END_SQL
select $rcol[id], $rcol[name], $rcol[long_desc]
from $dbt_room
where $rcol[id] = $rid_q
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error("Cannot determine the local room information.", FATAL);
		$data = $result->fields;
		
		$sql = <<<END_SQL
select $rcol[id], $rcol[name], $rcol[privilege]
from $dbt_room
where $rcol[status] = 1 
and $rcol[private] != 1 
order by $rcol[id]
END_SQL;
		$result2 = $dbh->Execute($sql) or trigger_error("Cannot build room list.", FATAL);

    $uid_q = $dbh->qstr($userinfo[id]);
    $sql = "select $acol[id] from $dbt_alias where $acol[uid] = $uid_q";
    $result_alias = $dbh->Execute($sql) or trigger_error ("Cannot build a list of user->aliases" . $dbh->ErrorMsg(), FATAL);
    $alias_list = array();
    while ($bdata = $result_alias->fields[id]) {
      $result_alias->MoveNext();
      $alias_list[] = $bdata[id];
    }
    
    $aid_list = join(",", $alias_list);
    $sql = <<<END_SQL
select $rcol[id], $rcol[name]
from $dbt_room, $dbt_rmac
where $racol[aid] in ($aid_list) 
  and $racol[rid] = $rcol[id]
  and $rcol[status] = 1 
  and $rcol[private] = 1 
order by $rcol[id]
END_SQL;
    $result3 = $dbh->Execute($sql) or trigger_error ("Cannot determine user access to rooms" . $dbh->ErrorMsg(), FATAL);
    
		$label = array(change_room => urlencode('Change'),
			       whos_on     => urlencode("Who's On"));
		$out .= <<<END_HTML
<HTML>
<HEAD>
<TITLE>Room Info Frame</TITLE>
<SCRIPT LANGUAGE="JavaScript"><!--

function triggerWho() {
  whoRoom = this.document.roomInfo.roominfo_room
  whoRoomSelectedText = whoRoom[whoRoom.selectedIndex].text;
  whoRoomSelectedID = whoRoom[whoRoom.selectedIndex].value;
  parent.code.userlistLocation = whoRoomSelectedText;
  parent.code.userlistLocationID = whoRoomSelectedID;
  parent.userlist.document.location =  "userlist.php?sid={$this->sid}&searchroom=" + whoRoomSelectedID;
}

{$this->JSCRIPT}
//-->
</SCRIPT></HEAD>
<BODY BGCOLOR=#E0E0E0>
<FORM NAME="roomInfo" ACTION="roominfo.php" METHOD=GET>
<INPUT TYPE="hidden" name="sid" value="{$this->sid}">
<TABLE WIDTH=100% BORDER=0 CELLSPACING=0 CELLPADDING=2 >
    <TR>
        <TD BGCOLOR=#406080>
            <FONT FACE="verdana,arial,helvetica" COLOR=#FFFFFF><B>$data[name]</B></FONT>
        </TD>
        <TD BGCOLOR=#406080 ALIGN=CENTER NOWRAP >
             <FONT FACE="verdana,arial,helvetica" COLOR=#FFFFFF SIZE=1>
               <INPUT TYPE=IMAGE SRC="{$config[chat][image_url]}/roominfo_Change.png" NAME="change_room" BORDER=0>
               <A HREF='' onClick="triggerWho();return false;"><IMG SRC="{$config[chat][image_url]}/roominfo_WhosOn.png" NAME="whos_on" BORDER=0></A>
             </FONT>
        </TD>
    </TR><TR>
        <TD VALIGN=TOP HEIGHT=100%>
            <FONT FACE="verdana,arial,helvetica" SIZE=1>$data[long_desc]
        </TD>
        <TD BGCOLOR=#C0C0C0 HEIGHT=100% ALIGN=CENTER VALIGN=TOP>
             <FONT FACE="verdana,arial,helvetica" SIZE=2><SELECT NAME="roominfo_room">
END_HTML;

		while ($data2 = $result2->fields) {
      $priv = ($data2[privilege] > 1) ? " (P)" : '';
		  $SELECTED = '';
		  if ($data2[id] == $data[id]) { $SELECTED = 'SELECTED'; }
	  		$out .= <<<END_HTML
              <OPTION VALUE="$data2[id]" $SELECTED>$data2[name]$priv</OPTION>
END_HTML;
		  $result2->MoveNext();
		}

    if (isset($result3->fields[id])) {
      $out .= "<option value='{$result3->fields[id]}'>---- Private Rooms ----</option>\n";
      while ( $data3 = $result3->fields) {
        $result3->MoveNext();
  		  if ($data3[id] == $data[id]) { $SELECTED = 'SELECTED'; }
        $out .= "<OPTION value=\"$data3[id]\" $SELECTED>$data3[name]</OPTION>\n";
      }
    }  

		$out .= <<<END_HTML
             </SELECT>
        </TD>
    </TR>
</TABLE>
</FORM>
</BODY>
</HTML>
END_HTML;
		return $out;	
	}

	function validateRoom($rid) {
		global $dbh;
		global $userinfo;

    list($dbt_room, $rcol) = array_values($this->command->DBGetTable('chat_room'));
    list($dbt_rmac, $racol) = array_values($this->command->DBGetTable('chat_room_access'));
    list($dbt_sess, $scol) = array_values($this->command->DBGetTable('chat_session'));

	  //CHECK: Make sure user is allowed to enter room.
		$rid_q = $this->command->db_quote($rid);
		$aid_q = $this->command->db_quote($this->chat_session[aid]);
		$uid_q = $this->command->db_quote($this->chat_session[uid]);
		$sql = <<<END_SQL
select $rcol[name], $rcol[occupancy], $rcol[status], $rcol[status_msg], 
  $rcol[privilege], $rcol[visible], $rcol[private]
from $dbt_room
where $rcol[id] = $rid_q
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error('Cannot load room information.', FATAL);
		$room_info = $result->fields;
	
		$sql = <<<END_SQL
select count($scol[id]) as room_count 
from $dbt_sess
where $scol[rid] = $rid_q
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error('Cannot detemine number of users in room.', FATAL);
		$sess_info = $result->fields;
		// First, check if the room is private and if the user has access to the room
		if ($room_info[private] == 1 && 
		    $userinfo[chat][enter_private] != 1 &&
		    $userinfo[id] != $room_info[uid]) {
			$sql = "select $racol[rid] from $dbt_rmac where $racol[rid] = $rid_q and $racol[aid] = $aid_q";
			$result = $dbh->Execute($sql) or trigger_error('Cannot determine user access to room.', FATAL);
			if (empty($result->fields[rid]) || $result->fields[rid] == '') {
				$error .= "Room $room_info[name] is a private room. You do not have permission to enter.\n";
			}
		} 
	  // Check if the room is disabled
		if ($room_info[status] == 2) {
			$error .= "Room $room_info[name] is currently closed. Reason: $room_info[status_msg]";
		}
		// Next, check if the room is full
		if ($sess_info[room_count] > $room_info[occupancy] && $userinfo[chat][enter_full] != 1) {
			$error .= "Room $room_info[name] is currently full. Try another room or wait until a user leaves.";
		}
	  //CHECK: Restrict the number of logins available to the user.
		$sql = <<<END_SQL
select $scol[rid], count($scol[id]) as user_count 
from $dbt_sess
where $scol[uid] = $uid_q 
group by $scol[rid]
END_SQL;
		$result = $dbh->Execute($sql) or trigger_error('Cannot determine chat login counts for user', FATAL);
		if ($result->fields[rid] != '') {
			while ($sess_info = $result->fields) {
				if ($sess_info[rid] == $rid && $sess_info[user_count] >= $userinfo[chat][login_perroom]) {
					($userinfo[chat][login_perroom] > 1) ? $plural = 's' : $plural = '';
					$error .= "You have already signed into $room_info[name], {$userinfo[chat][login_perroom]} time$plural. Logout one of the existing characters to proceed.";
				}
				$result->MoveNext();
			}
		}
		if ($error == '') {
			return true;
	  } else {
	  	$this->error = $error;
	  	return false;
	  } //if
	} //validateRoom

	function moveRoom($rid) {
		global $dbh;
		global $config;

    list($dbt_mess, $mcol) = array_values($this->command->DBGetTable('chat_message'));
		
		$old_session = $this->chat_session;
	  // Move the use by transfering the session to the new room... also setup the user for lastread.
	  $this->chat_session[rid] = $rid;
	  $rid_q = $this->command->db_quote($this->chat_session[rid]);
		$sql = <<<END_SQL
select $mcol[id]
from $dbt_mess
where $mcol[rid] = $rid_q 
order by $mcol[id] desc
END_SQL;
	  $result = $dbh->SelectLimit($sql, 20) or trigger_error('Cannot load message list for parsing.', FATAL);
	  $result->MoveLast();
	  if ($result->fields[id] > 0) {
	    $this->chat_session[lastread] = $result->fields[id];
	  } else {
	    $this->chat_session[lastread] = 0;
	  }
	  $result->MoveFirst();
	  if ($result->fields[id] > 0) {
	    $this->chat_session[firstread] = $result->fields[id];
	  } else {
	    $this->chat_session[firstread] = 0;
	  }
	  $this->command->updateSession($this->chat_session);
	  $this->chat_session = $this->command->loadSession($this->sid);
	  // Notify current room of user's move
	  $this->command->writeChatMessage($this->command->systemSession($old_session), sprintf($config[chat][message_roommove_exit], $this->chat_session[name], $this->chat_session[roomname],addslashes($this->chat_session[exit_message])));
	  $this->command->logMessage($old_session, $config[chat][log_session_moveout]);
	  // Notify new room that the user has entered.
	  $this->command->writeChatMessage($this->command->systemSession($this->chat_session), sprintf($config[chat][message_roommove_enter], $this->chat_session[name], $old_session[roomname], addslashes($this->chat_session[entry_message])));
	  $this->command->logMessage($this->chat_session, $config[chat][log_session_movein]);
	  // Update the user interface windows with JSCRIPT
	  $this->JSCRIPT = <<<END_JSCRIPT
    parent.code.clearMessageData();
	  parent.userlist.document.location = "userlist.php?sid={$this->sid}";
	  parent.elevator.document.location = "elevator.php?sid={$this->sid}&login_flag=1";
END_JSCRIPT;
	}
		
} //class

$gui = new LocalInterface();
$gui->Initialize();
$gui->sid = $sid;
$gui->chat_session = $gui->command->loadSession($gui->sid);
empty($gui->chat_session) ? die ("Session load failed: {$gui->command->error}") : '';

if (isset($change_room_x) && $change_room_x != '') {
	if ($gui->validateRoom($roominfo_room)) {
		$gui->moveRoom($roominfo_room);
	}
}	

print $gui->display();
?>
