<?php
// TODO: Add file uploading for posts.
/*
* Local Interface
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin.forum';    // Plugin Name
include_once("../../../function.php");

$interface = 'admin.forum.board'; 
$interface_title = 'DarkPortal - Forum Board Manager';
$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Forum Post Interface 
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
    function initializeLocal() {
        global $dbh;
        global $userinfo;
        global $config;
    }

    function finalizeLocal() {
/*        global $userinfo;
        $userinfo[SAVE_PLUGIN] = true;
        if (isset($this->interface_data[board][id]) && $this->interface_data[board][id] != ''){
            $this->command->setUserRead($this->interface_data[board][id], $this->interface_data[userread]);
        }*/
    }

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;
  }

	function view() {
        global $dbh, $userinfo, $config;
	}

  function preview() {
  }

  function add() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $bcol = &$dbt[forum_board_column];

    unset($this->interface_data[title]);
    $this->theme->assign('idata', $this->interface_data);
  }
  
  function doAdd() {
    global $dbh, $config, $userinfo;

    $dbt = $this->command->DBGetTables();
    $bcol = &$dbt[forum_board_column];
    
    unset ($this->form_data[id]);
    $dbfields = array($bcol[id], $bcol[create_dt]);
    $dbvalues = array('null', $this->command->formatUNIXTimeStamp());
    
    $error = '';

    $sql = "insert into $dbt[forum_board] ";
    while (list($k, $v) = each($this->form_data)) {
      $dbfields[] = $bcol[$k];
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error .= "New forum board addition failed -- $sql --" . $dbh->ErrorMsg() : '';

    $bid_q = $this->command->db_quote($dbh->Insert_ID());
    $cid_q = $this->command->db_quote($this->form_data[cid]);
    $sql = "select max($bcol[ord]) from $dbt[forum_board] where $bcol[cid] = $cid_q";
    $result_m = $dbh->Execute($sql);
    $ord_q = $this->command->db_quote($result_m->fields[0] + 1);
    $sql = "update $dbt[forum_board] set $bcol[ord] = $ord_q where $bcol[id] = $bid_q";
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error .= "New forum board addition ordering failed -- $sql --" . $dbh->ErrorMsg() : '';

    $this->interface_data[error] = $error;
    if ($error != '') { 
      $this->operation = 'add';
      $this->Initialize();
    }

    $this->operation = '';
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  
  function edit() {
    global $dbh, $config, $userinfo;
    $this->theme->assign('idata', $this->interface_data);
   
  }
  
  function doEdit() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $bcol = &$dbt[forum_board_column];

    if ($this->interface_data[id] == $this->form_data[id]) { // Make sure we update self.
      if ($this->interface_data[cid] != $this->form_data[cid]) {
        $cid_q = $this->command->db_quote($this->form_data[cid]);
        $sql = "select max($bcol[ord]) from $dbt[forum_board] where $bcol[cid] = $cid_q";
        $result = $dbh->Execute($sql);
        $this->form_data[ord] = (isset($result->fields[0]) && $result->fields[0] > 0) ? $result->fields[0] + 1 : 1;
      }

      $sql = "update $dbt[forum_board] set ";
      unset ($this->form_data[name]);
      unset ($this->form_data[id]);
      while (list($k,$v) = each ($this->form_data)) {
        $dbfields[] = "$bcol[$k] = " . $this->command->db_quote($v);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where id = ". $this->command->db_quote($this->interface_data[id]);

      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Forum board modification failed -- $sql -- " . $dbh->ErrorMsg() : '';
    } else {
      $error .= 'Form improperly submitted';
    }

    $this->interface_data[error] = $error;
    $this->operation = '';
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  
  function delete() {
    global $dbh, $config, $userinfo;
    $this->theme->assign('idata', $this->interface_data);
  }

  function doDelete() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $bcol = &$dbt[forum_board_column];
    $pcol = &$dbt[forum_post_column];

    if ($this->interface_data[id] == $this->form_data[id]) { // Make sure we update self.
      $bid_q = $this->command->db_quote($this->interface_data[id]);
      $sql = "delete from $dbt[forum_board] where $bcol[id] = $bid_q";
      $dbh->Execute($sql) or $this->interface_data[error] .= "Board did not properly delete.";
      
      // Re-order everything.
      $cid_q = $this->command->db_quote($this->interface_data[cid]);
      $sql = "select $bcol[id], $bcol[ord] from $dbt[forum_board] where $bcol[cid] = $cid_q";
      $result_o = $dbh->Execute($sql) or $this->interface_data[error] .= "Cannot fix board order after delete.\n";
      while ($odata = $result_o->fields) {
        $result_o->MoveNext();
        if ($odata[ord] > $this->interface_data[ord]) {
           $sql = "update $dbt[forum_board] set $bcol[ord] = $bcol[ord] - 1 where $bcol[id] = $odata[id]";
           $dbh->Execute($sql) or $this->interface_data[error] .= "Cannot fix board order after delete.\n";
        }
      }
      // If we need to delete all posts, do it.
      if ($this->form_data[killposts] == 1) {
        $sql = "delete from $dbt[forum_post] where $pcol[bid] = $bid_q";
        $dbh->Execute($sql) or $this->interface_data[error] .= "Could not delete posts from board.";
      }
    } else {
      $error .= 'Form improperly submitted';
    }

    $this->interface_data[error] = $error;
    $this->operation = '';
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    $this->Initialize();

  }

  function sort() {
    global $dbh, $config, $userinfo;
    
    $dbt = $this->command->DBGetTables();
    $bcol = &$dbt[forum_board_column];
    if (isset($this->interface_data[id])){
      $bid_q = $this->command->db_quote($this->interface_data[id]);
      $cid_q = $this->command->db_quote($this->interface_data[cid]);
      $sql = <<<END_SQL
select $bcol[id], $bcol[ord] 
from $dbt[forum_board] 
where $bcol[id] <> $bid_q
and $bcol[cid] = $cid_q
order by $bcol[ord]
END_SQL;

      $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");;
      if (empty($result->fields[id])){
        $this->operation = '';
        $this->Initialize();
        return;
      }
      
      $update_flag = false;
      if ($this->form_data[sort] == 'up') {
        $this->interface_data[ord] = ($this->interface_data[ord] - 1 >= 1) ? $this->interface_data[ord] - 1 : $this->interface_data[ord];
        while($data = $result->fields) {
          if ($data[ord] == $this->interface_data[ord]) {
            $bid_q = $this->command->db_quote($data[id]);
            $sql = <<<END_SQL
update $dbt[forum_board]
set $bcol[ord] = $bcol[ord] + 1
where $bcol[id] = $bid_q
END_SQL;
            $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
            $update_flag = true;
          }
          $result->MoveNext();
        }
        if ($update_flag) {
          $ord_q = $this->command->db_quote($this->interface_data[ord]);
          $bid_q = $this->command->db_quote($this->interface_data[id]);
          $sql = <<<END_SQL
update $dbt[forum_board]
set $bcol[ord] = $ord_q
where $bcol[id] = $bid_q
END_SQL;
          $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        }
      } elseif ($this->form_data[sort] == 'down') {
        $this->interface_data[ord] = ($this->interface_data[ord] + 1 >= 1) ? $this->interface_data[ord] + 1 : $this->interface_data[ord];
        while($data = $result->fields) {
          if ($data[ord] == $this->interface_data[ord]) {
            $bid_q = $this->command->db_quote($data[id]);
            $sql = <<<END_SQL
update $dbt[forum_board]
set $bcol[ord] = $bcol[ord] - 1
where $bcol[id] = $bid_q
END_SQL;
            $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
            $update_flag = true;
          }
          $result->MoveNext();
        }
        if ($update_flag == true) {
          $ord_q = $this->command->db_quote($this->interface_data[ord]);
          $bid_q = $this->command->db_quote($this->interface_data[id]);
          $sql = <<<END_SQL
update $dbt[forum_board]
set $bcol[ord] = $ord_q
where $bcol[id] = $bid_q
END_SQL;
          $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        }
      } else {
        $this->interface_data[error] .= 'Unknown sort type.';
      }
    } else {
      $error .= 'Form improperly submitted';
    }

    $this->interface_data[error] = $error;
    $this->operation = '';
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  function moderate() {
    global $dbh, $config, $userinfo;
    $this->theme->assign('idata', $this->interface_data);
  }
  function doModerate() {
    global $dbh, $config, $userinfo;

    $dbt = $this->command->DBGetTables();
    $mcol = &$dbt[forum_board_mod_column];

    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $bid_q = $this->command->db_quote($this->interface_data[id]);
      if (isset($this->form_data[add])) {
        while (list($k, $v) = each($this->form_data[publiclist])) {
          $uid_q = $this->command->db_quote($v);
          $sql = "insert into $dbt[forum_board_mod] ($mcol[uid], $mcol[bid]) values ($uid_q, $bid_q)";
          $dbh->Execute($sql);
          $dbh->ErrorMsg() ? $error .= "Board moderator modification failed -- " . $dbh->ErrorMsg() : '';
        }
      } elseif (isset($this->form_data[delete])) {
        while (list($k, $v) = each($this->form_data[privatelist])) {
          $uid_q = $this->command->db_quote($v);
          $sql = "delete from $dbt[forum_board_mod] where $mcol[uid] = $uid_q and $mcol[bid] = $bid_q";
          $dbh->Execute($sql);
          $dbh->ErrorMsg() ? $error .= "Board moderator modification failed -- " . $dbh->ErrorMsg() : '';
        }
      }
      
    } else {
        $error = "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->theme->assign('idata', $this->interface_data);
    $this->operation = 'moderate.forum_board'; 
    $this->Initialize();
  }
}

/*
* Interface Initialization
*/
$gui = new LocalInterface();

$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;
  
$gui->Initialize();
if ($gui->interface_data[board][security] > $gui->interface_data[user_security] ) {
    $gui->command->noAccess('You do not have a high enough security level on this forum to view or modify posts.');
}

//$gui->urls = $gui->command->buildURL( array(mode => $gui->interface_data[mode], view => $gui->interface_data[view], sort_ord => $gui->interface_data[sort_ord], sort_by => $gui->interface_data[sort_by], page => $gui->interface_data[page], id => $gui->form_data[id], board => $gui->interface_data[board][id]), 'post.php', "$config[site_url]/plugins/forum", array('search','preview','add','edit','submit','view'));
/*-----------------------------------------------------------------------------
* Operation Logic
*/

if (preg_match("/^search/i", $operation)) {
  $gui->view();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  // If an operation does not require input validation, it is placed first.
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    // Once the form data is placed, it can be validated. 
    // The validation is interface dependent.
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'moderate') {
      $gui->doModerate();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'moderate') {
      $gui->sort;
    } elseif ($form__operation == 'sort') {
      $gui->sort;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^moderate/", $operation)) {
  $gui->moderate();
} elseif (preg_match("/^sort/", $operation)) {
  $gui->sort();
} else {
	$gui->view();
}

/*-----------------------------------------------------------------------------
* Interface Display
*    Once the operations (if any) are complete, the display method is called.
*    this enacts the object's theme to display its appropriate blocks.
*/
print $gui->display();
$gui->Finalize();
?>
