<?php
// TODO: Add file uploading for posts.
/*
* Local Interface
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin.forum';    // Plugin Name
include_once("../../../function.php");

$interface = 'admin.forum.category'; 
$interface_title = 'DarkPortal - Forum Category Manager';
//$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

(isset($searchby) && $searchby != '') ? $operation .= ".$searchby" : '';
isset($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Forum Post Interface 
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
    function initializeLocal() {
        global $dbh;
        global $userinfo;
        global $config;
    }

    function finalizeLocal() {
/*        global $userinfo;
        $userinfo[SAVE_PLUGIN] = true;
        if (isset($this->interface_data[board][id]) && $this->interface_data[board][id] != ''){
            $this->command->setUserRead($this->interface_data[board][id], $this->interface_data[userread]);
        }*/
    }

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;
  }

	function view() {
        global $dbh, $userinfo, $config;
	}

  function preview() {
  }

  function add() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $ccol = &$dbt[forum_category_column];

    unset($this->interface_data[title]);
    $this->interface_data[parent] = $this->form_data[parent];
    $this->interface_data[main] = $this->form_data[main];
    
    $pid_q = $this->command->db_quote($this->interface_data[parent]);
    $sql = "select max($ccol[ord]) from $dbt[forum_category] where $ccol[parent] = $pid_q";
    $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");;
    
    $this->interface_data[ord] = $result->fields[0] + 1;
    $this->theme->assign('idata', $this->interface_data);
  }
  
  function doAdd() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $ccol = &$dbt[forum_category_column];
    
    unset ($this->form_data[id]);
    unset ($this->form_data[name]);
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $sql = "insert into $dbt[forum_category] ";
    while (list($k, $v) = each($this->form_data)) {
      $dbfields[] = $ccol[$k];
      $dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error = "New forum category addition failed -- $sql --" . $dbh->ErrorMsg() : '';
    $this->interface_data[error] = $error;

    if (empty($this->form_data[main]) || $this->form_data[main] == 0) { // Adding new root
      $tit_q = $this->command->db_quote($this->form_data[title]);
      $sql = "select $ccol[id] from $dbt[forum_category] where $ccol[title] = $tit_q";
      $result = $dbh->Execute($sql)  or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
      $main = $result->fields[0];
      $main_q = $this->command->db_quote($main);
      $sql = "update $dbt[forum_category] set $ccol[main] = $main_q where $ccol[id] = $main_q";
      $dbh->Execute($sql)  or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
    }

    if ($error != '') { 
      $this->operation = 'add';
      $this->Initialize();
    }

    $this->operation = '';
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  
  function edit() {
    global $dbh, $config, $userinfo;
    $this->theme->assign('idata', $this->interface_data);
  }
  
  function doEdit() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $ccol = &$dbt[forum_category_column];
    
    $save = true;
    
    if ($this->interface_data[id] == $this->form_data[id]) { // Make sure we update self.
      // If this is a root, always disallow parent and main changes.
      if ($this->interface_data[main] == $this->interface_data[id]) {
        $this->form_data[main] = $this->interface_data[main];
        $this->form_data[parent] = $this->interface_data[parent];
        $error .= "Parent and root id's are not changed for a root record.";
      }
      $pid_q = $this->command->db_quote($this->form_data[parent]);
      $cid_q = $this->command->db_quote($this->form_data[id]);
      $mid_q = $this->command->db_quote($this->form_data[main]);

      // Make sure parent and main match with existing record.
      if ($this->form_data[parent] != 0) {
        $sql = "select $ccol[id] from $dbt[forum_category] where $ccol[id] = $pid_q and $ccol[main] = $mid_q";
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        if (empty($result->fields[0]) || $result->fields[0] <= 0) {
          $error .= "Parent does not match with main root for this edit.";
          $save = false;
        }
      }
      // Make sure that a parent exists for the record to add to, or the hierarchy will break
      if (($this->interface_data[main] != $this->form_data[main]) ||
          ($this->interface_data[parent] != $this->form_data[parent])) {
        $sql = "select $ccol[id] from $dbt[forum_category] where $ccol[parent] = $cid_q";
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        if (isset($result->fields[0]) && $result->fields[0] >= '') {
          $error .= "Modifying this entry will disconnect the category hierarchy.";
          $save = false;
        }
      }
      if ($this->form_data[id] == $this->form_data[parent]) {
        $error .= "Category cannot be a parent of itself.";
        $save = false;
      }
      // If the parent has changed from original, check max ord and assign.
      if ($this->interface_data[parent] != $this->form_data[parent]) {
        $sql = <<<END_SQL
select max($ccol[ord]) 
from $dbt[forum_category]
where $ccol[parent] = $pid_q
END_SQL;
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        $this->form_data[ord] = $this->interface_data[ord] = $max_ord;
      }

        $ord_orig_q = $this->command->db_quote($this->interface_data[ord]);
        $ord_new_q = $this->command->db_quote($this->form_data[ord]);

        $sql = <<<END_SQL
select max($ccol[ord]) 
from $dbt[forum_category]
where $ccol[parent] = $pid_q
END_SQL;
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        $ord_max = $result->fields[0] + 1;
        $ord_max_q = $this->command->db_quote($ord_max);
        
        $sql = <<<END_SQL
select $ccol[id]
from $dbt[forum_category]
where $ccol[parent] = $pid_q
  and $ccol[ord] = $ord_new_q
END_SQL;
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        $new_id_q = $this->command->db_quote($result->fields[0]);

      if ($new_id_q == "''") {
        $this->form_data[ord] = $ord_max;
      } else {
        $sql = <<<END_SQL
update $dbt[forum_category]
set $ccol[ord] = $ord_max_q
where $ccol[id] = $new_id_q
END_SQL;
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
      }
      $sql = "update $dbt[forum_category] set ";

      unset ($this->form_data[name]);
      while (list($k,$v) = each ($this->form_data)) {
        $dbfields[] = "$ccol[$k] = " . $this->command->db_quote($v);
      }
      $sql .= join(',', $dbfields);
      $sql .= " where id = ". $this->command->db_quote($this->form_data[id]);

      if ($save == true) { $dbh->Execute($sql) ; }
      $dbh->ErrorMsg() ? $error .= "Forum category modification failed -- $sql -- " . $dbh->ErrorMsg() : '';
    } else {
      $error .= 'Form improperly submitted';
    }

    $this->interface_data[error] = $error;
    $this->operation = '';
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  
  function delete() {
    global $dbh, $config, $userinfo;
    $this->theme->assign('idata', $this->interface_data);

  }

  function doDelete() {
    global $dbh, $config, $userinfo;
    $dbt = $this->command->DBGetTables();
    $ccol = &$dbt[forum_category_column];

    if ($this->interface_data[id] == $this->form_data[id]) { // Make sure we update self.
      $checkflag = true;
      $ids = array($this->interface_data[id]);
      while ($checkflag) {
        $id_list = join (",", $ids);
        $sql = "select $ccol[id] from $dbt[forum_category] where $ccol[parent] in ($id_list)";
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        if (isset($result->fields[0]) && $result->fields[0] > 0) {
          $ids = array();
          while ($data = $result->fields) {
            $result->MoveNext();
            $ids[] = $data[id];
          }
        } else {
          $checkflag = false;
        }
        $sql = "delete from $dbt[forum_category] where $ccol[id] in ($id_list)";
        $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
      }

      // Now we need to reorder everything
      $cid_q = $this->command->db_quote($this->interface_data[parent]);
      $sql = "select $ccol[id], $ccol[ord] from $dbt[forum_category] where $ccol[parent] = $cid_q";
      $result_o = $dbh->Execute($sql) or $this->interface_data[error] .= "Cannot fix category order after delete.\n";
      while ($odata = $result_o->fields) {
        $result_o->MoveNext();
        if ($odata[ord] > $this->interface_data[ord]) {
           $sql = "update $dbt[forum_category] set $ccol[ord] = $ccol[ord] - 1 where $ccol[id] = $odata[id]";
           $dbh->Execute($sql) or $this->interface_data[error] .= "Cannot fix category order after delete.\n";
        }
      }

      
    } else {
      $error .= 'Form improperly submitted';
    }

    $this->interface_data[error] = $error;
    $this->operation = '';
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  
  function sort() {
    global $dbh, $config, $userinfo;
    
    $dbt = $this->command->DBGetTables();
    $ccol = &$dbt[forum_category_column];
    
    if (isset($this->interface_data[id])){
      $pid_q = $this->command->db_quote($this->interface_data[parent]);
      $cid_q = $this->command->db_quote($this->interface_data[id]);
      $sql = <<<END_SQL
select $ccol[id], $ccol[ord] 
from $dbt[forum_category] 
where $ccol[parent] = $pid_q 
  and $ccol[id] <> $cid_q
order by $ccol[ord]
END_SQL;
      $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");;
      if (empty($result->fields[id]) && $this->form_data[sort] != 'demote'){
        $this->operation = '';
        $this->Initialize();
        return;
      }
      
      $update_flag = false;
      if ($this->form_data[sort] == 'up') {
        $this->interface_data[ord] = ($this->interface_data[ord] - 1 >= 1) ? $this->interface_data[ord] - 1 : $this->interface_data[ord];
        while($data = $result->fields) {
          if ($data[ord] == $this->interface_data[ord]) {
            $cid_q = $this->command->db_quote($data[id]);
            $sql = <<<END_SQL
update $dbt[forum_category]
set $ccol[ord] = $ccol[ord] + 1
where $ccol[id] = $cid_q
END_SQL;
            $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
            $update_flag = true;
          }
          $result->MoveNext();
        }
        if ($update_flag) {
          $ord_q = $this->command->db_quote($this->interface_data[ord]);
          $cid_q = $this->command->db_quote($this->interface_data[id]);
          $sql = <<<END_SQL
update $dbt[forum_category]
set $ccol[ord] = $ord_q
where $ccol[id] = $cid_q
END_SQL;
          $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        }
      } elseif ($this->form_data[sort] == 'down') {
        $this->interface_data[ord] = ($this->interface_data[ord] + 1 >= 1) ? $this->interface_data[ord] + 1 : $this->interface_data[ord];
        while($data = $result->fields) {
          if ($data[ord] == $this->interface_data[ord]) {
            $cid_q = $this->command->db_quote($data[id]);
            $sql = <<<END_SQL
update $dbt[forum_category]
set $ccol[ord] = $ccol[ord] - 1
where $ccol[id] = $cid_q
END_SQL;
            $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
            $update_flag = true;
          }
          $result->MoveNext();
        }
        if ($update_flag == true) {
          $ord_q = $this->command->db_quote($this->interface_data[ord]);
          $cid_q = $this->command->db_quote($this->interface_data[id]);
          $sql = <<<END_SQL
update $dbt[forum_category]
set $ccol[ord] = $ord_q
where $ccol[id] = $cid_q
END_SQL;
          $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        }
      } elseif ($this->form_data[sort] == 'demote') {
        // Check if the selected option has children.
        $sql = "select count($ccol[id]) from $dbt[forum_category] where $ccol[parent] = $cid_q";
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        
        // If children, return error.
        if ($result->fields[0] > 0) {
          $this->interface_data[error] .= "This category has child categories which must be deleted or moved before demoting.";
          $this->theme->assign('idata', $this->interface_data);
          $this->operation = '';
          $this->Initialize();
          return;
        }
        
        // Determine new parent level.
        $sql = "select parent from $dbt[forum_category] where $ccol[id] = $pid_q";
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        $newpid = $result->fields[0];
        $newpid_q = $this->command->db_quote($newpid);
        
        // Determine max order for parent level.
        $sql = "select max($ccol[ord]) from $dbt[forum_category] where $ccol[parent] = $newpid_q";
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        $max_ord = $result->fields[0] + 1;
        $max_ord_q = $this->command->db_quote($max_ord);
  
        // If Parent is 0, main becomes the id of the entry
        $newmain = ($newpid == 0) ? $this->interface_data[id] : $this->interface_data[main];
        $newmain_q = $this->command->db_quote($newmain);
  
        // Set selection to new values & level.
        $sql = <<<END_HTML
update $dbt[forum_category]
set $ccol[parent] = $newpid_q,
  $ccol[ord] = $max_ord_q,
  $ccol[main] = $newmain_q
where $ccol[id] = $cid_q
END_HTML;
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
      } else {
        $this->interface_data[error] .= 'Unknown sort type.';
      }
    }
    $this->operation = '';
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }  
}

/*
* Interface Initialization
*/
$gui = new LocalInterface();

$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;

$gui->Initialize();
if ($gui->interface_data[board][security] > $gui->interface_data[user_security] ) {
    $gui->command->noAccess('You do not have a high enough security level on this forum to view or modify posts.');
}

//$gui->urls = $gui->command->buildURL( array(mode => $gui->interface_data[mode], view => $gui->interface_data[view], sort_ord => $gui->interface_data[sort_ord], sort_by => $gui->interface_data[sort_by], page => $gui->interface_data[page], id => $gui->form_data[id], board => $gui->interface_data[board][id]), 'post.php', "$config[site_url]/plugins/forum", array('search','preview','add','edit','submit','view'));
/*-----------------------------------------------------------------------------
* Operation Logic
*/
if (preg_match("/^search/i", $operation)) {
  $gui->view();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  // If an operation does not require input validation, it is placed first.
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    // Once the form data is placed, it can be validated. 
    // The validation is interface dependent.
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } 
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'preview') {
      $gui->preview;
    } elseif ($form__operation == 'sort') {
      $gui->sort;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^sort/", $operation)) {
  $gui->sort();
} elseif (preg_match("/^preview/", $operation)) {
  $gui->preview();
} else {
	$gui->view();
}

/*-----------------------------------------------------------------------------
* Interface Display
*    Once the operations (if any) are complete, the display method is called.
*    this enacts the object's theme to display its appropriate blocks.
*/
print $gui->display();
$gui->Finalize();
?>
