<?php
class PluginMethodFactory extends MethodFactory {
    var $theme;
    var $gui;
    
    function PluginMethodFactory() {
       $this->MethodFactory();
    }

    function getUserRead($bid, $uid = ''){
      global $dbh, $config, $userinfo;
    
      $dbtable = $this->DBGetTables();
      $uid = ($uid == '') ? $userinfo[id] : $uid;
      $uid_q = $this->db_quote($uid);
      $bid_q = $this->db_quote($bid);
      $cols = $dbtable[forum_post_read_column];
      
      $userread = array(last_read_dt => '', max_read => '', read => array());
      $sql = <<<END_SQL
select $cols[last_read_dt], $cols[max_read], $cols[done_read] from 
$dbtable[forum_post_read]
where $cols[uid] = $uid_q
and $cols[bid] = $bid_q
END_SQL;
      $result = $dbh->Execute($sql) or die ("USERREAD: $sql " . $dbh->ErrorMsg());
      $userread = $result->fields;
      
      $read_array = unserialize($userread[done_read]);
      $userread[read] = $read_array;
      unset ($userread[done_read]);
      
      return $userread;
    }
    
    function setUserRead($bid, $ur, $uid = '') {
        global $dbh, $config, $userinfo;
        $dbtable = $this->DBGetTables();
        $uid = ($uid == '') ? $userinfo[id] : $uid;
        $uid_q = $this->db_quote($uid);
        $bid_q = $this->db_quote($bid);

        $max_q = $this->db_quote($ur[max_read]);
        $read_q = $this->db_quote(serialize($ur[read]));
        $date_q = $this->db_quote($this->formatUNIXTimeStamp());

        $cols = $dbtable[forum_post_read_column];
        if (isset($ur[last_read_dt]) && $ur[last_read_dt] != '') {
            $sql = <<<END_SQL
update $dbtable[forum_post_read]
set $cols[last_read_dt] = $date_q,
$cols[max_read] = $max_q,
$cols[done_read] = $read_q
where $cols[uid] = $uid_q
and $cols[bid] = $bid_q
END_SQL;
        } else {
            $date_q = $this->db_quote($this->formatUNIXTimeStamp());
            $sql = <<<END_SQL
INSERT into $dbtable[forum_post_read]
($cols[uid], $cols[bid], $cols[last_read_dt], $cols[max_read], $cols[done_read])
values
($uid_q, $bid_q, $date_q, $max_q, $read_q)
END_SQL;
        }
        $dbh->Execute($sql) or $this->interface_data[error] .= "USERREAD: $sql" . $dbh->ErrorMsg();
    }

    function getModerator($bid) {
      global $dbh, $config, $userinfo;
    
      $dbtable = $this->DBGetTables();
      $bid_q = $this->db_quote($bid);
     
      $mcols = $dbtable[forum_board_mod_column];
      $ucols = $dbtable[users_column];
      $sql = <<<END_SQL
select $mcols[uid], u.name, u.username
from $dbtable[forum_board_mod], users u
where $mcols[uid] = u.id
and $mcols[bid] = $bid_q
END_SQL;
      $result = $dbh->Execute($sql) or die ("GETMOD: $sql " . $dbh->ErrorMsg());
  
      if (empty($result->fields[uid])) {
        return array("None");
      } elseif ($result->RecordCount() > 1) {
        while ($udata = $result->fields[uid]) {
          $uids[$udata[uid]] = 1;
          $result->MoveNext();
        }
        return array("Group Access", $uids);
      } else {
        $uids[$result->fields[uid]] = 1;
        return (isset($result->fields[name]) && $result->fields[name] != '') ? array($result->fields[name], $uids) : array($result->fields[username], $uids);
      }
    }

  function &showReplies($parent, $indent, &$color, &$userread, $myself = '') {
    global $dbh, $config, $userinfo, $gui;
  
    $dbtable = $this->DBGetTables();
    $pcol = &$dbtable[forum_post_column];

    $out = '';
    $indent++;

    $bdata = &$gui->interface_data[board];
  
    $sql = <<<END_SQL
  SELECT $pcol[id], $pcol[parent], $pcol[post_dt],$pcol[uid], $pcol[subject], $pcol[status_flg]
  FROM $dbtable[forum_post]
  WHERE $pcol[parent] = $parent 
  AND $pcol[bid] = $bdata[id]
  ORDER BY $pcol[id] desc
END_SQL;
    $result = $dbh->Execute($sql) or die ("Query syntax error: " . $dbh->ErrorMsg() . ". Query: $sql");
  
  	while ($rdata = $result->fields) {
  		$result->MoveNext();    
  	//list($Number,$Parent,$Posted,$Username,$Subject,$Open) = mysql_fetch_array($sth);
  		$out .= <<<END_HTML
  	<tr class="$color">
  		<td class="forum_brd_postsubject">
END_HTML;
  		for ($y = 0; $y < $indent; $y++){
  	    $out .= "<img alt=\".\" src=\"$config[site_url]/plugins/forum/images/blank.gif\">";
  		}
  		$post_time = $this->formatDBTimestamp($rdata[post_dt]);
  		$folder = "closedfolder.gif";
  		$alt     = ".";
  
  		if(empty($userread[read][$rdata[id]])) {
  	    $alt    = "*";
  	    $folder = "newclosedfolder.gif";
  		} 
  		if ($rdata[status_flg] == "C") { 
  	    $alt    = "-";
  	    $folder = "lock.gif"; 
  		}
  
  		if( $rdata[id] == $myself ) {
  	    $out .= "<img src=\"$config[site_url]/plugins/forum/images/$folder\" alt =$alt hspace=5><b>$rdata[subject]</b>";
  		} else {
  	    $out .= "<img alt=$alt src=\"$config[site_url]/plugins/forum/images/$folder\" hspace=5><a href=\"$config[site_url]/plugins/forum/post.php?operation=view&form_board=$bdata[id]&form_id=$rdata[id]&form_page={$gui->interface_data[page]}#Post$rdata[id]\">$rdata[subject]</a>";
  		}
  		if (empty($rdata[uid]) || $rdata[uid] == 0){
  	    $out .= "</td><td width=\"20%\" class=\"forum_brd_postauthor\">Anonymous</td>";
  		} else {
        $username = $this->getUserName($rdata[uid]);
  	    $out .= "</td><td width=\"20%\" class=\"forum_brd_postauthor\"><a href=\"$config[site_url]/plugins/user/userlist.php?operation=view&form_id=$rdata[uid]&form_from_page=forum\">$username</a></td>";
      }
  		$out .= "<td width=\"20%\" class=\"forum_brd_posttime\">$post_time</td></tr>";
  
      # alternate the colors
  		if ($color == "forum_light") {
  		    $color = "forum_dark";
  		} else {
  		    $color = "forum_light";
  		}
  
  		$sql = "SELECT count($pcol[id]) as followup FROM $dbtable[forum_post] WHERE $pcol[parent] = $rdata[id]";
  		$result_f = $dbh->Execute($sql) or die ("Query syntax error: " . $dbh->ErrorMsg . ". Query: $sql");
  		if ($result_f->fields[followup] > 0) {
  	    $out .= $this->showReplies($rdata[id], $indent, $color, $userread, $myself);
  		}
    }
  	$indent--;
    return $out;
  }
  
  function createJumpbox() {
    global $dbh, $config, $userinfo, $gui;
  
    $dbtable = $this->DBGetTables();
    $bcol = &$dbtable[forum_board_column];
    $forum_security = (empty($userinfo[forum][security_level])) ? $config[forum][anon_security] : $userinfo[forum][security_level];
  
    $sql = <<<END_SQL
  SELECT $bcol[id],$bcol[title]
  FROM $dbtable[forum_board]
  WHERE $bcol[security] <= $forum_security
  ORDER BY $bcol[title]
END_SQL;
    $result = $dbh->Execute($sql) or die ("Query syntax error: " . $dbh->ErrorMsg() . ". Query: $sql");
    $jumpbox = <<<END_HTML
  <FORM METHOD=POST action="$config[site_url]/plugins/forum/index.php">
  <input type="hidden" name="operation" value="list">
  Jump to <select name="form_board">
END_HTML;
    while ($jdata = $result->fields) {
        $result->MoveNext();
  		if ($jdata[id] == $gui->interface_data[board][id]) { continue; }
    	$jumpbox .= "<option value=\"$jdata[id]\">$jdata[title]\n";
    }
  	$jumpbox .= "</select><INPUT TYPE=submit name=jump value=Go></form>";
  	return $jumpbox;	
  }
  function formatDBTimestamp($time, $parent = false) {
    //global $datetime, $locale;
    //setlocale ("LC_TIME", "$locale");
    if ($time == '30010101000000') {
        return 'Never';
    }
    preg_match("/([0-9]{4})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})/", $time, $datetime);
    $datemake = mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]);
    if (!$parent) {
        $datetran = "%d-%b-%Y<br>%H:%M:%S %p";
    } else {
        $datetran = $this->language->translate("datestring");
    } 
    $datetime = strftime($datetran, $datemake);
    $datetime = ucfirst($datetime);
    return($datetime);
  }

    function postStatus ($id) {
        global $dbh, $config, $userinfo;
  
        $dbtable = $this->DBGetTables();
        $pcol = &$dbtable[forum_post_column];
        $id_q = $this->db_quote($id);
        $sql = "select $pcol[status_flg] from $dbtable[forum_post] where $pcol[id] = $id_q";
        $result = $dbh->Execute($sql);
        return $result->fields[status_flg];
    }
    function postExists() {
        global $dbh, $config, $userinfo;
        $sid = session_id();
        
        $dbtable = $this->DBGetTables();
        $pcol = &$dbtable[forum_post_column];
        $sid_q = $this->db_quote($sid);
        $sql = "select max($pcol[post_dt]) from $dbtable[forum_post] where $pcol[sid] = $sid_q";
        $result = $dbh->Execute($sql);
        
        if ($this->calculateSeconds($result->fields[0], $this->formatUNIXTimeStamp()) < $config[forum][post_timeout]) {
            return true;
        } else {
            return false;
        }
    }
}

?>
