<?php
/*
* Forums Index Interface
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin.forum';    // Plugin Name
include_once("../../../function.php");

$interface = 'admin.forum'; 
$interface_title = 'DarkPortal - Forums Administration';
$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/

if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Interface 
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
	function initializeLocal() {
        global $dbh;
        global $config; 
        global $userinfo;

        $dbtable = $this->command->DBGetTables(); 
        $bcol = &$dbtable[forum_board_column];  
        $pcol = &$dbtable[forum_post_column];  

        // DEFAULT Viewing Mode
        if (isset($this->form_data[mode])) {
          $this->interface_data[mode] = $this->form_data[mode];
        } elseif (isset($userinfo[forum][post_view]) ) { 
          $this->interface_data[mode] = $userinfo[forum][post_view]; 
        } else {
          $this->interface_data[mode] = $config[forum][post_view]; 
        }  
        // DEFAULT Sort By Column
        if (isset($this->form_data[sort_by])) {
          $this->interface_data[sort_by] = $this->form_data[sort_by];
        } elseif (isset($userinfo[forum][sort_by]) ) {
          $this->interface_data[sort_by] = $userinfo[forum][sort_by];
        } else {
          $this->interface_data[sort_by] = $config[forum][sort_by];
        }
        // DEFAULT Sorting Order
        if (isset($this->form_data[sort_ord])) {
          $this->interface_data[sort_ord] = $this->form_data[sort_ord];
        } elseif (isset($userinfo[forum][sort_ord]) ) {
          $this->interface_data[sort_ord] = $userinfo[forum][sort_ord];
        } else {
          $this->interface_data[sort_ord] = $config[forum][sort_ord];
        }
        // DEFAULT Post View Mode
        if (isset($this->form_data[view])) {
          $this->interface_data[view] = $this->form_data[view];
        } elseif (isset($userinfo[forum][threaded]) ) {
          $this->interface_data[view] = $userinfo[forum][threaded];
        } else {
          $this->interface_data[view] = $config[forum][threaded];
        }
        // DEFAULT Security Level
        $this->interface_data[user_security] = (empty($userinfo[forum][security_level])) ? $config[forum][anon_security] : $userinfo[forum][security_level]; 
        // DEFAULT Page to view
        $this->interface_data[page] = (!$this->form_data[page]) ? 0 : $this->form_data[page];
        

        if (isset($this->form_data[board])) {
            $board_q = $this->form_data[board];

            $posts_per_page = (empty($userinfo[forum][posts_per_page])) ? $config[forum][posts_per_page] : $userinfo[forum][posts_per_page]; 
            if ($this->interface_data[page] < 1){ 
                $total_posts_tograb = 2 + $posts_per_page ; 
            } else { 
                $start_at_post = $this->interface_data[page] * ($posts_per_page - 1); 
                $number_of_posts = $posts_per_page + 2; 
                $total_posts_tograb = "$start_at_post, $number_of_posts "; 
            } 
            if ($config[forum][post_dateslip] && $this->interface_data[sort_by] == 'date') { 
                $post_sort_by = $pcol[last_post_dt]; 
            } else { 
                $post_sort_by = $pcol[post_dt]; 
            } 
            $sql = <<<END_SQL
SELECT $pcol[id], $pcol[uid], $pcol[subject], $pcol[post_dt] 
FROM $dbtable[forum_post] 
WHERE $pcol[id] = $pcol[main]
and $pcol[bid] = $board_q
ORDER BY $post_sort_by {$this->interface_data[sort_ord]}
LIMIT $total_posts_tograb 
END_SQL;
            $this->interface_data[post_mains] = $dbh->Execute ($sql) or die ("Query syntax error: " . mysql_error() . ". Query: $sql"); 
    
            $sql = <<<END_SQL
SELECT $bcol[id], $bcol[name], $bcol[title], $bcol[locked_dt], 
    $bcol[last_post_dt], $bcol[html_flg], $bcol[anon_flg], 
    $bcol[markup_flg], $bcol[security]
FROM $dbtable[forum_board]
WHERE $bcol[id] = $board_q
END_SQL;
            $result = $dbh->Execute($sql) or die ("Query syntax error: " . $dbh->ErrorMsg() . ". Query: $sql");
            $this->interface_data[board] = $result->fields;
            $this->interface_data[userread] = $this->command->getUserRead($result->fields[id]);
            $result->Close(); 
        }

        $this->theme->assign('idata', $this->interface_data);
	}
    function finalizeLocal() {
/*        global $userinfo;
        $userinfo[SAVE_PLUGIN] = true;
        if (isset($this->interface_data[board][id]) && $this->interface_data[board][id] != ''){
            $this->command->setUserRead($this->interface_data[board][id], $this->interface_data[userread]);
        }*/
    }

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
  }

  function list_posts() {
  }


###########################################################################
# show replies - list the replies here if we are doing threaded, expanded
###########################################################################

  function show_replies($bid, $b_table, $Mother, $indent, $class) {
    global $dbh;
    global $config;

    $sql = "SELECT id, parent, post_dt, uid, subject, status_flg FROM $b_table WHERE parent = $Mother ORDER BY id Desc";
    $result = $dbh->Execute($sql) or die ("Query syntax error: " . $dbh->ErrorMsg() . ". Query: $sql");
    //$followups = mysql_num_rows($sth);
  
    $indent++;
    
    while ($reply_data = $result->fields) {
      $result->MoveNext();
    # alternate the colors

    //for($x = 0; $x < $followups; $x++){
    	for ($y = 0; $y < $indent; $y++){
  	    $indent_img .= "<img alt=\".\" src=\"$config[site_url]/plugins/forum/images/blank.gif\">";
	    }
    	$time = $this->command->formatDBTimestamp($reply_data[post_dt]);
    	$folder = "closedfolder.gif";
    	$alt     = ".";
    	$thisone = ",$Number,";
    
    	if( ($reply_data[post_dt] > $unread) && (!preg_match("/$thisone/",$read))) {
  	    $alt    = "*";
  	    $folder = "newclosedfolder.gif";
    	} else {
	      $alt    = ".";
  	    $folder = "closedfolder.gif";
	    }
    	if ($reply_data[status_flg] == 0) { 
  	    $alt    = "-";
	      $folder = "lock.gif"; 
	    }

      if ($reply_data[uid] == 0){
	      $Username = "Anonymous";
	    } else {
	      $Username = $this->command->getUserName($reply_data[uid]);
	      $Username = "<a href=\"$config[site_url]/plugins/forum/showprofile.php?form_id=$reply_data[uid]&form_board=$brd_data[id]&form_page={$this->form_data[page]}&form_view={$this->interface_data[view]}&form_sort_by={$this->interface_data[sort_by]}&form_sort_ord={$this->interface_data[sort_ord]}\">$Username</a>";
      }

	    $sql = "SELECT count(id) FROM $b_table WHERE Parent = $reply_data[id]";
    	$result_a = $dbh->Execute($sql) or die ("Query syntax error: " . $dbh->ErrorMsg() . ". Query: $sql");
	    $follows = $result_a->fields[0];
      $result_a->Close();
	    if ($follows > 0) {
	      list($out_reply, $class) = $this->show_replies($bid, $b_table, $reply_data[id],$indent,$class);
	    }
	    if ($class == 'forum_light') {
	      $class = 'forum_dark';
	    } else {
	      $class = 'forum_light';
	    }
			$out .= <<<END_HTML
	<tr class="$class">
		<td class="forum_brd_postsubject">
			$indent_img
			<img alt="$alt" src="$config[site_url]/plugins/forum/images/$folder" hspace="5">
			<a href="$config[site_url]/plugins/forum/post.php?form_board=$bid&form_id=$reply_data[id]&form_page={$this->interface_data[page]}&form_view={$this->interface_data[view]}&form_sort_by={$this->interface_data[sort_by]}&form_sort_ord={$this->interface_data[sort_ord]}">
				$reply_data[subject]
			</a>
		</td>
		<td class="forum_brd_postauthor">
		  $Username
		</td>
		<td class="forum_brd_posttime">
			$time
		</td>
	</tr>
$out_reply
END_HTML;
    }

    $indent--;
    $result->Close();
    return array($out, $class);
  }

} // End Class

/*
* Interface Initialization
*/
$gui = new LocalInterface();

if ($operation == 'list') {
	$gui->search[id] = $form_board;
	$gui->search[key] = 'forum_board';
	$gui->search[name] = 'id';
}
$gui->Initialize();

/*-----------------------------------------------------------------------------
* Operation Logic
*/

if ($operation == 'list') {
	$gui->list_posts();
}   

/*-----------------------------------------------------------------------------
* Interface Display
*/
print $gui->display();
$gui->Finalize();

?>
