<?php
// TODO: Add file uploading for posts.
/*
* Local Interface
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin.forum';    // Plugin Name
include_once("../../../function.php");

$interface = 'admin.forum.post'; 
$interface_title = 'DarkPortal - Forum Post Manager';
$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Forum Post Interface 
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
  function initializeLocal() {
        global $dbh;
        global $userinfo;
        global $config;
        
        $dbtable = $this->command->DBGetTables(); 
        $bcol = &$dbtable[forum_board_column];  
        $pcol = &$dbtable[forum_post_column];  
        // Set default interface options
        // DEFAULT Viewing Mode
        if (isset($this->form_data[mode])) {
          $this->interface_data[mode] = $this->form_data[mode];
        } elseif (isset($userinfo[forum][post_view]) ) { 
          $this->interface_data[mode] = $userinfo[forum][post_view]; 
        } else {
          $this->interface_data[mode] = $config[forum][post_view];
        }  
        // DEFAULT Sort By Column
        if (isset($this->form_data[sort_by])) {
          $this->interface_data[sort_by] = $this->form_data[sort_by];
        } elseif (isset($userinfo[forum][sort_by]) ) {
          $this->interface_data[sort_by] = $userinfo[forum][sort_by];
        } else {
          $this->interface_data[sort_by] = $config[forum][sort_by];
        }
        // DEFAULT Sorting Order
        if (isset($this->form_data[sort_ord])) {
          $this->interface_data[sort_ord] = $this->form_data[sort_ord];
        } elseif (isset($userinfo[forum][sort_ord]) ) {
          $this->interface_data[sort_ord] = $userinfo[forum][sort_ord];
        } else {
          $this->interface_data[sort_ord] = $config[forum][sort_ord];
        }
        // DEFAULT Post View Mode
        if (isset($this->form_data[view])) {
          $this->interface_data[view] = $this->form_data[view];
        } elseif (isset($userinfo[forum][threaded]) ) {
          $this->interface_data[view] = $userinfo[forum][threaded];
        } else {
          $this->interface_data[view] = $config[forum][threaded];
        }
         // DEFAULT Security Level
        $this->interface_data[user_security] = (empty($userinfo[forum][security_level])) ? $config[forum][anon_security] : $userinfo[forum][security_level]; 
        // DEFAULT Page to view
        $this->interface_data[page] = (!$this->form_data[page]) ? 0 : $this->form_data[page];
        
        //if ($this->interface_data[user_security] < $bdata[security]) { 
        // $this->command->noaccess("You do not have a high enough security level to view this board."); 
        //
    
        // Read the user's read post data.
        $this->interface_data[userread] = $this->command->getUserRead($this->form_data[board]); 
        list($this->interface_data[moderator_info], $this->interface_data[moderator_ids]) = $this->command->getModerator($this->form_data[board]);
    
        if (isset($this->interface_data[id]) && $this->interface_data[id] != '') {
          if (! preg_match('/preview/', $this->operation)) {
            $sql = <<<END_SQL
SELECT $pcol[id],$pcol[post_dt],$pcol[uid],$pcol[aid], $pcol[bid],
$pcol[ip_addr],$pcol[subject],$pcol[body], $pcol[parent],
$pcol[file], $pcol[status_flg], $pcol[main] ,$pcol[last_post_dt],
$pcol[expire_dt], $pcol[modify_by], $pcol[modify_dt], $pcol[comment],
$pcol[icon]
FROM $dbtable[forum_post] 
WHERE $pcol[id] = {$this->interface_data[id]}
END_SQL;
            $result = $dbh->Execute ($sql) or die ("Query Syntax Error: " . mysql_error() . ". Query: $sql"); 
            $this->interface_data[post_data] = $result->fields;
          }
        // Load a definition of the board.
        $bid_q = $this->command->db_quote($this->interface_data[bid]);
        $sql= <<<END_SQL
    SELECT *
    FROM $dbtable[forum_board]
    WHERE $bcol[id] = {$this->interface_data[post_data][bid]}
END_SQL;
        $result = $dbh->Execute($sql) or die ("Query Syntax Error: " . $dbh->ErrorMsg() . ". Query: $sql");
        $this->interface_data[board] = $result->fields;

          $sql = <<<END_SQL
SELECT count($pcol[id]) as reply 
FROM $dbtable[forum_post] 
WHERE $pcol[main] = {$this->interface_data[post_data][main]}
END_SQL;
          $result = $dbh->Execute ($sql) or $this->interface_data[error] .= ("Query Syntax Error: " . mysql_error() . ". Query: $sql"); 
          $this->interface_data[reply_count] = $result->fields[reply];
          
          if ($config[forum][post_dateslip] && $this->interface_data[sort_by] == 'date') { 
            $post_sort_by = $pcol[last_post_dt]; 
          } else { 
            $post_sort_by = $pcol[post_dt]; 
          } 
          $posts_per_page = (empty($userinfo[forum][posts_per_page])) ? $config[forum][posts_per_page] : $userinfo[forum][posts_per_page]; 
          if ($this->interface_data[page] < 1){ 
            $total_posts_tograb = $posts_per_page + 2; 
          } else { 
            $start_at_post = $this->interface_data[page] * ($posts_per_page - 1); 
            $number_of_posts = $posts_per_page + 2; 
            $total_posts_tograb = "$start_at_post, $number_of_posts "; 
          } 
          $sql = <<<END_SQL
SELECT $pcol[id], $pcol[uid], $pcol[aid], $pcol[subject], $pcol[post_dt] 
FROM $dbtable[forum_post] 
WHERE $pcol[id] = $pcol[main]
  and $pcol[bid] = $bid_q
ORDER BY $post_sort_by {$this->interface_data[sort_ord]}
LIMIT $total_posts_tograb 
END_SQL;
          $this->interface_data[post_mains] = $dbh->Execute ($sql) or die ("Query syntax error: " . mysql_error() . ". Query: $sql"); 

          $sql = <<<END_SQL
SELECT $pcol[id],$pcol[post_dt],$pcol[uid], $pcol[aid], $pcol[ip_addr],$pcol[subject],$pcol[body],$pcol[file],$pcol[status_flg] 
FROM $dbtable[forum_post] 
WHERE $pcol[main] = {$this->interface_data[post_data][main]}
ORDER BY $pcol[id] 
END_SQL;
          $this->interface_data[post_posts] = $dbh->Execute ($sql) or print ("Query syntax error: " . mysql_error() . ". Query: $sql"); 
      
        }
        $userinfo[forum][threaded] = $this->interface_data[view];
        $userinfo[forum][post_view] = $this->interface_data[mode];
        $userinfo[forum][sort_by] = $this->interface_data[sort_by];
        $userinfo[forum][sort_ord] = $this->interface_data[sort_ord];
        
        $this->theme = $this->resetTheme();
    //$this->interface_data = array_merge($this->interface_data, $result->fields);
  }

    function finalizeLocal() {
/*        global $userinfo;
        $userinfo[SAVE_PLUGIN] = true;
        if (isset($this->interface_data[board][id]) && $this->interface_data[board][id] != ''){
            $this->command->setUserRead($this->interface_data[board][id], $this->interface_data[userread]);
        }*/
    }

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;
    $theme->assign('idata', $this->interface_data);
  }

	function view() {
    global $dbh, $userinfo, $config;
	}

  function preview($oper) {
    global $dbh, $userinfo, $config;
    $dbtable = $this->command->DBGetTables(); 
    $pcol = &$dbtable[forum_post_column];  
    if ($this->form_data[saved_uid] != $this->form_data[uid]) {
      $this->interface_data[preview_suppress] = true;
    }
    $this->interface_data[post_data][bid] = (isset($this->form_data[board])) ? $this->form_data[board] : $this->interface_data[post_data][board];
    $this->interface_data[post_data][expire] = $this->form_data[expire];
    while (list($k, $v ) = each($pcol) ) {
      $this->interface_data[post_data][$k] = (isset($this->form_data[$k])) ? $this->form_data[$k] : $this->interface_data[post_data][$k];
    }
    
    $this->Initialize();
  }

  function add() {
    global $dbh, $userinfo, $config;
  }
  
  function doAdd() {
    global $dbh, $userinfo, $config;
    $dbt = $this->command->DBGetTables();
    $pcol = $dbt[forum_post_column];

    $dbh->Execute($sql) or $error = "Could not .. post: " . $dbh->ErrorMsg();
  }
  
  function edit() {
    global $dbh, $userinfo, $config;
  }
  
  function doEdit() {
    global $dbh, $userinfo, $config;
    $dbt = $this->command->DBGetTables();
    $pcol = $dbt[forum_post_column];

    if ($this->form_data[preview_post] == 1) {
      $this->operation = "edit.preview";
      $this->preview('edit.preview');
      return;
    }


    if ($this->interface_data[id] == $this->form_data[id]) {
      // Perform normal edit operation.
      $id_q = $this->command->db_quote($this->interface_data[id]);
      $dbcol = array();
      $dbcol[] = "$pcol[bid] = " . $this->command->db_quote($this->form_data[board]);
      if (isset($this->form_data[expire]) && 
        $this->form_data[expire] != '') {
        list($amount, $freq) = explode("|", $this->form_data[expire]);
        if ($amount == 0) {
          $expire_q = $this->command->db_quote('00000000000000');
        } else {
          $expire_q = $this->command->db_quote($this->command->manipulateTime($this->command->formatUNIXTimestamp, $amount, $freq));
        }
      } else {
        $expire_q = (isset($this->interface_data[post_data][expire_dt])) ? $this->command->db_quote($this->interface_data[post_data][expire_dt]) : $this->command->db_quote('00000000000000');
      }
      $dbcol[] = "$pcol[expire_dt] = $expire_q";
      $dbcol[] = "$pcol[modify_by] = " . $this->command->db_quote($userinfo[id]);
      $dbcol[] = "$pcol[modify_dt] = " . $this->command->db_quote($this->command->formatUNIXTimeStamp());

      while (list($k, $v) = each ($pcol)) {
        if (isset($this->form_data[$k]) && $this->form_data[$k] != '') {
          $dbcol[] = "$pcol[$k] = " . $this->command->db_quote($this->form_data[$k]);
        } 
      }
      $sql = "update $dbt[forum_post] set ";
      $sql .= implode(", ", $dbcol);
      $sql .= " where $pcol[id] = $id_q";
      $dbh->Execute($sql) or $error .= "Could not edit post: " . $dbh->ErrorMsg();
      // Check if we are moving the post to another board 
      if ($this->form_data[bid] != $this->interface_data[bid]) {
        $bid_q = $this->command->db_quote($this->form_data[board]);
        // If this is a main thread, then move all children
        if ($this->interface_data[parent] == 0) {
          $sql = "update $dbt[forum_post] set $pcol[bid] = $bid_q where $pcol[main] = $id_q";
          $dbh->Execute($sql) or $error .= "Could not edit post. Could not move children of root: " . $dbh->ErrorMsg();
          // If this is a child, 
        } else {
          // make the child a root in new bid
          $sql = "update $dbt[forum_post] set $pcol[main] = $id_q, $pcol[parent] = 0 where $pcol[id] = $id_q";
          $dbh->Execute($sql) or $error .= "Could not edit post. Could not set new root: " . $dbh->ErrorMsg();
          // move its replies.
          $sql = "select $pcol[id] from $dbt[forum_post] where $pcol[parent] = $id_q";
          $result = $dbh->Execute($sql) or $error .= "Could not edit post. Could find children: " . $dbh->ErrorMsg();
          $id_list = array();
          while ($data = $result->fields) {
            $result->MoveNext();
            $id_list[] = $data[id];
          }
          //Pull the value off the bottom of stack
          while ($v = array_shift($id_list)) {
            $newid_q = $this->command->db_quote($v);
            // Lookup for children
            $sql = "select $pcol[id] from $dbt[forum_post] where $pcol[parent] = $newid_q";
            $result = $dbh->Execute($sql) or $error .= "Could not edit post. Could find children: " . $dbh->ErrorMsg();
            // Add children to top of the stack
            while ($data = $result->fields) {
              $result->MoveNext();
              $id_list[] = $data[id];
            }
            // Update current record to new bID
            $sql = "update $dbt[forum_post] set $pcol[bid] = $bid_q, $pcol[main] = $id_q where $pcol[id] = $newid_q"; 
            $result = $dbh->Execute($sql) or $error .= "Could not edit post. Cannot update child bID: " . $dbh->ErrorMsg();
          }
        }
      }
    } else {
      $error .= "Form improperly submitted.";
    }
    if (isset($error) && $error !='') {
      $this->operation = 'edit.forum_post';
    } else {
      $this->operation = '';
    }
    $this->interface_data[error] = $error;
    $this->Initialize();
  }
  
  function delete() {
    global $dbh, $userinfo, $config;
  }

  function doDelete() {
    global $dbh, $userinfo, $config;
    $dbt = $this->command->DBGetTables();
    $pcol = $dbt[forum_post_column];

    if ($this->interface_data[id] == $this->form_data[id]) {
      $id_q = $this->command->db_quote($this->form_data[id]);
      $comment_q = $this->command->db_quote("Post deleted by " . $this->command->getUsername());
      $expired_q = $this->command->db_quote($this->command->formatUNIXTimestamp());
      $uid_q = $this->command->db_quote($userinfo[id]);

      $sql = "update $dbt[forum_post] set $pcol[comment] = $comment_q, $pcol[expire_dt] = $expired_q, $pcol[status_flg] = 5, $pcol[modify_by] = $uid_q where $pcol[id] = $id_q";
      $this->interface_data[error] = "Post deleted";
      $dbh->Execute($sql) or $this->interface_data[error] = ("Could not delete this post." . $sql); 
      
      // Allow delete of all replies to this post.
      if ($this->form_data[killposts] == 1) {
        $sql = "select $pcol[id] from $dbt[forum_post] where $pcol[parent] = $id_q";
        $result = $dbh->Execute();
        while ($data = $result->fields) {
          $result->MoveNext();
          $id_list[] = $data[id];
        }
        while ($v = array_shift($id_list)) {
          $newid_q = $this->command->db_quote($v);
          $sql = "select $pcol[id] from $dbt[forum_post] where $pcol[parent] = $newid_q";
          $result2 = $dbh->Execute();
          while ($data2 = $result2->fields) {
            $result2->MoveNext();
            $id_list[] = $data2[id];
          }

          $sql = "update $dbt[forum_post] set $pcol[comment] = $comment_q, $pcol[expire_dt] = $expire_q, $pcol[status_flg] = 5, $pcol[modify_by] = $uid_q where $pcol[id] = $newid_q";
          $dbh->Execute($sql) or $this->interface_data[error] = ("Could not delete reply post $id_q."); 
        }
      }
      
      // delete any file attachments for the post (should recycle).
      //if (isset($this->interface_data[file]) && $this->interface_data[file] != '') {
      //  unlink($this->interface_data[file]);
      //}

      $this->operation = '';
      $this->theme = $this->resetTheme();
    } else {
      $error .= "Form improperly submitted.";
    }
    $this->Initialize();
  }

  function approve() {
    global $dbh, $userinfo, $config;
  }
  
  function doApprove() {
    global $dbh, $userinfo, $config;
    $dbt = $this->command->DBGetTables();
    $pcol = $dbt[forum_post_column];

    if ($this->interface_data[id] == $this->form_data[id]) {
      $status_q = $this->command->db_quote(1);
      $comment_q = $this->command->db_quote($this->form_data[comment]);
      $id_q = $this->command->db_quote($this->form_data[id]);
      
      $sql = "update $dbt[forum_post] set $pcol[status_flg] = $status_q, $pcol[comment] = $comment_q where $pcol[id] = $id_q";
      $dbh->Execute($sql) or $error = "Could not approve post: " . $dbh->ErrorMsg();
    } else {
      $error .= "Form improperly submitted.";
    }
    $this->operation = '';
    $this->interface_data[error] = $error;
    $this->Initialize();
  }
  
  function reject() {
    global $dbh, $userinfo, $config;
  }
  
  function doReject() {
    global $dbh, $userinfo, $config;
    $dbt = $this->command->DBGetTables();
    $pcol = $dbt[forum_post_column];

    if ($this->interface_data[id] == $this->form_data[id]) {
      $status_q = $this->command->db_quote(4);
      $comment_q = $this->command->db_quote($this->form_data[comment]);
      $id_q = $this->command->db_quote($this->form_data[id]);
      
      $sql = "update $dbt[forum_post] set $pcol[status_flg] = $status_q, $pcol[comment] = $comment_q where $pcol[id] = $id_q";
      $dbh->Execute($sql) or $error = "Could not reject post: " . $dbh->ErrorMsg();
    } else {
      $error .= "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->Initialize();
  }
}

/*
* Interface Initialization
*/
$gui = new LocalInterface();

$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;

$gui->Initialize();
//if ($gui->interface_data[board][security] > $gui->interface_data[user_security] ) {
//    $gui->command->noAccess('You do not have a high enough security level on this forum to view or modify posts.');
//}

//$gui->urls = $gui->command->buildURL( array(mode => $gui->interface_data[mode], view => $gui->interface_data[view], sort_ord => $gui->interface_data[sort_ord], sort_by => $gui->interface_data[sort_by], page => $gui->interface_data[page], id => $gui->form_data[id], board => $gui->interface_data[board][id]), 'post.php', "$config[site_url]/plugins/forum", array('search','preview','add','edit','submit','view'));
/*-----------------------------------------------------------------------------
* Operation Logic
*/

if (preg_match("/^search/i", $operation)) {
  $gui->view();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  // If an operation does not require input validation, it is placed first.
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    // Once the form data is placed, it can be validated. 
    // The validation is interface dependent.
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'approve') {
      $gui->doApprove();
    } elseif ($form__operation == 'reject') {
      $gui->doReject();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'preview') {
      $gui->preview();
    } elseif ($form__operation == 'approve') {
      $gui->approve();
    } elseif ($form__operation == 'reject') {
      $gui->reject();
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^preview/", $operation)) {
  $gui->preview();
} elseif (preg_match("/^approve/", $operation)) {
  $gui->approve();
} elseif (preg_match("/^reject/", $operation)) {
  $gui->reject();
} else {
	$gui->view();
}
/*-----------------------------------------------------------------------------
* Interface Display
*    Once the operations (if any) are complete, the display method is called.
*    this enacts the object's theme to display its appropriate blocks.
*/
print $gui->display();
$gui->Finalize();
?>
