<?php
class PluginMethodFactory extends MethodFactory {
    var $theme;
    var $gui;
    
    function PluginMethodFactory() {
       $this->MethodFactory();
    }

    function getUserRead($bid, $uid = ''){
      global $dbh, $config, $userinfo;
    
      list($dbtable,$cols) = array_values($this->DBGetTable('forum_post_read'));
      $uid = ($uid == '') ? $userinfo[id] : $uid;
      $uid_q = $this->db_quote($uid);
      $bid_q = $this->db_quote($bid);
      
      $userread = array(last_read_dt => '', max_read => '', read => array());
      $sql = <<<END_SQL
select $cols[last_read_dt], $cols[max_read], $cols[done_read] from 
$dbtable
where $cols[uid] = $uid_q
and $cols[bid] = $bid_q
END_SQL;
      $result = $dbh->Execute($sql) or trigger_error("Cannot load previously read post list.",FATAL);
      $userread = $result->fields;
      
      $read_array = unserialize($userread[done_read]);
      $userread[read] = $read_array;
      unset ($userread[done_read]);
      
      return $userread;
    }
    
    function setUserRead($bid, $ur, $uid = '') {
        global $dbh, $config, $userinfo;
        list($dbtable,$cols) = array_values($this->DBGetTable('forum_post_read'));
        $uid = ($uid == '') ? $userinfo[id] : $uid;
        $uid_q = $this->db_quote($uid);
        $bid_q = $this->db_quote($bid);

        $max_q = $this->db_quote($ur[max_read]);
        $read_q = $this->db_quote(serialize($ur[read]));
        $date_q = $this->db_quote($this->formatUNIXTimeStamp());

        if (isset($ur[last_read_dt]) && $ur[last_read_dt] != '') {
            $sql = <<<END_SQL
update $dbtable
set $cols[last_read_dt] = $date_q,
$cols[max_read] = $max_q,
$cols[done_read] = $read_q
where $cols[uid] = $uid_q
and $cols[bid] = $bid_q
END_SQL;
        } else {
            $date_q = $this->db_quote($this->formatUNIXTimeStamp());
            $sql = <<<END_SQL
INSERT into $dbtable
($cols[uid], $cols[bid], $cols[last_read_dt], $cols[max_read], $cols[done_read])
values
($uid_q, $bid_q, $date_q, $max_q, $read_q)
END_SQL;
        }
        $dbh->Execute($sql) or trigger_error("Cannot write user read post list.",FATAL);
    }

    function getModerator($bid) {
      global $dbh, $config, $userinfo;
    
      list($dbt_mod, $mcols) = array_values($this->DBGetTable('forum_board_mod'));
      list($dbt_user, $ucols) = array_values($this->DBGetTable('users'));
      $bid_q = $this->db_quote($bid);
     
      $sql = <<<END_SQL
select $mcols[uid], $ucols[name], $ucols[username]
from $dbt_mod, $dbt_user
where $mcols[uid] = $ucols[id]
and $mcols[bid] = $bid_q
END_SQL;
      $result = $dbh->Execute($sql) or trigger_error('Cannot load moderator list for board.',FATAL);
  
      if (empty($result->fields[uid])) {
        return array("None");
      } elseif ($result->RecordCount() > 1) {
        while ($udata = $result->fields[uid]) {
          $uids[$udata[uid]] = 1;
          $result->MoveNext();
        }
        return array("Group Access", $uids);
      } else {
        $uids[$result->fields[uid]] = 1;
        return (isset($result->fields[name]) && $result->fields[name] != '') ? array($result->fields[name], $uids) : array($result->fields[username], $uids);
      }
    }

  function &showReplies($parent, $indent, &$color, &$userread, $myself = '') {
    global $dbh, $config, $userinfo, $gui;
  
    list($dbt_post, $pcol) = array_values($this->DBGetTable('forum_post')); 

    $out = '';
    $indent++;
    $bdata = &$gui->interface_data[board];
  
    $sql = <<<END_SQL
  SELECT $pcol[id], $pcol[parent], $pcol[post_dt],$pcol[uid], $pcol[aid], $pcol[subject], $pcol[status_flg]
  FROM $dbt_post
  WHERE $pcol[parent] = $parent 
  AND $pcol[bid] = $bdata[id]
  ORDER BY $pcol[id] desc
END_SQL;
    $result = $dbh->Execute($sql) or trigger_error("Cannot load reply posts for parent level", FATAL);
  
  	while ($rdata = $result->fields) {
  		$result->MoveNext();    
  		$out .= <<<END_HTML
  	<tr class="$color">
  		<td class="forum_post_treesubject">
END_HTML;
  		for ($y = 0; $y < $indent; $y++){
  	    $out .= "<img alt=\".\" src=\"$config[site_url]/$config[plugin_path]/images/blank.gif\">";
  		}
  		$post_time = $this->formatDBTimestamp($rdata[post_dt]);
  		$folder = "closedfolder.gif";
  		$alt     = ".";
  
  		if(empty($userread[read][$rdata[id]])) {
  	    $alt    = "*";
  	    $folder = "newclosedfolder.gif";
  		} 
  		if ($rdata[status_flg] == "C") { 
  	    $alt    = "-";
  	    $folder = "lock.gif"; 
  		}
  
  		if( $rdata[id] == $myself ) {
  	    $out .= "<img src=\"$config[site_url]/$config[plugin_path]/images/$folder\" alt =$alt hspace=5><b>$rdata[subject]</b>";
  		} else {
  	    $out .= "<img alt=$alt src=\"$config[site_url]/$config[plugin_path]/images/$folder\" hspace=5><a href=\"$config[site_url]/$config[plugin_path]/post.php?operation=view&form_board=$bdata[id]&form_id=$rdata[id]&form_page={$gui->interface_data[page]}#Post$rdata[id]\">$rdata[subject]</a>";
  		}
  		if (isset($rdata[aid]) && $rdata[aid] != 0){
          $author_name = $this->getNameFromID($rdata[aid], 'alias');
  	      $out .= "</td><td width=\"20%\" class=\"forum_post_treeauthor\">\n";
  	      $out .= ($rdata[aid] != $config[forum][anon_user_id]) ? "<a href=\"$config[site_url]/plugins/user/userlist.php?operation=view&form_id=$rdata[uid]&form_from_page=forum\">$author_name</a>\n" : $author_name;
  	      $out .= "</td>\n";
  		} else {
  	      $out .= "</td><td width=\"20%\" class=\"forum_post_treeauthor\">Unknown</td>";
        }
  		$out .= "<td width=\"20%\" class=\"forum_post_treedate\">$post_time</td></tr>";
  
      # alternate the colors
  		if ($color == "forum_light") {
  		    $color = "forum_dark";
  		} else {
  		    $color = "forum_light";
  		}
  
  		$sql = "SELECT count($pcol[id]) as followup FROM $dbt_post WHERE $pcol[parent] = $rdata[id]";
  		$result_f = $dbh->Execute($sql) or trigger_error("Cannot determine followup count for reply level.", FATAL);
  		if ($result_f->fields[followup] > 0) {
  	    $out .= $this->showReplies($rdata[id], $indent, $color, $userread, $myself);
  		}
    }
  	$indent--;
    return $out;
  }
  
  function createJumpbox($all_boards = false) {
    global $dbh, $config, $userinfo, $gui;
  
    list($dbt_board, $bcol) = array_values($this->DBGetTable('forum_board')); 
    $forum_security = (empty($userinfo[forum][security_level])) ? $config[forum][anon_security] : $userinfo[forum][security_level];
  
    $sql = <<<END_SQL
  SELECT $bcol[id],$bcol[title]
  FROM $dbt_board
  WHERE $bcol[security] <= $forum_security
  ORDER BY $bcol[title]
END_SQL;
    $result = $dbh->Execute($sql) or trigger_error("Cannot load board list for jumpbox.",FATAL);
    $jumpbox .= <<<END_HTML
  <FORM METHOD=GET action="$config[site_url]/$config[plugin_path]/index.php">
  <input type="hidden" name="operation" value="list">
  <select name="form_board">
  <option value="">Jump to...</option>
END_HTML;
    while ($jdata = $result->fields) {
      $result->MoveNext();
  		if (!$all_boards && $jdata[id] == $gui->interface_data[board][id]) { continue; }
      $jumpbox .= "<option value=\"$jdata[id]\">$jdata[title]</option>\n";
    }
  	$jumpbox .= "</select><INPUT TYPE=submit name=jump value=Go></form>";
  	return $jumpbox;	
  }
  function formatDBTimestamp($time = '', $parent = false) {
    if ($time == '') { $time = date("YmdHis", time()); }
    if ($time == '30010101000000') {
        return 'Never';
    }
    preg_match("/([0-9]{4})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})([0-9]{1,2})/", $time, $datetime);
    $datemake = mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]);
    if (!$parent) {
        $datetran = "%d-%b-%Y<br>%H:%M:%S %p";  
    } else {
        $datetran = $this->language->translate("datestring");
    } 
    $datetime = strftime($datetran, $datemake);
    $datetime = ucfirst($datetime);
    return($datetime);
  }

    function postStatus ($id) {
        global $dbh, $config, $userinfo;
  
        list($dbt_post, $pcol) = array_values($this->DBGetTable('forum_post')); 
        $id_q = $this->db_quote($id);
        $sql = "select $pcol[status_flg] from $dbt_post where $pcol[id] = $id_q";
        $result = $dbh->Execute($sql) or trigger_error('Cannot load post ($id) status',FATAL);
        return $result->fields[status_flg];
    }
    function postExists() {
        global $dbh, $config, $userinfo;
        $sid = session_id();
        
        list($dbt_post, $pcol) = array_values($this->DBGetTable('forum_post')); 
        $sid_q = $this->db_quote($sid);
        $sql = "select max($pcol[post_dt]) from $dbt_post where $pcol[sid] = $sid_q";
        $result = $dbh->Execute($sql) or trigger_error('Failed to check if post exists.',FATAL);
        
        if ($this->calculateSeconds($result->fields[0], $this->formatUNIXTimeStamp()) < $config[forum][post_timeout]) {
            return true;
        } else {
            return false;
        }
    }
}

?>
