<?php
/*
* Forums Index Interface
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'forum';    // Plugin Name
include_once("../../function.php");

$interface = 'forum'; 
$interface_title = 'DarkPortal - Forums';

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
/*
    if ($brd_data[security] > $user_security) {
			$this->not_right("You do not have a high enough Security level to view this board.");
    }
if (empty ($userinfo[groups][User])) {
  $reason = "You must be a ";
  include("$include_path/noaccess.php");
  exit;
}*/

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Interface 
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
	function initializeLocal() {
        global $dbh;
        global $config; 
        global $userinfo;

        list($dbt_board,$bcol) = array_values($this->command->DBGetTable('forum_board'));
        list($dbt_post,$pcol) = array_values($this->command->DBGetTable('forum_post'));

        // DEFAULT Viewing Mode
        if (isset($this->form_data[mode])) {
          $this->interface_data[mode] = $this->form_data[mode];
        } elseif (isset($userinfo[forum][post_view]) ) { 
          $this->interface_data[mode] = $userinfo[forum][post_view]; 
        } else {
          $this->interface_data[mode] = $config[forum][post_view]; 
        }  
        // DEFAULT Sort By Column
        if (isset($this->form_data[sort_by]) && $this->form_data[sort_by] != '') {
          $this->interface_data[sort_by] = $this->form_data[sort_by];
        } elseif (isset($userinfo[forum][sort_by]) && $userinfo[forum][sort_by] != '') {
          $this->interface_data[sort_by] = $userinfo[forum][sort_by];
        } else {
          $this->interface_data[sort_by] = $config[forum][sort_by];
        }
        
        // DEFAULT Sorting Order
        if (isset($this->form_data[sort_ord]) && $this->form_data[sort_ord] != '') {
          $this->interface_data[sort_ord] = $this->form_data[sort_ord];
        } elseif (isset($userinfo[forum][sort_ord]) && $userinfo[forum][sort_ord] != '') {
          $this->interface_data[sort_ord] = $userinfo[forum][sort_ord];
        } else {
          $this->interface_data[sort_ord] = $config[forum][sort_ord];
        }
        // DEFAULT Post View Mode
        if (isset($this->form_data[view])) {
          $this->interface_data[view] = $this->form_data[view];
        } elseif (isset($userinfo[forum][threaded]) ) {
          $this->interface_data[view] = $userinfo[forum][threaded];
        } else {
          $this->interface_data[view] = $config[forum][threaded];
        }
        // DEFAULT Security Level
        $this->interface_data[user_security] = (empty($userinfo[forum][security_level])) ? $config[forum][anon_security] : $userinfo[forum][security_level]; 
        // DEFAULT Page to view
        $this->interface_data[page] = (!$this->form_data[page]) ? 0 : $this->form_data[page];
        

        if (isset($this->form_data[board])) {
          list($this->interface_data[moderator_info], $this->interface_data[moderator_ids]) = $this->command->getModerator($this->form_data[board]);
          $board_q = $this->form_data[board];

          $this->interface_data[posts_per_page] = (empty($userinfo[forum][posts_per_page])) ? $config[forum][posts_per_page] : $userinfo[forum][posts_per_page]; 
          if ($this->interface_data[page] < 1){ 
            $this->interface_data[total_posts_tograb] = $this->interface_data[posts_per_page] + 1; 
          } else { 
            $start_at_post = $this->interface_data[page] * ($this->interface_data[posts_per_page] - 1); 
            $number_of_posts = $this->interface_data[posts_per_page] + 1; 
            $this->interface_data[total_posts_tograb] = "$start_at_post, $number_of_posts "; 
          } 
        $lookup_states = ($this->interface_data[moderator_ids][$userinfo[id]] == 1) ? '0,1,2,3,4' : '1,2';
        $sql = <<<END_SQL
SELECT $pcol[id], $pcol[uid], $pcol[aid], $pcol[subject], 
  $pcol[post_dt], $pcol[expire_dt], $pcol[modify_by], $pcol[status_flg],
  $pcol[views], $pcol[icon], $pcol[rating]
FROM $dbt_post
WHERE $pcol[id] = $pcol[main]
and $pcol[bid] = $board_q
and $pcol[status_flg] in ($lookup_states,5,0)
ORDER BY {$this->interface_data[sort_by]} {$this->interface_data[sort_ord]}
LIMIT {$this->interface_data[total_posts_tograb]}
END_SQL;
            $this->interface_data[post_mains] = $dbh->Execute ($sql) or trigger_error ("Could not load main post list.", FATAL); 
    
            $sql = <<<END_SQL
SELECT $bcol[id], $bcol[name], $bcol[title], $bcol[locked_dt], 
    $bcol[last_post_dt], $bcol[html_flg], $bcol[anon_flg], 
    $bcol[markup_flg], $bcol[security]
FROM $dbt_board
WHERE $bcol[id] = $board_q
END_SQL;
            $result = $dbh->Execute($sql) or trigger_error ("Cannot load board listing.", FATAL);
            $this->interface_data[board] = $result->fields;
            $this->interface_data[userread] = $this->command->getUserRead($result->fields[id]);
            $result->Close(); 
        }
        $this->theme->assign('idata', $this->interface_data);
	}
    function finalizeLocal() {
        global $userinfo;
        $userinfo[SAVE_PLUGIN] = true;
        if (isset($this->interface_data[board][id]) && $this->interface_data[board][id] != ''){
            $this->command->setUserRead($this->interface_data[board][id], $this->interface_data[userread]);
        }
    }

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
  }

  function list_posts() {
    global $dbh, $config, $userinfo;
    
    // Set expiry flags on any records that have passed.  
    list($dbt, $pcol) = array_values($this->command->DBGetTable('forum_post'));
    $expire_q = $this->command->db_quote($this->command->formatUNIXTimestamp());
    $sql = "update $dbt set $pcol[status_flg] = 3 where  ($pcol[expire_dt] <> '00000000000000' and $pcol[expire_dt] <= $expire_q)    and $pcol[status_flg] not in (3,5)";
    $dbh->Execute($sql) or trigger_error ('Thread expiry failed.', WARN);
    $this->resetTheme();
  }


###########################################################################
# show replies - list the replies here if we are doing threaded, expanded
###########################################################################

} // End Class

/*
* Interface Initialization
*/
$gui = new LocalInterface();

if ($operation == 'list') {
	$gui->search[id] = $form_board;
	$gui->search[key] = 'forum_board';
	$gui->search[name] = 'id';
}
$gui->Initialize();

/*-----------------------------------------------------------------------------
* Operation Logic
*/

if ($operation == 'list') {
	$gui->list_posts();
}   

/*-----------------------------------------------------------------------------
* Interface Display
*/
print $gui->display();
$gui->Finalize();

?>
