<?php
/*
* Local Interface
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/

/**
* Initializing the Interface classes
*/
$plugin = 'forum';    // Plugin Name
include_once("../../function.php");

$interface = 'forum.post'; 
$interface_title = 'DarkPortal - DarkCodex Forum';
$interface_cols = array();

/*-----------------------------------------------------------------------------
* Authentication Handling
*/
isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* Forum Post Interface 
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/
class LocalInterface extends Interface {


/**
* Interface Constructor
* @return VOID
*/
  function LocalInterface() {
    $this->Interface();
  }

/**
* Initialize Local Interface
* @return VOID
*/
    function initializeLocal() {
        global $dbh;
        global $userinfo;
        global $config;
        
        list($dbt_board, $bcol) = array_values($this->command->DBGetTable('forum_board')); 
        list($dbt_post, $pcol) = array_values($this->command->DBGetTable('forum_post')); 

        // Set default interface options
        // DEFAULT Viewing Mode
        if (isset($this->form_data[mode])) {
          $this->interface_data[mode] = $this->form_data[mode];
        } elseif (isset($userinfo[forum][post_view]) ) { 
          $this->interface_data[mode] = $userinfo[forum][post_view]; 
        } else {
          $this->interface_data[mode] = $config[forum][post_view];
        }  
        // DEFAULT Sort By Column
        if (isset($this->form_data[sort_by]) && $this->form_data[sort_by] != '') {
          $this->interface_data[sort_by] = $this->form_data[sort_by];
        } elseif (isset($userinfo[forum][sort_by]) && $userinfo[forum][sort_by] != '') {
          $this->interface_data[sort_by] = $userinfo[forum][sort_by];
        } else {
          $this->interface_data[sort_by] = $config[forum][sort_by];
        }
        // DEFAULT Sorting Order
        if (isset($this->form_data[sort_ord]) && $this->form_data[sort_ord] != '') {
          $this->interface_data[sort_ord] = $this->form_data[sort_ord];
        } elseif (isset($userinfo[forum][sort_ord]) && $userinfo[forum][sort_ord] != '') {
          $this->interface_data[sort_ord] = $userinfo[forum][sort_ord];
        } else {
          $this->interface_data[sort_ord] = $config[forum][sort_ord];
        }
        // DEFAULT Post View Mode
        if (isset($this->form_data[view])) {
          $this->interface_data[view] = $this->form_data[view];
        } elseif (isset($userinfo[forum][threaded]) ) {
          $this->interface_data[view] = $userinfo[forum][threaded];
        } else {
          $this->interface_data[view] = $config[forum][threaded];
        }
        // DEFAULT Security Level
        $this->interface_data[user_security] = (empty($userinfo[forum][security_level])) ? $config[forum][anon_security] : $userinfo[forum][security_level]; 
        // DEFAULT Page to view
        $this->interface_data[page] = (!$this->form_data[page]) ? 0 : $this->form_data[page];
        
        // Load a definition of the board.
      if (isset($this->form_data[board]) && $this->form_data[board] != '') {
        $bid_q = $this->command->db_quote($this->form_data[board]);
        $sql= <<<END_SQL
    SELECT *
    FROM $dbt_board
    WHERE $bcol[id] = $bid_q
END_SQL;
        $result = $dbh->Execute($sql) or trigger_error("Cannot load board listing.",FATAL);
        $this->interface_data[board] = $result->fields;
        list($this->interface_data[moderator_info], $this->interface_data[moderator_ids]) = $this->command->getModerator($this->form_data[board]);
      }

      if (isset($this->form_data[id]) && $this->form_data[id] != '') {
        $lookup_states = ($this->interface_data[moderator_ids][$userinfo[id]] == 1) ? '0,1,2,3,4' : '1,2';
        if ($this->interface_data[user_security] < $bdata[security]) { 
          $this->command->noaccess("You do not have a high enough security level to view this board."); 
        } 
    
        // Read the user's read post data.
        $this->interface_data[userread] = $this->command->getUserRead($this->form_data[board]); 
    
        if (isset($this->form_data[id]) && $this->form_data[id] != '') {
          if (! preg_match('/preview/', $this->operation)) {
            $sql = <<<END_SQL
SELECT $pcol[id],$pcol[post_dt],$pcol[uid],$pcol[aid],
$pcol[ip_addr],$pcol[subject],$pcol[body], $pcol[parent],
$pcol[file], $pcol[status_flg], $pcol[main] ,$pcol[last_post_dt],
$pcol[expire_dt], $pcol[modify_by], $pcol[modify_dt], $pcol[comment],
$pcol[icon]
FROM $dbt_post
WHERE $pcol[id] = {$this->form_data[id]}
  and $pcol[status_flg] in ($lookup_states,5,0)
END_SQL;
            $result = $dbh->Execute ($sql) or trigger_error("Cannot build post data listings.", FATAL); 
            $this->interface_data[post_data] = $result->fields;
          }
          $sql = <<<END_SQL
SELECT count($pcol[id]) as reply 
FROM $dbt_post
WHERE $pcol[main] = {$this->interface_data[post_data][main]}
END_SQL;
          $result = $dbh->Execute ($sql) or trigger_error("Cannot determine reply counts for posts.", FATAL); 
          $this->interface_data[reply_count] = $result->fields[reply];
          
            $this->interface_data[posts_per_page] = (empty($userinfo[forum][posts_per_page])) ? $config[forum][posts_per_page] : $userinfo[forum][posts_per_page]; 
            if ($this->interface_data[page] < 1){ 
                $this->interface_data[total_posts_tograb] = $this->interface_data[posts_per_page] + 1; 
            } else { 
                $start_at_post = $this->interface_data[page] * ($this->interface_data[posts_per_page] - 1); 
                $number_of_posts = $this->interface_data[posts_per_page] + 1; 
                $this->interface_data[total_posts_tograb] = "$start_at_post, $number_of_posts "; 
            } 
          $sql = <<<END_SQL
SELECT $pcol[id], $pcol[uid], $pcol[aid], $pcol[subject], 
  $pcol[post_dt], $pcol[expire_dt], $pcol[modify_by], $pcol[status_flg]
FROM $dbt_post 
WHERE $pcol[id] = $pcol[main]
  and $pcol[bid] = $bid_q
  and $pcol[status_flg] in ($lookup_states,5)
ORDER BY {$this->interface_data[sort_by]} {$this->interface_data[sort_ord]}
LIMIT {$this->interface_data[total_posts_tograb]}
END_SQL;
          $this->interface_data[post_mains] = $dbh->Execute ($sql) or trigger_error ("Cannot load primary main posts.",FATAL); 
          $sql = <<<END_SQL
SELECT $pcol[id],$pcol[post_dt],$pcol[uid], $pcol[aid], 
  $pcol[ip_addr],$pcol[subject],$pcol[body],$pcol[file],
  $pcol[status_flg], $pcol[expire_dt]
FROM $dbt_post
WHERE $pcol[main] = {$this->interface_data[post_data][main]}
  and $pcol[status_flg] in ($lookup_states)
ORDER BY $pcol[id] 
END_SQL;
          $this->interface_data[post_posts] = $dbh->Execute ($sql) or trigger_error("Cannot load raw post list data.",FATAL); 
        }
      }
        $userinfo[forum][threaded] = $this->interface_data[view];
        $userinfo[forum][post_view] = $this->interface_data[mode];
        $userinfo[forum][sort_by] = $this->interface_data[sort_by];
        $userinfo[forum][sort_ord] = $this->interface_data[sort_ord];
       
        $this->theme = $this->resetTheme();
    //$this->interface_data = array_merge($this->interface_data, $result->fields);
    }

    function finalizeLocal() {
        global $userinfo;
        $userinfo[SAVE_PLUGIN] = true;
        if (isset($this->interface_data[board][id]) && $this->interface_data[board][id] != ''){
            $this->command->setUserRead($this->interface_data[board][id], $this->interface_data[userread]);
        }
    }

/**
* Main Zone Callback Method
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
    global $dbh;
    global $config; 
    global $userinfo;

    $this->template =& $theme;
    $interface = $this->interface;
    $theme->assign('idata', $this->interface_data);
  }

	function view() {
    global $dbh, $userinfo, $config;
    
    list($dbt, $pcol) = array_values($this->command->DBGetTable('forum_post'));
    if (isset($this->interface_data[post_data][id]) && $this->interface_data[post_data][id] != '') {
      $pid_q = $this->command->db_quote($this->interface_data[post_data][id]);
      $sql = <<<END_SQL
update $dbt
set $pcol[views] = $pcol[views] + 1
where $pcol[id] = $pid_q
END_SQL;
      $dbh->Execute($sql) or trigger_error( "Cannot increment post views.",FATAL);
    }
	}

  function preview($oper) {
    global $dbh, $userinfo, $config;

    list($dbt, $pcol) = array_values($this->command->DBGetTable('forum_post')); 
    
    while (list($k, $v ) = each($pcol) ) {
      $this->interface_data[post_data][$k] = $this->form_data[$k];
    }
    // check if the user receives email replies.
    if ($userinfo[forum][email_reply] == 1) {
      $this->interface_data[email_reply] = 1;
    }
    //$this->interface_data[preview_post] = 0;
    
    $this->Initialize();
  }

  function add() {
    global $dbh;
    global $userinfo;
    global $config;
    
    if ($this->interface_data[board][locked_dt] != ''  &&
      $this->interface_data[board][locked_dt] != '00000000000000'  &&
      $this->interface_data[board][locked_dt] <= $this->command->formatUNIXTimeStamp() &&
      $this->interface_data[moderator_ids][$userinfo[id]] != 1) {
      $this->command->noAccess('This board is locked and cannot be posted to.');
    } 
    
    $this->interface_data[bid] = $this->interface_data[board][id];
    // check if the user receives email replies.
    if ($userinfo[forum][email_reply] == 1) {
        $this->interface_data[email_reply] = 1;
    }
    if (isset($this->form_data[id]) && $this->form_data[id] != '') {
        $this->interface_data[post_data][subject] = 
            (preg_match('/^Re: /', $this->interface_data[post_data][subject])) ?
            $this->interface_data[post_data][subject] :
            'Re: ' . $this->interface_data[post_data][subject] ;
        //$this->interface_data[main] = $this->interface_data[post_data][main];
        $this->interface_data[post_data][parent] = $this->interface_data[post_data][id];
    }
    // when the user submits, will they preview first?
    if (empty($userinfo[forum][preview])) { 
        $this->interface_data[preview_post] = $config[forum][preview];
    } else {
        $this->interface_data[preview_post] = $userinfo[forum][preview];
    }
    // Check the board options to display the appropriate messages.
    if ($this->interface_data[board][anon_flg] == 0 && $userinfo[id] <= 0) {
        $this->command->noAccess('Anonymous postings are not allowed on this forum.  You need to have a Username and be logged in before posting on this board.');
    } elseif ($this->interface_data[board][anon_flg] == 1) {
        $this->interface_data[anon_user] = 'Anonymous';
    }
  }
  
  function doAdd() {
    global $dbh;
    global $config;
    global $userinfo;
    // Setup the DB tables we will use.
    list($dbt, $pcol) = array_values($this->command->DBGetTable('forum_post')); 
    unset($this->form_data[id]);
    
    // Extract the userID to use when posting.
    $this->form_data[uid] = isset($userinfo[id]) ? $userinfo[id] : 0;
    
    // check if we are allowed Anonymous posting.
    if ($this->interface_data[board][anon_flg] == 0 && $this->form_data[uid] <= 0) {
        $this->command->noAccess('Anonymous postings are not allowed on this forum.  You need to have a Username and be logged in before posting on this board.');
    }
    
    // Check if the board is locked.
    if($this->inteface_data[board][locked_dt] != '' &&
       ($this->interface_data[board][locked_dt] <= $this->command->formatUNIXTimestamp) && 
       ($userinfo[forum][status] != "Administrator") && 
       ($userinfo[forum][status] != "Moderator") ) {
        $this->command->noAccess("This board is read only.  Only Administrators and Moderators can post here.");
    }
    
    // Check if the main thread is locked.
    if (isset($this->form_data[main]) && 
        $this->form_data[main] > 0 &&
        $this->command->postStatus($this->form_data[main]) == 2 && 
        ($userinfo[forum][status] != "Administrator") && 
        ($userinfo[forum][status] != "Moderator") ) {
        $this->command->noAccess("I'm sorry, this thread is locked and you don't have the proper permission to add to it.");
    }
    
    // Double check for double clicked posting.
    if ($this->command->postExists()){
        $this->command->noAccess("This post has already been entered into the database.");
    }

    // Check for preview mode override.
    if ($this->form_data[preview_post] == 1) {
      $this->operation = "add.preview";
      $this->preview('add.preview');
      return;
    }

    // prep the rest of the fields for posting 
    $this->form_data[post_dt] = $this->command->formatUNIXTimestamp();
    $this->form_data[modify_dt] = $this->command->formatUNIXTimestamp();
    $this->form_data[modify_by] = $userinfo[id];
    $this->form_data[last_post_dt] = $this->form_data[post_dt];
    $this->form_data[uid] = $this->form_data[uid];
    $this->form_data[ip_addr] = $_SERVER['REMOTE_ADDR']; // VErify IP Pull method.
    $this->form_data[kept_flg] = 0;

    // Check for a moderator expiry setting
    if (isset($this->form_data[expire]) && 
      $this->form_data[expire] != '0|s' &&
      $this->interface_data[moderator_ids][$userinfo[id]] == 1) {
      list($amount, $freq) = explode("|", $this->form_data[expire]);
      $this->form_data[expire_dt] = $this->command->manipulateTime($this->command->formatUNIXTimestamp, $amount, $freq);
    } else {
      $this->form_data[expire_dt] = '00000000000000';
    }

    // Set the status flag based on the board status
    if ($this->interface_data[moderator_ids][$userinfo[id]] != 1) {
      $this->form_data[status_flg] = ($this->interface_data[board][approve_flg] == 0) ? 1 : 0;
      $this->form_data[comment] = (isset($this->interface_data[post_data][comment])) ? $this->interface_data[post_data][comment] : '';
    }

    // if we are guest, email reply is not allowed.
    if ($this->form_data[uid] == 0) {
        $this->form_data[mail_flg] = 0;
    }
    if (empty($this->form_data[parent]) || $this->form_data[parent] == '') {
        $this->form_data[parent] = 0;
    }
    if (empty($this->form_data[main]) || $this->form_data[main] == '') {
        $this->form_data[main] = 0;
    }
    
    // Go through the list of columns and set the values
    $this->form_data[bid] = $this->form_data[board];
    while (list($k, $v) = each($pcol)) {
        $cols[] = $v;
        if ($k != 'sid') {
            $vals[] = $this->command->db_quote($this->form_data[$k]);
        } else {
            $vals[] = $this->command->db_quote(session_id());
        }
    }

    // Build the SQL for insert and run it.
    $col_list = implode(',', $cols);
    $val_list = implode(',', $vals);
    $sql = "insert into $dbt ($col_list) values ($val_list)";
    $dbh->Execute($sql) or trigger_error ("Cannot add post.", FATAL); 

    // Now that we have inserted, we need to extract the post ID we just set.
    $sql = "select $pcol[id] from $dbt where $pcol[sid] = " . 
        $this->command->db_quote(session_id()) .
        " and $pcol[post_dt] = " . $this->command->db_quote($this->form_data[post_dt]);
    $result = $dbh->Execute($sql) or trigger_error("Cannot retrieve post for rewrite after add.",FATAL); 
    $update_flg = 0;
    if ($this->form_data[main] == 0) {
        $this->form_data[main] = $result->fields[id];
        $update_flg = 1;
    } 
    
    // Set the user's post count up one.
    (isset($userinfo[forum][post_count])) ? $userinfo[forum][post_count]++ : $userinfo[forum][post_count] = 1;
    
    // Set the user's read post to include the newly added post.
    $this->interface_data[userread][read][$result->fields[id]] = 1;
    if ($result->fields[id] > $this->interface_data[userread][max_read]) {
        $this->interface_data[userread][max_read] = $result->fields[id];
    }

    // Update the record with main/parent information as needed.
    if ($update_flg) {
        $sql = "update $dbt set $pcol[main] = " .
            $this->command->db_quote($this->form_data[main]) . 
            "where $pcol[id] = " . $this->command->db_quote($result->fields[id]);
        $dbh->Execute($sql) or trigger_error("Cannot update parent record(s) after add.",FATAL); 
    }
    
    // Reset the form fields and reload the interfaces to display the new post.
    $this->form_data[id] = $result->fields[id];
    $this->Initialize();
  }
  
  function edit() {
    global $dbh;
    global $userinfo;
    global $config;
    
    if ( ($userinfo[id] != $this->interface_data[post_data][uid]) &&
      ($this->interface_data[moderator_ids][$userinfo[id]] != 1 )) { 
      $this->command->noAccess("We could not verify that you made this post, that you have Administrator priviledges or that you are a moderator for this board.  Because of this, we cannot allow you to edit this post.");
    }
    // when the user submits, will they preview first?
    if (empty($userinfo[forum][preview])) { 
        $this->interface_data[preview_post] = $config[forum][preview];
    } else {
        $this->interface_data[preview_post] = $userinfo[forum][preview];
    }
    $this->interface_data[username] = $this->command->getUserName();
    $this->interface_data[id] = $this->interface_data[post_data][id];
    $this->interface_data[main] = $this->interface_data[post_data][main];
    $this->interface_data[parent] = $this->interface_data[post_data][parent];
    $this->interface_data[subject] = $this->interface_data[post_data][subject];
  }
  
  function doEdit() {
    global $dbh;
    global $userinfo;
    global $config;
    list($dbt, $pcol) = array_values($this->command->DBGetTable('forum_post')); 

    $this->form_data[uid] = isset($userinfo[id]) ? $userinfo[id] : 0;
    if ($this->interface_data[board][anon_flg] == 0 && $this->form_data[uid] <= 0) {
        $this->command->noAccess('Anonymous postings are not allowed on this forum.  You need to have a Username and be logged in before posting on this board.');
    }
    if($this->inteface_data[board][locked_dt] != '' &&
       ($this->interface_data[board][locked_dt] <= $this->command->formatUNIXTimestamp) && 
       ($userinfo[forum][status] != "Administrator") && 
       ($userinfo[forum][status] != "Moderator") ) {
        $this->command->noAccess("This board is read only.  Only Administrators and Moderators can post here.");
    }
    if (isset($this->form_data[main]) && 
        $this->form_data[main] > 0 &&
        $this->command->postStatus($this->form_data[main]) == 2 && 
        ($userinfo[forum][status] != "Administrator") && 
        ($userinfo[forum][status] != "Moderator") ) {
        $this->command->noAccess("I'm sorry, this thread is locked and you don't have the proper permission to add to it.");
    }
    if ($this->form_data[preview_post] == 1) {
      $this->operation = "edit.preview";
      $this->preview('edit.preview');
      return;
    }
    if (isset($this->form_data[expire]) && 
      $this->form_data[expire] != '' &&
      $this->interface_data[moderator_ids][$userinfo[id]] == 1) {
      list($amount, $freq) = explode("|", $this->form_data[expire]);
      if ($amount == 0) {
        $expire_q = $this->command->db_quote('00000000000000');
      } else {
        $expire_q = $this->command->db_quote($this->command->manipulateTime($this->command->formatUNIXTimestamp, $amount, $freq));
      }
    } else {
      $expire_q = (isset($this->interface_data[post_data][expire_dt])) ? $this->command->db_quote($this->interface_data[post_data][expire_dt]) : $this->command->db_quote('00000000000000');
    }
    if ($this->interface_data[moderator_ids][$userinfo[id]] == 1) {
      $status_q = $this->command->db_quote($this->form_data[status_flg]);
      $comment_q = $this->command->db_quote($this->form_data[comment]);
    } else {
      $status_q = $this->command->db_quote($this->interface_data[post_data][status_flg]);
      $comment_q = $this->command->db_quote($this->interface_data[post_data][comment]);
    }

    $subject_q = $this->command->db_quote($this->form_data[subject]);
    $body_q = $this->command->db_quote($this->form_data[body]);
    $icon_q = $this->command->db_quote($this->form_data[icon]);
    $id_q = $this->command->db_quote($this->form_data[id]);
    $modby_q = $this->command->db_quote($userinfo[id]);
    $moddt_q = $this->command->db_quote($this->command->formatUNIXTimeStamp());
    $sql = <<<END_SQL
update $dbt set
  $pcol[subject] = $subject_q,
  $pcol[icon] = $icon_q,
  $pcol[body] = $body_q,
  $pcol[status_flg] = $status_q,
  $pcol[comment] = $comment_q,
  $pcol[expire_dt] = $expire_q,
  $pcol[modify_by] = $modby_q,
  $pcol[modify_dt] = $moddt_q
  where $pcol[id] = $id_q
END_SQL;

    $dbh->Execute($sql) or trigger_error("Cannot update post record.",FATAL); 
    $this->Initialize();
  }
  
  function delete() {
    global $dbh;
    global $userinfo;
    global $config;
    if ($this->interface_data[moderator_ids][$userinfo[id]] == 1 ||
      $this->interface_data[uid] == $userinfo[id]) {
      $this->operation = 'delete';
    } else  {
      $this->interface = 'forum';
      $this->operation = 'list';
      $this->interface_data[error] = 'You do not have permission to modify this post.';
      header("Location: $config[site_url]/$config[plugin_path]/index.php?operation=list&form_board={$this->form_data[board]}");
    }
  }
  
  function doDelete() {
    global $dbh;
    global $userinfo;
    global $config;
    list($dbt, $pcol) = array_values($this->command->DBGetTable('forum_post')); 
        
    if ($this->interface_data[moderator_ids][$userinfo[id]] == 1 ||
      $this->interface_data[uid] == $userinfo[id]) {
      if ($this->interface_data[id] == $this->form_data[id]) {
        $id_q = $this->command->db_quote($this->form_data[id]);
        $comment_q = $this->command->db_quote("Post deleted by " . $this->command->getUsername());
        $expired_q = $this->command->db_quote($this->command->formatDBTimestamp());
        $uid_q = $this->command->db_quote($userinfo[id]);

        $sql = "update $dbt set $pcol[comment] = $comment_q, $pcol[expire_dt] = $expired_q, $pcol[status_flg] = 3, $pcol[modify_by] = $uid_q where $pcol[id] = $id_q";
        $this->interface_data[error] = "Post deleted";
        $dbh->Execute($sql) or trigger_error("Could not delete this post."); 
        // delete any file attachments for the post (should recycle).
        //if (isset($this->interface_data[file]) && $this->interface_data[file] != '') {
        //  unlink($this->interface_data[file]);
        //}

        $this->interface = 'forum';
        $this->operation = 'list';
      } else {
        $error .= "Form improperly submitted.";
      }
    }
    $this->theme = $this->resetTheme();
  }
}

/*
* Interface Initialization
*/
$gui = new LocalInterface();

$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;

$gui->Initialize();
if ($gui->interface_data[board][security] > $gui->interface_data[user_security] ) {
    $gui->command->noAccess('You do not have a high enough security level on this forum to view or modify posts.');
}

//$gui->urls = $gui->command->buildURL( array(mode => $gui->interface_data[mode], view => $gui->interface_data[view], sort_ord => $gui->interface_data[sort_ord], sort_by => $gui->interface_data[sort_by], page => $gui->interface_data[page], id => $gui->form_data[id], board => $gui->interface_data[board][id]), 'post.php', "$config[site_url]/plugins/forum", array('search','preview','add','edit','submit','view'));
/*-----------------------------------------------------------------------------
* Operation Logic
*/

if (preg_match("/^search/i", $operation)) {
  $gui->view();
} elseif (preg_match("/^submit/i", $operation)) {
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  // If an operation does not require input validation, it is placed first.
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($gui->validateForm()){ 
    // Once the form data is placed, it can be validated. 
    // The validation is interface dependent.
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'preview') {
      $gui->preview;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^preview/", $operation)) {
  $gui->preview();
} else {
	$gui->view();
}

/*-----------------------------------------------------------------------------
* Interface Display
*    Once the operations (if any) are complete, the display method is called.
*    this enacts the object's theme to display its appropriate blocks.
*/
print $gui->display();
$gui->Finalize();
?>
