<?php
/*
* Chat Alias Manager
*
*/

/**
* Initializing the Interface classes
*/
$plugin = 'admin.user';    // Plugin Name
include_once("../../../function.php");

/*     The next variables set the interface name and the plugin name of the 
*     current script. The interface name describes shared functionality within
*     a specific plugin, while the plugin name is used to determine the 
*     location of helper scripts to the interfaces.
*/
$interface = 'admin.user.alias'; 
$interface_title = 'DarkPortal - User Alias Manager';
$interface_cols = array('id', 'name', 'description', 'system', 'status', 'activity',
                        'url', 'image', 'entry_message', 'exit_message', 'allow_public',
                        'can_modify', 'uid', 'create_date', 'modify_date', 'modify_by',
                        'login_date', 'login_count', 'delete_date', 'inactive_date');

/*-----------------------------------------------------------------------------
* Authentication Handling
*    In the case that a specific interface should limit access to its functions,
*    the following code sample can be used to limit access and provide the user
*    with a reason for the denial. This sample could be expanded to force the
*    user to be a member of specific group(s) or use a plugin config variable
*    to turn on group level authentication.
*/
if (empty ($userinfo[groups][Administrator])) {
  $reason = "Access to Administration Interface Denied";
  include("$include_path/noaccess.php");
  exit;
}

isset ($searchby) ? $operation .= ".$searchby" : '';
isset ($form__operation) ? $operation .= ".$form__operation" : '';

/*-----------------------------------------------------------------------------
* >>>>>>>>>>>>>>>>>>>>>>>>>>  END OF GLOBAL CODE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*/

/**
* API Interface 
*
* The following template provides the basic level of functionality for all
* Dark Portal plugin interfaces. It serves as a common interface or API to
* perform all display functions for Dark Portal addons and current core
* functionality. For detailed developer instructions, refer to comments in
* this file, and the developer manual included with Dark Portal.
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package API
*/
class LocalInterface extends Interface {


/**
* API Interface Constructor
*
* The local interface contructor should usually only call the super class
* constructor. In some cases, it may be useful to add some parameters such
* as static theme ID (admin interfaces) and so forth.
*
* @return VOID
*/
  function LocalInterface() {
    $this->themeID = 1;
    $this->permission = 1;
    $this->Interface();
  }

/**
* Initialize Local Interface
*
* If special initialzation is required by the local interface, it should be
* performed here. It may be best to comment this out if no special initialization
* is required.
*
* @return VOID
*/
	function initializeLocal() {
      global $dbh, $config;
      
      if (isset($this->interface_data[id]) && $this->interface_data[id] != '') {
        
        while (list($k, $v) = each($this->interface_data)) {
            if (is_array($v) || $k = 'error') { continue; }
            $this->interface_data[no_parse][$k] = $v;
            $this->interface_data[$k] = (isset($v) && $v != '') ? $this->command->parseTags($v,1,0,0) : 'N/A';
        }

        $sql = "select name, value from alias_extra where aid = {$this->interface_data[id]}";
        $result = $dbh->Execute($sql);
        $dbh->ErrorMsg() ? $this->interface_data[error] =  "Cannot find extra information for {$this->interface_data[name]}." : '';
        
        while ($adata = $result->fields) {
          $result->MoveNext();
          if (preg_match("/^\d{14}$/", $adata[value])) { $adata[value] = $this->command->formatDBTimestamp($adata[value]); }
          $this->interface_data[no_parse][extra][$adata[name]] = $adata[value];
          $this->interface_data[extra][$adata[name]] = (isset($adata[value]) && $adata[value] != '') ? $this->command->parseTags($adata[value],1,0,0) : 'N/A';
        }
      
        $this->interface_data[system_d] = $this->command->getNameFromID($this->interface_data[system], 'alias_system');
        $this->interface_data[status_d] = $this->command->getNameFromID($this->interface_data[status], 'alias_status');
        $this->interface_data[activity_d] = $this->command->getNameFromID($this->interface_data[activity], 'alias_activity');
      } elseif (isset($this->interface_data[0][id]) && $this->interface_data[0][id] != '') {
        for ($i = 0; $i < sizeof ($this->interface_data) ; $i++) {
          if (is_array($this->interface_data[$i])) {
            $this->interface_data[$i][system_d] = $this->command->getNameFromID($this->interface_data[$i][system], 'alias_system');
            $this->interface_data[$i][status_d] = $this->command->getNameFromID($this->interface_data[$i][status], 'alias_status');
            $this->interface_data[$i][activity_d] = $this->command->getNameFromID($this->interface_data[$i][activity], 'alias_activity');
          }
        }
      }
      $this->theme->assign('idata', $this->interface_data);
 	}
  
/**
* Main Zone Callback Method
*
* Almost all interfaces should contain a main() method. This will allow the 
* system to override the parsing of main inside the template and perform the
* lookup of data which will later be needed to be placed inside the primary
* zone of the interface. It is also common to create helper and indexing 
* content in other zones. These may be further aided by adding content methods
* with the same name as the zone. As an example: It is common to provide 
* help features to new users in the rightblock zone of the default theme. If
* customized data is needed in these blocks, it could be done in a rightblock()
* method.
*
* @param ObjectRef $theme A reference to the template object to use for assigning template date, etc.
* @return VOID
*/
  function main(&$theme) {
    global $dbh, $config, $userinfo;
    $theme->assign('idata', $this->interface_data);
  }
  function search() {
    if (sizeof($this->interface_data) <= 1 && empty($this->interface_data[id])) {
      $this->interface_data[error] = "No search results found.";
    }
    $this->theme->assign('idata', $this->interface_data);
  }

  function doAdd() {
    global $dbh;
    global $userinfo;
    
    $this->form_data[can_modify] = 1;
    $this->form_data[create_date] = $this->command->formatUNIXTimestamp();
    $this->form_data[modify_by] = $userinfo[id];
    $this->form_data[modify_date] = $this->command->formatUNIXTimestamp();
    $this->form_data[login_date] = '00000000000000';
    $this->form_data[delete_date] = '00000000000000';
    $this->form_data[inactive_date] = '00000000000000';
    unset ($this->form_data[id]);
    $dbfields = array('id');
    $dbvalues = array('null');
    $error = '';

    $sql = "insert into alias ";
    while (list($k, $v) = each($this->form_data)) {
  		$dbfields[] = $k;
			$dbvalues[] = $this->command->db_quote($v);
    }
    $sql .= '(' . join(',', $dbfields) . ') ';
    $sql .= 'values(' . join(',', $dbvalues) . ')';
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? $error = "Chat alias addition failed -- " . $dbh->ErrorMsg() : '';
    $this->interface_data[error] = $error;
    if ($error != '') { 
      $this->operation = 'add';
      $this->Initialize();
    }
    $theme =& $this->theme;
    $theme->assign('idata', $this->interface_data);
  }
  
  function doEdit() {
    global $dbh, $config, $userinfo;
    $dbfields = array();
    $error = '';

    if($this->interface_data[id] == $this->form_data[id] ) { // Ensure we are updating ourselves
      $this->form_data[modify_by] = $userinfo[id];
      $this->form_data[modify_date] = $this->command->formatUNIXTimestamp();
      $aid_q =  $this->command->db_quote($this->form_data[id]);
     
      $sql1 = "update alias set ";
      while (list($k,$v) = each ($this->form_data)) {
        $sql2 = '';
        if (substr($k, 0,3) == 'ex_') {
      	  $val_q = $this->command->db_quote($v);
      	  $nam_q = $this->command->db_quote(substr($k,3));
      	  if (isset($this->interface_data[$k])) {
      	    $sql2 = "update alias_extra set value = $val_q where name = $nam_q and aid = $aid_q";
      	  } else {
      	    $sql2 = "insert into alias_extra (id, aid, name, value, permission) values (null, $aid_q, $nam_q, $val_q, 0)";
      	  }
	        if ($sql2 != '') { 
	        $dbh->Execute($sql2);
            $dbh->ErrorMsg() ? $error .= "Chat alias extra data failed -- " . $dbh->ErrorMsg() : '';
	        }
  	    } else {
          $dbfields1[] = "$k = " . $this->command->db_quote($v);
	      }
      }
      if (isset($this->form_data[name]) && $this->form_data[name] !='') {
        $sql1 .= join(',', $dbfields1);
        $sql1 .= " where id = $aid_q";
        $dbh->Execute($sql1);
        $dbh->ErrorMsg() ? $error .= "Chat alias modification failed -- " . $dbh->ErrorMsg() : '';
      }
    } else {
        $error = "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  function doDelete() {
    global $dbh, $config, $userinfo;

    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $del_date = $this->command->db_quote($this->command->formatUNIXTimestamp);
      $aid_q = $this->command->db_quote($this->interface_data[id]);
      $sql = "update alias set delete_date = $del_date, activity = 5 where id = $aid_q";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Chat alias delete failed -- " . $dbh->ErrorMsg() : '';
    } else {
      $error .= "Form improperly submitted.";
    }

    $this->operation = '';
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }

  function doPurge() {
    global $dbh, $config, $userinfo;

    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $del_date = $this->command->db_quote($this->command->formatUNIXTimestamp);
      $aid_q = $this->command->db_quote($this->interface_data[id]);
      $sql = "delete from alias where id = $aid_q";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Chat alias purge failed -- " . $dbh->ErrorMsg() : '';
    } elseif ($this->form_data[id] == 'ALL') {
      $sql = "delete from alias where activity = 5";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Chat alias purge failed -- " . $dbh->ErrorMsg() : '';
    } else {
      $error .= "Form improperly submitted.";
    }

    $this->operation = '';
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }

  function doApprove() {
    global $dbh, $config, $userinfo;

    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $del_date = $this->command->db_quote($this->command->formatUNIXTimestamp);
      $aid_q = $this->command->db_quote($this->interface_data[id]);
      $mid_q = $this->command->db_quote($userinfo[id]);
      $sql = "update alias set modify_date = $del_date, modify_by = $mid_q, activity = 1 where id = $aid_q";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Chat alias approval failed -- " . $dbh->ErrorMsg() : '';

      $comment_q = $this->command->db_quote($this->form_data[ex_mod_comment]);
   	  if (isset($this->interface_data[extra][mod_comment])) {
        $sql2 = "update alias_extra set value = $comment_q where name = 'mod_comment' and aid = $aid_q";
      } else {
        $sql2 = "insert into alias_extra (id, aid, name, value, permission) values (null, $aid_q, 'mod_comment', $comment_q, 0)";
      }
      $dbh->Execute($sql2);
      $dbh->ErrorMsg() ? $error .= "Chat alias approval failed -- " . $dbh->ErrorMsg() : '';
    } else {
      $error .= "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
  function doReject() {
    global $dbh, $config, $userinfo;

    if($this->interface_data[id] == $this->form_data[id]) { // Ensure we are updating ourselves
      $del_date = $this->command->db_quote($this->command->formatUNIXTimestamp);
      $aid_q = $this->command->db_quote($this->interface_data[id]);
      $mid_q = $this->command->db_quote($userinfo[id]);
      $sql = "update alias set modify_date = $del_date, modify_by = $mid_q, activity = 8 where id = $aid_q";
      $dbh->Execute($sql);
      $dbh->ErrorMsg() ? $error .= "Chat alias approval failed -- " . $dbh->ErrorMsg() : '';
      
      $comment_q = $this->command->db_quote($this->form_data[ex_mod_comment]);
   	  if (isset($this->interface_data[extra][mod_comment])) {
        $sql2 = "update alias_extra set value = $comment_q where name = 'mod_comment' and aid = $aid_q";
      } else {
        $sql2 = "insert into alias_extra (id, aid, name, value, permission) values (null, $aid_q, 'mod_comment', $comment_q, 0)";
      }
      $dbh->Execute($sql2);
      $dbh->ErrorMsg() ? $error .= "Chat alias approval failed -- " . $dbh->ErrorMsg() : '';
    } else {
      $error .= "Form improperly submitted.";
    }
    $this->interface_data[error] = $error;
    $this->interface_data = array_merge($this->interface_data, $this->command->getInterfaceData($this->search));
    $this->theme->assign('idata', $this->interface_data);
    $this->Initialize();
  }
}

/*
* Interface Initialization
*    The interface class itself is now initialized, the operation variable 
*    used here is always included from the user interface GET or POST request.
*    The Interface constructor creates the global interface variable which 
*    makes it available to the other classes which are initialized by the
*    Initialize method. We cannot initialize in the constructor, as the object
*    is not actually instantiated yet.
*/
$gui = new LocalInterface();
/*    DarkPortal institutes a common set of CGI parameters which should always
*    be used when performing search or lookup operations for user data. The
*    basic method to create a search pattern is handled by three basic lookup
*    variables:
*    - searchby ==> the search lookup table for the query.
*    - searchid ==> the id to use when performing the search.
*    - searchname ==> If the search needs to lookup on an alternate column, 
*      indicate a name for that column.
*    In future releases, this API will be expanded to allow for ranged 
*    searching, and joins on multiple tables. Currently, the search function
*    is implemented directly in the Interface class. This will be changed to
*    be moved to the mainfile.
*/
$gui->search[id] = $searchid;
$gui->search[key] = $searchby;
$gui->search[name] = $searchname;
$gui->Initialize();

/*-----------------------------------------------------------------------------
* Operation Logic
*    Below is a sample of operational logic, which determines what the operation
*    is to be performed, and attempts to perform methods within the GUI to 
*    enact requests by the user. Note that the interface itself will automatically
*    retrieve the appropriate user interface layout blocks from the database 
*    during initialization. User interface methods should never generate output,
*    they should only extract or place data in the database based upon the 
*    user's request.
*/
if (preg_match("/^search/i", $operation)) {
  $gui->search();
} elseif (preg_match("/^submit/i", $operation)) {
  // It is typical to set the form data into the interface class if the operation
  // is a submission of information. Form data fields typically take on the form
  // of form_<dataitem>. This transposition may be modified in future releases.
  isset($form_id) ? $gui->form_data[id] = $form_id : '';
  $gui->form_data[name] = $form_name;
  // If an operation does not require input validation, it is placed first.
  if ($form__operation == 'delete') { 
    $gui->doDelete();
  } elseif ($form__operation == 'purge') { 
    $gui->doPurge();
  } elseif ($gui->validateForm()){ 
    // Once the form data is placed, it can be validated. 
    // The validation is interface dependent.
    if ($form__operation == 'edit') {
      $gui->doEdit();
    } elseif ($form__operation == 'add') {
      $gui->doAdd();
    } elseif ($form__operation == 'copy') {
      $gui->doCopy();
    } elseif ($form__operation == 'approve') {
      $gui->doApprove();
    } elseif ($form__operation == 'reject') {
      $gui->doReject();
    }
  } else {
    if ($form__operation == 'edit') {
      $gui->edit();
    } elseif ($form__operation == 'add') {
      $gui->add();
    } elseif ($form__operation == 'copy') {
      $gui->copy;
    } else {
      $gui->unknownError();
    }
  }
} elseif (preg_match("/^add/", $operation)) {
  $gui->add();
} elseif (preg_match("/^edit/", $operation)) {
  $gui->edit();
} elseif (preg_match("/^delete/", $operation)) {
  $gui->delete();
} elseif (preg_match("/^copy/", $operation)) {
  $gui->copy();
}

/*-----------------------------------------------------------------------------
* Interface Display
*    Once the operations (if any) are complete, the display method is called.
*    this enacts the object's theme to display its appropriate blocks.
*/
print $gui->display();

?>
