<?php
/**
* setup.php - Portal Setup
*/
$SYSTEM_VARS = get_defined_vars();
if (isset($operation) && $operation != '') {
  $form_data = loadFormData();
  $dbh = setupDatabase($form_data);
	setFunctionClass($form_data);
  $config = buildConfig($form_data);
  displayResult($form_data);
  fixPermissions($form_data);
  // Current setup doesn't remove itself.. This should be fixed later.
  exit;  
}

if (preg_match("/Windows/", $HTTP_ENV_VARS[OS] )) {
  $Windows = 'SELECTED';
} else {
  $UNIX = 'SELECTED';
}
$dbhost = 'localhost';
$dbname = "darkportal";
$site_name = "Dark Portal";
$site_url = preg_replace("/(.+)[\/\\\]setup\.php/", "\\1", $HTTP_SERVER_VARS[PHP_SELF]);
$site_path = preg_replace("/(.+)[\/\\\]setup\.php/", "\\1", $HTTP_SERVER_VARS[PATH_TRANSLATED]);
$site_theme = 2;

$out = <<<END_HTML
<h2>Configure Dark Portal
<form name="setupForm" method="post" action="setup.php">
<table width=100% cellspacing=0 cellpadding=2>
  <tr><td width=50% align="right">
    Database Type
  </td><td width=50%>
    <select name="form_dbtype">
      <option value="mysql">MySQL</option>
    </select>
  </td></tr>
  <tr><td width=50% align="right">
    Database Host
  </td><td width=50%>
    <input type=text width=20 name="form_dbhost" value="$dbhost">
  </td></tr>
  <tr><td width=50% align="right">
    Database Username
  </td><td width=50%>
    <input type=text width=20 name="form_dbuname" value="$dbuname">
  </td></tr>
  <tr><td width=50% align="right">
    Database Password    
  </td><td width=50%>
    <input type=password width=20 name="form_dbpassword" value="$dbpassword">
  </td></tr>
  <tr><td width=50% align="right">
    Database Name/Schema
  </td><td width=50%>
    <input type=text width=20 name="form_dbname" value="$dbname">
  </td></tr>
  <tr><td width=50% align="right">
    System Type
  </td><td width=50%>
    <select name="form_system">
      <option value="UNIX" $UNIX>UNIX</option>
      <option value="Windows" $Windows>Windows</option>
    </select>
  </td></tr>
  <tr><td width=50% align="right">
    Site Name  
  </td><td width=50%>
    <input type=text width=20 name="form_site_name" value="$site_name">
  </td></tr>
  <tr><td width=50% align="right">
    Site URL
  </td><td width=50%>
    <input type=text width=20 name="form_site_url" value="$site_url">
  </td></tr>
  <tr><td width=50% align="right">
    Site Path
  </td><td width=50%>
    <input type=text width=20 name="form_site_path" value="$site_path">
  </td></tr>
  <tr><td width=50% align="right">
    Site Language
  </td><td width=50%>
    <select name="form_site_language">
      <option value="english">English</option>
    </select>    
  </td></tr>
  <tr><td width=50% align="right">
  </td><td width=50%>
  </td></tr>
  <tr><td width=100% colspan="2" align="center">
    <input type="submit" name="operation" value="Submit">
    <input type="reset" value="Reset">
  </td></tr>
</table>
</form>
END_HTML;

print $out;

function buildConfig($form) {
  global $dbh;
  
	print "<h3>Loading config parameters into database...</h3>\n";
	
  while (list($k, $v) = each($form)) {
    $sql = "update config set value = " . $dbh->qstr($v) . " where name = " . $dbh->qstr($k) .
           "and interface = 'admin.sysconfig'";
    $dbh->Execute($sql);
    $dbh->ErrorMsg() ? die ("Sysconfig failed -- " . $dbh->ErrorMsg() . "<br>$sql<br>\n") : '';
  }
  
  $sql = "select name, value, title, description from config where interface = 'admin.sysconfig' order by grp, ord";
  $result = $dbh->Execute($sql);
  $dbh->ErrorMsg() ? die ("Sysconfig failed -- " . $dbh->ErrorMsg() . "<br>$sql<br>\n") : '';

	print "<h3>Building config file...</h3>\n";
  $out = <<<END_HTML
<?php
/*
* Configuration
*
* While not completely object oriented, this config class opens the door
* for using config as an object in later development. Ideally, the config
* for plugins will eventually inherit from this class, and config will be
* an object owned by interfaces. For now, it creates a simple associative
* array of configuration parameters. This file can be generated dynamically
* from the system config tool and will eventually be generated during the
* standard install process.
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
*/

\$config = array(

END_HTML;
    while ($data = $result->fields) {
      $data[description] = wordwrap(strip_tags($data[description]), 76, "\n** ");
      $out .= <<<END_HTML
/* $data[name] - $data[title]
** $data[description]
*/
  	$data[name] => "$data[value]",

END_HTML;
      $result->MoveNext();
    }
    $out .= <<<END_HTML
);

/**
* Configuration
*
* While not completely object oriented, this config class opens the door
* for using config as an object in later development. Ideally, the config
* for plugins will eventually inherit from this class, and config will be
* an object owned by interfaces. For now, it creates a simple associative
* array of configuration parameters. This file can be generated dynamically
* from the system config tool and will eventually be generated during the
* standard install process.
*
* @version  0.2.0 beta
* @author   Fred Hirsch
* @copyright  Dark Hart Design  2001
* @package CORE
*/
class Config {

/**
* Holds an array containing the global configuration options for the entire 
* portal.
*
* @access private
*/
  var \$config = array();

/**
* Config Constructor
* 
* Creates a configuration object from the global configuration. Eventually the
* object methods will replace the static array used above.
*/
  function Config() {
    global \$config;
    \$this->config = \$config;
  }
}
END_HTML;

	print "<h3>Saving config file...</h3>\n";
    if (file_exists("$form[site_path]/{$plugin}config.php")) {
      // Make a backup of the existing config.
      $date = time();
      copy("$form[site_path]/{$plugin}config.php", "$config[site_path]/{$plugin}config.$date.php");
    }
   
    $fh = fopen("$form[site_path]/{$plugin}config.php", 'w');
    fwrite($fh, $out);
  }

function loadFormData() {
  global $SYSTEM_VARS;
	print "<h3>Loading Data from Form...</h3>\n";
  $form_data = array();
  while (list ($k, $v) = each ($SYSTEM_VARS)) {
      if (preg_match("/^form_([^_].+)/", $k, $match) ) {
				$form_data[$match[1]] = $v;
      }
  }
  $SYSTEM_VARS = array();
  if (sizeof($form_data) <= 0) {
  	die ("Data from form was not loaded properly. Form was improperly submitted.");
  }
  return $form_data;
}

function setupDatabase($form) {
	print "<h3>Setting up Database connection...</h3>\n";
  if (isset($form[site_path]) && $form[site_path] != ''
      && file_exists("$form[site_path]/adodb/adodb.inc.php")) {
    include "$form[site_path]/adodb/adodb.inc.php";
  } else {
    print "<h3>Site path ($form[site_path]) is incorrect, cannot find ADODB libraries.</h3>";
    exit;
  }
  ADOLoadCode($form[dbtype]);
  $dbh = NewADOConnection();
  $dbh->PConnect($form[dbhost], $form[dbuname], $form[dbpass], $form[dbname]);
  $dbh->ErrorMsg() ? die ("Database Connection failed -- " . $dbh->ErrorMsg()) . " Ensure database is properly setup and try again." : '';
  return $dbh;  
}

function displayResult($form) {
	print <<<END_HTML
<h3>Configuration Successful...</h3>	
<p>You should now be able to enter the main portal page by entering the URL:<br>
<a href="$form[site_url]/index.php">$form[site_url]/index.php</a>
<p>You may also login to the portal as an administrator using the account "admin" and password "password":<br>
<a href="$form[site_url]/login.php">$form[site_url]/login.php</a>

END_HTML;
}

function setFunctionClass($form) {
	print "<h3>Fixing the Main Method Factory Class...</h3>\n";
	$filename_pre = "$form[site_path]/function.php.pre";
	$filename = "$form[site_path]/function.php";
	$fh = fopen($filename_pre, 'r') or die ("Could not open file");
	$contents = fread ($fh, filesize ($filename_pre));
	fclose($fh);
	$new_content = preg_replace("/\{SET_PATH\}/", $form[site_path], $contents);
	$fh = fopen($filename, 'w') or die ("Could not open file");
	fwrite($fh, $new_content);
	fclose($fh);

}

function fixPermissions($form) {
	if ($form[system] == "UNIX") {
		chmod ("$form[site_path]/function.php", 0744);
		chmod ("$form[site_path]/config.php", 0744);
	}
}

function removeSetup() {
}

?>