-- MySQL dump 9.09
--
-- Host: localhost    Database: portal
---------------------------------------------------------
-- Server version	4.0.15

--
-- Table structure for table `alias`
--

DROP TABLE IF EXISTS alias;
CREATE TABLE alias (
  id int(11) NOT NULL auto_increment,
  uid int(11) NOT NULL default '0',
  name varchar(60) NOT NULL default '',
  system int(11) NOT NULL default '0',
  status tinyint(4) NOT NULL default '0',
  activity tinyint(4) NOT NULL default '0',
  url varchar(80) default NULL,
  description text,
  image varchar(80) default NULL,
  entry_message tinytext NOT NULL,
  exit_message tinytext NOT NULL,
  allow_public tinyint(4) NOT NULL default '0',
  create_date varchar(14) NOT NULL default '00000000000000',
  modify_date varchar(14) NOT NULL default '00000000000000',
  login_date varchar(14) NOT NULL default '00000000000000',
  login_count int(10) unsigned NOT NULL default '0',
  delete_date varchar(14) NOT NULL default '00000000000000',
  inactive_date varchar(14) NOT NULL default '00000000000000',
  can_modify tinyint(4) NOT NULL default '0',
  modify_by int(11) NOT NULL default '0',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY userid (uid)
) TYPE=MyISAM;

--
-- Table structure for table `alias_activity`
--

DROP TABLE IF EXISTS alias_activity;
CREATE TABLE alias_activity (
  id int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `alias_extra`
--

DROP TABLE IF EXISTS alias_extra;
CREATE TABLE alias_extra (
  id int(10) unsigned NOT NULL auto_increment,
  aid int(10) unsigned NOT NULL default '0',
  name varchar(80) NOT NULL default '',
  value text NOT NULL,
  permission tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY aid (aid)
) TYPE=MyISAM;

--
-- Table structure for table `alias_status`
--

DROP TABLE IF EXISTS alias_status;
CREATE TABLE alias_status (
  id int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `alias_system`
--

DROP TABLE IF EXISTS alias_system;
CREATE TABLE alias_system (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `article`
--

DROP TABLE IF EXISTS article;
CREATE TABLE article (
  id int(11) NOT NULL auto_increment,
  aid varchar(30) NOT NULL default '',
  title varchar(80) default NULL,
  time varchar(14) default NULL,
  text_intro text,
  text_body longtext NOT NULL,
  comments int(11) default '0',
  counter mediumint(8) unsigned default NULL,
  topic int(3) NOT NULL default '1',
  informant varchar(20) NOT NULL default '',
  notes text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `article_comment`
--

DROP TABLE IF EXISTS article_comment;
CREATE TABLE article_comment (
  id int(10) unsigned NOT NULL auto_increment,
  parent int(10) unsigned NOT NULL default '0',
  aid int(10) unsigned NOT NULL default '0',
  uid int(10) unsigned NOT NULL default '0',
  subject tinytext NOT NULL,
  content text NOT NULL,
  create_date varchar(14) NOT NULL default '',
  rating tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `article_topic`
--

DROP TABLE IF EXISTS article_topic;
CREATE TABLE article_topic (
  id int(10) unsigned NOT NULL auto_increment,
  parent int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  image varchar(30) NOT NULL default '',
  description varchar(80) NOT NULL default '',
  content text NOT NULL,
  counter int(11) NOT NULL default '0',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `article_topic_related`
--

DROP TABLE IF EXISTS article_topic_related;
CREATE TABLE article_topic_related (
  id int(10) unsigned NOT NULL auto_increment,
  topic int(10) unsigned NOT NULL default '0',
  name varchar(80) NOT NULL default '',
  url tinytext NOT NULL,
  PRIMARY KEY  (id),
  KEY theme (topic)
) TYPE=MyISAM;

--
-- Table structure for table `article_userinfo`
--

DROP TABLE IF EXISTS article_userinfo;
CREATE TABLE article_userinfo (
  id int(10) unsigned NOT NULL auto_increment,
  uid int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  value varchar(80) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY uid (uid)
) TYPE=MyISAM;

--
-- Table structure for table `block`
--

DROP TABLE IF EXISTS block;
CREATE TABLE block (
  id int(10) unsigned NOT NULL auto_increment,
  theme int(10) unsigned NOT NULL default '0',
  zone varchar(20) NOT NULL default '',
  user_block tinyint(3) unsigned NOT NULL default '0',
  grp int(10) unsigned NOT NULL default '0',
  interface varchar(40) NOT NULL default 'default',
  operation varchar(40) NOT NULL default 'default',
  title tinytext NOT NULL,
  content text NOT NULL,
  code tinyint(4) NOT NULL default '0',
  multi tinyint(3) unsigned NOT NULL default '0',
  ord tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY theme (theme),
  KEY zone (zone),
  KEY interface (interface)
) TYPE=MyISAM;

--
-- Table structure for table `chat_log`
--

DROP TABLE IF EXISTS chat_log;
CREATE TABLE chat_log (
  id int(10) unsigned NOT NULL auto_increment,
  uid int(10) unsigned NOT NULL default '0',
  rid int(10) unsigned NOT NULL default '0',
  aid int(10) unsigned NOT NULL default '0',
  mid int(10) unsigned NOT NULL default '0',
  details tinytext NOT NULL,
  sid varchar(40) NOT NULL default '',
  severity tinyint(3) unsigned NOT NULL default '0',
  module varchar(40) NOT NULL default '',
  entry_date varchar(14) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `chat_message`
--

DROP TABLE IF EXISTS chat_message;
CREATE TABLE chat_message (
  id int(10) unsigned NOT NULL auto_increment,
  rid int(10) unsigned NOT NULL default '0',
  aid int(10) unsigned NOT NULL default '0',
  recipient tinytext NOT NULL,
  from_room varchar(60) NOT NULL default '',
  message text NOT NULL,
  postdate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `chat_plugin`
--

DROP TABLE IF EXISTS chat_plugin;
CREATE TABLE chat_plugin (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  code varchar(80) NOT NULL default '',
  ord tinyint(3) unsigned NOT NULL default '0',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `chat_room`
--

DROP TABLE IF EXISTS chat_room;
CREATE TABLE chat_room (
  id int(11) unsigned NOT NULL auto_increment,
  uid int(10) unsigned NOT NULL default '0',
  name varchar(60) NOT NULL default '',
  short_desc tinytext NOT NULL,
  long_desc text,
  url varchar(100) NOT NULL default '',
  occupancy tinyint(3) unsigned NOT NULL default '10',
  status tinyint(4) NOT NULL default '1',
  status_msg tinytext NOT NULL,
  privilege tinyint(4) NOT NULL default '0',
  visible tinyint(3) unsigned NOT NULL default '1',
  private tinyint(3) unsigned NOT NULL default '0',
  create_date varchar(14) NOT NULL default '00000000000000',
  modify_date varchar(14) NOT NULL default '00000000000000',
  modify_by int(10) unsigned NOT NULL default '0',
  used_date varchar(14) NOT NULL default '00000000000000',
  image varchar(100) NOT NULL default '',
  PRIMARY KEY  (id),
  UNIQUE KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `chat_room_access`
--

DROP TABLE IF EXISTS chat_room_access;
CREATE TABLE chat_room_access (
  rid int(10) unsigned NOT NULL default '0',
  aid int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `chat_room_extra`
--

DROP TABLE IF EXISTS chat_room_extra;
CREATE TABLE chat_room_extra (
  id int(10) unsigned NOT NULL auto_increment,
  rid int(10) unsigned NOT NULL default '0',
  name varchar(80) NOT NULL default '',
  value text NOT NULL,
  permission tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY aid (rid)
) TYPE=MyISAM;

--
-- Table structure for table `chat_room_privilege`
--

DROP TABLE IF EXISTS chat_room_privilege;
CREATE TABLE chat_room_privilege (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `chat_room_status`
--

DROP TABLE IF EXISTS chat_room_status;
CREATE TABLE chat_room_status (
  id int(10) unsigned NOT NULL default '1',
  name varchar(20) NOT NULL default '',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `chat_session`
--

DROP TABLE IF EXISTS chat_session;
CREATE TABLE chat_session (
  id varchar(40) NOT NULL default '',
  uid int(10) unsigned NOT NULL default '0',
  aid int(10) unsigned NOT NULL default '0',
  rid int(10) unsigned NOT NULL default '0',
  status tinyint(3) unsigned NOT NULL default '0',
  status_description tinytext NOT NULL,
  firstread int(10) unsigned NOT NULL default '0',
  lastread int(10) unsigned NOT NULL default '0',
  created varchar(14) default NULL,
  updated varchar(14) default NULL,
  ip_address varchar(15) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY uid (uid,aid,rid),
  KEY updated (updated)
) TYPE=MyISAM;

--
-- Table structure for table `config`
--

DROP TABLE IF EXISTS config;
CREATE TABLE config (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(80) NOT NULL default '',
  value tinytext NOT NULL,
  grp tinyint(3) unsigned NOT NULL default '0',
  override char(1) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `config_group`
--

DROP TABLE IF EXISTS config_group;
CREATE TABLE config_group (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(40) NOT NULL default '',
  description tinytext NOT NULL,
  category varchar(10) NOT NULL default '',
  plugin varchar(20) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `config_select`
--

DROP TABLE IF EXISTS config_select;
CREATE TABLE config_select (
  id int(10) unsigned NOT NULL auto_increment,
  name tinytext NOT NULL,
  value varchar(80) NOT NULL default '',
  form_field varchar(80) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY form_field (form_field),
  KEY value (value)
) TYPE=MyISAM;

--
-- Table structure for table `dyna_form`
--

DROP TABLE IF EXISTS dyna_form;
CREATE TABLE dyna_form (
  id int(10) unsigned NOT NULL auto_increment,
  plugin varchar(20) NOT NULL default '',
  interface varchar(40) NOT NULL default '',
  template int(10) unsigned NOT NULL default '1',
  name varchar(40) NOT NULL default '',
  action varchar(80) NOT NULL default '',
  method varchar(8) NOT NULL default 'POST',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY interface (plugin)
) TYPE=MyISAM;

--
-- Table structure for table `dyna_form_button`
--

DROP TABLE IF EXISTS dyna_form_button;
CREATE TABLE dyna_form_button (
  id int(10) unsigned NOT NULL auto_increment,
  type varchar(10) NOT NULL default 'submit',
  name varchar(20) NOT NULL default 'OK',
  value varchar(20) NOT NULL default '',
  src tinytext NOT NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `dyna_form_element`
--

DROP TABLE IF EXISTS dyna_form_element;
CREATE TABLE dyna_form_element (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(80) NOT NULL default '',
  value tinytext NOT NULL,
  title varchar(80) NOT NULL default '',
  description tinytext NOT NULL,
  form_name varchar(20) NOT NULL default '',
  plugin varchar(20) NOT NULL default '',
  interface varchar(40) NOT NULL default '',
  operation varchar(20) NOT NULL default '',
  is_required tinyint(3) unsigned NOT NULL default '0',
  is_unique tinyint(3) unsigned NOT NULL default '0',
  formsize_a varchar(5) NOT NULL default '0',
  formsize_b int(10) unsigned NOT NULL default '0',
  size_min tinyint(3) unsigned NOT NULL default '0',
  size_max int(10) unsigned NOT NULL default '0',
  source varchar(10) NOT NULL default 'user',
  source_name tinytext NOT NULL,
  script tinytext NOT NULL,
  type varchar(20) NOT NULL default '',
  ord tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `dyna_form_group`
--

DROP TABLE IF EXISTS dyna_form_group;
CREATE TABLE dyna_form_group (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  type varchar(10) NOT NULL default '',
  elements tinytext NOT NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `dyna_form_select`
--

DROP TABLE IF EXISTS dyna_form_select;
CREATE TABLE dyna_form_select (
  id int(10) unsigned NOT NULL auto_increment,
  name tinytext NOT NULL,
  value varchar(80) NOT NULL default '',
  form_field varchar(80) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY form_field (form_field),
  KEY value (value)
) TYPE=MyISAM;

--
-- Table structure for table `dyna_form_template`
--

DROP TABLE IF EXISTS dyna_form_template;
CREATE TABLE dyna_form_template (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(40) NOT NULL default '',
  template text NOT NULL,
  permission int(10) unsigned NOT NULL default '0',
  has_elements tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `element`
--

DROP TABLE IF EXISTS element;
CREATE TABLE element (
  id int(10) unsigned NOT NULL auto_increment,
  interface varchar(25) NOT NULL default 'default',
  plugin varchar(25) NOT NULL default 'default',
  language tinyint(4) NOT NULL default '0',
  name varchar(80) NOT NULL default '',
  content text NOT NULL,
  code tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name),
  KEY plugin (plugin)
) TYPE=MyISAM;

--
-- Table structure for table `format_color`
--

DROP TABLE IF EXISTS format_color;
CREATE TABLE format_color (
  id int(10) unsigned NOT NULL auto_increment,
  color varchar(80) NOT NULL default '',
  hex varchar(6) NOT NULL default '',
  darkness tinyint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `forum_board`
--

DROP TABLE IF EXISTS forum_board;
CREATE TABLE forum_board (
  id int(10) unsigned NOT NULL auto_increment,
  parent int(11) NOT NULL default '0',
  main int(11) NOT NULL default '0',
  name varchar(80) NOT NULL default '',
  title tinytext,
  description text,
  cid int(11) NOT NULL default '0',
  total int(9) unsigned default NULL,
  last_post_dt varchar(14) default NULL,
  html_flg tinyint(4) NOT NULL default '1',
  markup_flg tinyint(4) NOT NULL default '1',
  anon_flg tinyint(4) NOT NULL default '0',
  locked_dt varchar(14) NOT NULL default '',
  create_dt varchar(14) default NULL,
  expire_dt varchar(14) default NULL,
  security int(4) default '50',
  approve_flg tinyint(4) NOT NULL default '0',
  ord int(11) NOT NULL default '0',
  UNIQUE KEY name (name),
  UNIQUE KEY id (id),
  KEY indx2 (id)
) TYPE=MyISAM;

--
-- Table structure for table `forum_board_mod`
--

DROP TABLE IF EXISTS forum_board_mod;
CREATE TABLE forum_board_mod (
  uid int(10) unsigned NOT NULL default '0',
  bid int(10) unsigned NOT NULL default '0',
  KEY uid (uid,bid)
) TYPE=MyISAM;

--
-- Table structure for table `forum_category`
--

DROP TABLE IF EXISTS forum_category;
CREATE TABLE forum_category (
  id int(10) unsigned NOT NULL auto_increment,
  parent int(11) NOT NULL default '0',
  main int(11) NOT NULL default '0',
  title varchar(255) NOT NULL default 'General Discussion',
  ord int(9) unsigned default '0',
  KEY indx1 (title),
  KEY indx2 (id)
) TYPE=MyISAM;

--
-- Table structure for table `forum_post`
--

DROP TABLE IF EXISTS forum_post;
CREATE TABLE forum_post (
  id int(10) unsigned NOT NULL auto_increment,
  bid int(11) NOT NULL default '0',
  parent int(10) unsigned NOT NULL default '0',
  main int(10) unsigned NOT NULL default '0',
  post_dt varchar(14) NOT NULL default '',
  last_post_dt varchar(14) NOT NULL default '',
  aid int(10) unsigned NOT NULL default '0',
  uid int(10) unsigned NOT NULL default '0',
  sid varchar(47) NOT NULL default '',
  ip_addr varchar(60) NOT NULL default '',
  subject tinytext,
  body text,
  comment text NOT NULL,
  mail_flg tinyint(3) unsigned NOT NULL default '0',
  file varchar(100) NOT NULL default '',
  kept_flg tinyint(3) unsigned NOT NULL default '0',
  status_flg tinyint(3) unsigned NOT NULL default '0',
  icon int(10) unsigned NOT NULL default '1',
  views int(10) unsigned NOT NULL default '1',
  rating int(10) unsigned default NULL,
  expire_dt varchar(14) NOT NULL default '00000000000000',
  modify_dt varchar(14) NOT NULL default '00000000000000',
  modify_by int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY aid (aid)
) TYPE=MyISAM;

--
-- Table structure for table `forum_post_expire_type`
--

DROP TABLE IF EXISTS forum_post_expire_type;
CREATE TABLE forum_post_expire_type (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `forum_post_icon`
--

DROP TABLE IF EXISTS forum_post_icon;
CREATE TABLE forum_post_icon (
  id int(10) unsigned NOT NULL auto_increment,
  filename varchar(80) NOT NULL default '',
  description varchar(80) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY filename (filename)
) TYPE=MyISAM;

--
-- Table structure for table `forum_post_read`
--

DROP TABLE IF EXISTS forum_post_read;
CREATE TABLE forum_post_read (
  uid int(10) unsigned NOT NULL default '0',
  bid int(10) unsigned NOT NULL default '0',
  last_read_dt varchar(14) NOT NULL default '',
  max_read int(10) unsigned NOT NULL default '0',
  done_read text NOT NULL,
  KEY bid (bid),
  KEY uid (uid)
) TYPE=MyISAM;

--
-- Table structure for table `forum_post_status`
--

DROP TABLE IF EXISTS forum_post_status;
CREATE TABLE forum_post_status (
  id int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `forum_post_type`
--

DROP TABLE IF EXISTS forum_post_type;
CREATE TABLE forum_post_type (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id)
) TYPE=MyISAM;

--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS groups;
CREATE TABLE groups (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(80) NOT NULL default '',
  description varchar(255) NOT NULL default '',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `icon_formatter`
--

DROP TABLE IF EXISTS icon_formatter;
CREATE TABLE icon_formatter (
  id int(10) unsigned NOT NULL auto_increment,
  filename varchar(255) NOT NULL default '',
  description tinytext NOT NULL,
  code text NOT NULL,
  type varchar(10) NOT NULL default '',
  ord int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `icon_smiley`
--

DROP TABLE IF EXISTS icon_smiley;
CREATE TABLE icon_smiley (
  id int(10) unsigned NOT NULL auto_increment,
  filename varchar(255) NOT NULL default '',
  description tinytext NOT NULL,
  code text NOT NULL,
  ord int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `interface`
--

DROP TABLE IF EXISTS interface;
CREATE TABLE interface (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(40) NOT NULL default '',
  plugin varchar(40) NOT NULL default '',
  title varchar(80) NOT NULL default '',
  description tinytext NOT NULL,
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `language`
--

DROP TABLE IF EXISTS language;
CREATE TABLE language (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(25) NOT NULL default '',
  description varchar(80) NOT NULL default '',
  encoding varchar(6) NOT NULL default '',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `locale_country`
--

DROP TABLE IF EXISTS locale_country;
CREATE TABLE locale_country (
  id int(11) NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `menu`
--

DROP TABLE IF EXISTS menu;
CREATE TABLE menu (
  id int(10) unsigned NOT NULL auto_increment,
  parent int(10) unsigned NOT NULL default '0',
  main int(10) unsigned NOT NULL default '0',
  plugin varchar(60) NOT NULL default '',
  interface varchar(60) NOT NULL default '',
  operation varchar(60) NOT NULL default '',
  condition tinytext NOT NULL,
  text varchar(80) NOT NULL default '',
  url tinytext NOT NULL,
  target varchar(60) NOT NULL default '_self',
  ord tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `permission`
--

DROP TABLE IF EXISTS permission;
CREATE TABLE permission (
  id int(10) unsigned NOT NULL default '0',
  name varchar(40) NOT NULL default '',
  description tinytext NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS sessions;
CREATE TABLE sessions (
  sesskey varchar(32) NOT NULL default '',
  expiry int(11) unsigned NOT NULL default '0',
  data text NOT NULL,
  PRIMARY KEY  (sesskey)
) TYPE=MyISAM;

--
-- Table structure for table `site`
--

DROP TABLE IF EXISTS site;
CREATE TABLE site (
  id int(10) unsigned NOT NULL auto_increment,
  tid int(10) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `theme`
--

DROP TABLE IF EXISTS theme;
CREATE TABLE theme (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(20) NOT NULL default '',
  description tinytext,
  content text NOT NULL,
  permission tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `theme_config`
--

DROP TABLE IF EXISTS theme_config;
CREATE TABLE theme_config (
  id int(10) unsigned NOT NULL auto_increment,
  theme int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  value varchar(80) NOT NULL default '',
  permission int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY theme (theme)
) TYPE=MyISAM;

--
-- Table structure for table `theme_meta`
--

DROP TABLE IF EXISTS theme_meta;
CREATE TABLE theme_meta (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(80) NOT NULL default '',
  value text NOT NULL,
  theme int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY theme (theme)
) TYPE=MyISAM;

--
-- Table structure for table `user_ban`
--

DROP TABLE IF EXISTS user_ban;
CREATE TABLE user_ban (
  id int(10) unsigned NOT NULL auto_increment,
  uid int(10) unsigned NOT NULL default '0',
  entry_user int(10) unsigned NOT NULL default '0',
  ip varchar(15) NOT NULL default '',
  entry_date varchar(14) NOT NULL default '',
  expiry_date varchar(14) NOT NULL default '',
  reason tinytext NOT NULL,
  plugin varchar(20) NOT NULL default '',
  interface varchar(40) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY uid (uid)
) TYPE=MyISAM;

--
-- Table structure for table `user_block`
--

DROP TABLE IF EXISTS user_block;
CREATE TABLE user_block (
  uid int(10) unsigned NOT NULL default '0',
  bid int(10) unsigned NOT NULL default '0',
  misc tinyint(4) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `user_groups`
--

DROP TABLE IF EXISTS user_groups;
CREATE TABLE user_groups (
  uid int(10) unsigned NOT NULL default '0',
  gid int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;

--
-- Table structure for table `user_preference`
--

DROP TABLE IF EXISTS user_preference;
CREATE TABLE user_preference (
  id int(10) unsigned NOT NULL default '0',
  name varchar(40) NOT NULL default '',
  value tinytext NOT NULL,
  plugin varchar(20) NOT NULL default '',
  KEY id (id,name)
) TYPE=MyISAM;

--
-- Table structure for table `user_preference_group`
--

DROP TABLE IF EXISTS user_preference_group;
CREATE TABLE user_preference_group (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(40) NOT NULL default '',
  description tinytext NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `user_tracking`
--

DROP TABLE IF EXISTS user_tracking;
CREATE TABLE user_tracking (
  sid varchar(32) NOT NULL default '',
  plugin varchar(60) NOT NULL default '',
  extra tinytext NOT NULL,
  expire_date varchar(14) NOT NULL default '',
  login_flag tinyint(3) unsigned NOT NULL default '0',
  uid int(10) unsigned NOT NULL default '0',
  create_date varchar(14) NOT NULL default '',
  update_date varchar(14) NOT NULL default '',
  PRIMARY KEY  (sid)
) TYPE=MyISAM;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS users;
CREATE TABLE users (
  id int(11) NOT NULL auto_increment,
  username varchar(10) NOT NULL default '',
  password varchar(80) NOT NULL default '',
  name varchar(60) NOT NULL default '',
  alias varchar(60) NOT NULL default '',
  email varchar(60) NOT NULL default '',
  fakeemail varchar(60) NOT NULL default '',
  url varchar(100) NOT NULL default '',
  locale_city varchar(40) NOT NULL default '',
  locale_country int(10) unsigned NOT NULL default '0',
  icq varchar(15) NOT NULL default '',
  aim varchar(15) NOT NULL default '',
  yim varchar(15) NOT NULL default '',
  msnm varchar(15) NOT NULL default '',
  occupation varchar(40) NOT NULL default '',
  interests varchar(80) NOT NULL default '',
  sig tinytext NOT NULL,
  bio tinytext NOT NULL,
  birth_date varchar(14) NOT NULL default '00000000000000',
  create_date varchar(14) NOT NULL default '00000000000000',
  modify_date varchar(14) NOT NULL default '00000000000000',
  login_date varchar(14) NOT NULL default '00000000000000',
  modify_by int(10) NOT NULL default '0',
  login_count int(10) NOT NULL default '1',
  last_ip varchar(20) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `zone`
--

DROP TABLE IF EXISTS zone;
CREATE TABLE zone (
  id int(10) unsigned NOT NULL auto_increment,
  theme int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  content text NOT NULL,
  active tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY theme (theme),
  KEY name (name)
) TYPE=MyISAM;

--
-- Table structure for table `zonebak`
--

DROP TABLE IF EXISTS zonebak;
CREATE TABLE zonebak (
  id int(10) unsigned NOT NULL auto_increment,
  theme int(10) unsigned NOT NULL default '0',
  name varchar(20) NOT NULL default '',
  content text NOT NULL,
  blockdef text NOT NULL,
  active tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY theme (theme)
) TYPE=MyISAM;

