------------------------------------------------------------------
-- My2Pg 1.23 translated dump
--
------------------------------------------------------------------

BEGIN;




--
-- Sequences for table ALIAS
--

CREATE SEQUENCE alias_id_seq;

-- MySQL dump 9.09
--
-- Host: localhost    Database: portal
---------------------------------------------------------
-- Server version	4.0.15

--
-- Table structure for table `alias`
--

CREATE TABLE alias (
  id INT4 DEFAULT nextval('alias_id_seq'),
  uid INT4 NOT NULL DEFAULT '0',
  name varchar(60) NOT NULL DEFAULT '',
  system INT4 NOT NULL DEFAULT '0',
  status INT2 NOT NULL DEFAULT '0',
  activity INT2 NOT NULL DEFAULT '0',
  url varchar(80) DEFAULT NULL,
  description text,
  image varchar(80) DEFAULT NULL,
  entry_message TEXT DEFAULT '' NOT NULL,
  exit_message TEXT DEFAULT '' NOT NULL,
  allow_public INT2 NOT NULL DEFAULT '0',
  create_date varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_date varchar(14) NOT NULL DEFAULT '00000000000000',
  login_date varchar(14) NOT NULL DEFAULT '00000000000000',
  login_count INT4  NOT NULL DEFAULT '0',
  delete_date varchar(14) NOT NULL DEFAULT '00000000000000',
  inactive_date varchar(14) NOT NULL DEFAULT '00000000000000',
  can_modify INT2 NOT NULL DEFAULT '0',
  modify_by INT4 NOT NULL DEFAULT '0',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `alias_activity`
--

CREATE TABLE alias_activity (
  id INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `alias_extra`
--



--
-- Sequences for table ALIAS_EXTRA
--

CREATE SEQUENCE alias_extra_id_seq;

CREATE TABLE alias_extra (
  id INT4 DEFAULT nextval('alias_extra_id_seq'),
  aid INT4  NOT NULL DEFAULT '0',
  name varchar(80) NOT NULL DEFAULT '',
  value TEXT DEFAULT '' NOT NULL,
  permission INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `alias_status`
--

CREATE TABLE alias_status (
  id INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `alias_system`
--



--
-- Sequences for table ALIAS_SYSTEM
--

CREATE SEQUENCE alias_system_id_seq;

CREATE TABLE alias_system (
  id INT4 DEFAULT nextval('alias_system_id_seq'),
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `article`
--



--
-- Sequences for table ARTICLE
--

CREATE SEQUENCE article_id_seq;

CREATE TABLE article (
  id INT4 DEFAULT nextval('article_id_seq'),
  aid varchar(30) NOT NULL DEFAULT '',
  title varchar(80) DEFAULT NULL,
  time varchar(14) DEFAULT NULL,
  text_intro text,
  text_body TEXT DEFAULT '' NOT NULL,
  comments INT4 DEFAULT '0',
  counter INT4  DEFAULT NULL,
  topic INT4 NOT NULL DEFAULT '1',
  informant varchar(20) NOT NULL DEFAULT '',
  notes TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (id)
);

--
-- Table structure for table `article_comment`
--



--
-- Sequences for table ARTICLE_COMMENT
--

CREATE SEQUENCE article_comment_id_seq;

CREATE TABLE article_comment (
  id INT4 DEFAULT nextval('article_comment_id_seq'),
  parent INT4  NOT NULL DEFAULT '0',
  aid INT4  NOT NULL DEFAULT '0',
  uid INT4  NOT NULL DEFAULT '0',
  subject TEXT DEFAULT '' NOT NULL,
  content TEXT DEFAULT '' NOT NULL,
  create_date varchar(14) NOT NULL DEFAULT '',
  rating INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `article_topic`
--



--
-- Sequences for table ARTICLE_TOPIC
--

CREATE SEQUENCE article_topic_id_seq;

CREATE TABLE article_topic (
  id INT4 DEFAULT nextval('article_topic_id_seq'),
  parent INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  image varchar(30) NOT NULL DEFAULT '',
  description varchar(80) NOT NULL DEFAULT '',
  content TEXT DEFAULT '' NOT NULL,
  counter INT4 NOT NULL DEFAULT '0',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `article_topic_related`
--



--
-- Sequences for table ARTICLE_TOPIC_RELATED
--

CREATE SEQUENCE article_topic_related_id_seq;

CREATE TABLE article_topic_related (
  id INT4 DEFAULT nextval('article_topic_related_id_seq'),
  topic INT4  NOT NULL DEFAULT '0',
  name varchar(80) NOT NULL DEFAULT '',
  url TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (id)
);

--
-- Table structure for table `article_userinfo`
--



--
-- Sequences for table ARTICLE_USERINFO
--

CREATE SEQUENCE article_userinfo_id_seq;

CREATE TABLE article_userinfo (
  id INT4 DEFAULT nextval('article_userinfo_id_seq'),
  uid INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  value varchar(80) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `block`
--



--
-- Sequences for table BLOCK
--

CREATE SEQUENCE block_id_seq;

CREATE TABLE block (
  id INT4 DEFAULT nextval('block_id_seq'),
  theme INT4  NOT NULL DEFAULT '0',
  zone varchar(20) NOT NULL DEFAULT '',
  user_block INT2  NOT NULL DEFAULT '0',
  grp INT4  NOT NULL DEFAULT '0',
  interface varchar(40) NOT NULL DEFAULT 'default',
  operation varchar(40) NOT NULL DEFAULT 'default',
  title TEXT DEFAULT '' NOT NULL,
  content TEXT DEFAULT '' NOT NULL,
  code INT2 NOT NULL DEFAULT '0',
  multi INT2  NOT NULL DEFAULT '0',
  ord INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_log`
--



--
-- Sequences for table CHAT_LOG
--

CREATE SEQUENCE chat_log_id_seq;

CREATE TABLE chat_log (
  id INT4 DEFAULT nextval('chat_log_id_seq'),
  uid INT4  NOT NULL DEFAULT '0',
  rid INT4  NOT NULL DEFAULT '0',
  aid INT4  NOT NULL DEFAULT '0',
  mid INT4  NOT NULL DEFAULT '0',
  details TEXT DEFAULT '' NOT NULL,
  sid varchar(40) NOT NULL DEFAULT '',
  severity INT2  NOT NULL DEFAULT '0',
  module varchar(40) NOT NULL DEFAULT '',
  entry_date varchar(14) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_message`
--



--
-- Sequences for table CHAT_MESSAGE
--

CREATE SEQUENCE chat_message_id_seq;

CREATE TABLE chat_message (
  id INT4 DEFAULT nextval('chat_message_id_seq'),
  rid INT4  NOT NULL DEFAULT '0',
  aid INT4  NOT NULL DEFAULT '0',
  recipient TEXT DEFAULT '' NOT NULL,
  from_room varchar(60) NOT NULL DEFAULT '',
  message TEXT DEFAULT '' NOT NULL,
  postdate TIMESTAMP NOT NULL DEFAULT '0001-01-01 00:00:00',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_plugin`
--



--
-- Sequences for table CHAT_PLUGIN
--

CREATE SEQUENCE chat_plugin_id_seq;

CREATE TABLE chat_plugin (
  id INT4 DEFAULT nextval('chat_plugin_id_seq'),
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  code varchar(80) NOT NULL DEFAULT '',
  ord INT2  NOT NULL DEFAULT '0',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_room`
--



--
-- Sequences for table CHAT_ROOM
--

CREATE SEQUENCE chat_room_id_seq;

CREATE TABLE chat_room (
  id INT4 DEFAULT nextval('chat_room_id_seq'),
  uid INT4  NOT NULL DEFAULT '0',
  name varchar(60) NOT NULL DEFAULT '',
  short_desc TEXT DEFAULT '' NOT NULL,
  long_desc text,
  url varchar(100) NOT NULL DEFAULT '',
  occupancy INT2  NOT NULL DEFAULT '10',
  status INT2 NOT NULL DEFAULT '1',
  status_msg TEXT DEFAULT '' NOT NULL,
  privilege INT2 NOT NULL DEFAULT '0',
  visible INT2  NOT NULL DEFAULT '1',
  private INT2  NOT NULL DEFAULT '0',
  create_date varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_date varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_by INT4  NOT NULL DEFAULT '0',
  used_date varchar(14) NOT NULL DEFAULT '00000000000000',
  image varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_room_access`
--

CREATE TABLE chat_room_access (
  rid INT4  NOT NULL DEFAULT '0',
  aid INT4  NOT NULL DEFAULT '0'
);

--
-- Table structure for table `chat_room_extra`
--



--
-- Sequences for table CHAT_ROOM_EXTRA
--

CREATE SEQUENCE chat_room_extra_id_seq;

CREATE TABLE chat_room_extra (
  id INT4 DEFAULT nextval('chat_room_extra_id_seq'),
  rid INT4  NOT NULL DEFAULT '0',
  name varchar(80) NOT NULL DEFAULT '',
  value TEXT DEFAULT '' NOT NULL,
  permission INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_room_privilege`
--



--
-- Sequences for table CHAT_ROOM_PRIVILEGE
--

CREATE SEQUENCE chat_room_privilege_id_seq;

CREATE TABLE chat_room_privilege (
  id INT4 DEFAULT nextval('chat_room_privilege_id_seq'),
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_room_status`
--

CREATE TABLE chat_room_status (
  id INT4  NOT NULL DEFAULT '1',
  name varchar(20) NOT NULL DEFAULT '',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `chat_session`
--

CREATE TABLE chat_session (
  id varchar(40) NOT NULL DEFAULT '',
  uid INT4  NOT NULL DEFAULT '0',
  aid INT4  NOT NULL DEFAULT '0',
  rid INT4  NOT NULL DEFAULT '0',
  status INT2  NOT NULL DEFAULT '0',
  status_description TEXT DEFAULT '' NOT NULL,
  firstread INT4  NOT NULL DEFAULT '0',
  lastread INT4  NOT NULL DEFAULT '0',
  created varchar(14) DEFAULT NULL,
  updated varchar(14) DEFAULT NULL,
  ip_address varchar(15) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `config`
--



--
-- Sequences for table CONFIG
--

CREATE SEQUENCE config_id_seq;

CREATE TABLE config (
  id INT4 DEFAULT nextval('config_id_seq'),
  name varchar(80) NOT NULL DEFAULT '',
  value TEXT DEFAULT '' NOT NULL,
  grp INT2  NOT NULL DEFAULT '0',
  override char(1) NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `config_group`
--



--
-- Sequences for table CONFIG_GROUP
--

CREATE SEQUENCE config_group_id_seq;

CREATE TABLE config_group (
  id INT4 DEFAULT nextval('config_group_id_seq'),
  name varchar(40) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  category varchar(10) NOT NULL DEFAULT '',
  plugin varchar(20) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `config_select`
--



--
-- Sequences for table CONFIG_SELECT
--

CREATE SEQUENCE config_select_id_seq;

CREATE TABLE config_select (
  id INT4 DEFAULT nextval('config_select_id_seq'),
  name TEXT DEFAULT '' NOT NULL,
  value varchar(80) NOT NULL DEFAULT '',
  form_field varchar(80) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `dyna_form`
--



--
-- Sequences for table DYNA_FORM
--

CREATE SEQUENCE dyna_form_id_seq;

CREATE TABLE dyna_form (
  id INT4 DEFAULT nextval('dyna_form_id_seq'),
  plugin varchar(20) NOT NULL DEFAULT '',
  interface varchar(40) NOT NULL DEFAULT '',
  template INT4  NOT NULL DEFAULT '1',
  name varchar(40) NOT NULL DEFAULT '',
  action varchar(80) NOT NULL DEFAULT '',
  method varchar(8) NOT NULL DEFAULT 'POST',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `dyna_form_button`
--



--
-- Sequences for table DYNA_FORM_BUTTON
--

CREATE SEQUENCE dyna_form_button_id_seq;

CREATE TABLE dyna_form_button (
  id INT4 DEFAULT nextval('dyna_form_button_id_seq'),
  type varchar(10) NOT NULL DEFAULT 'submit',
  name varchar(20) NOT NULL DEFAULT 'OK',
  value varchar(20) NOT NULL DEFAULT '',
  src TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (id)
);

--
-- Table structure for table `dyna_form_element`
--



--
-- Sequences for table DYNA_FORM_ELEMENT
--

CREATE SEQUENCE dyna_form_element_id_seq;

CREATE TABLE dyna_form_element (
  id INT4 DEFAULT nextval('dyna_form_element_id_seq'),
  name varchar(80) NOT NULL DEFAULT '',
  value TEXT DEFAULT '' NOT NULL,
  title varchar(80) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  form_name varchar(20) NOT NULL DEFAULT '',
  plugin varchar(20) NOT NULL DEFAULT '',
  interface varchar(40) NOT NULL DEFAULT '',
  operation varchar(20) NOT NULL DEFAULT '',
  is_required INT2  NOT NULL DEFAULT '0',
  is_unique INT2  NOT NULL DEFAULT '0',
  formsize_a varchar(5) NOT NULL DEFAULT '0',
  formsize_b INT4  NOT NULL DEFAULT '0',
  size_min INT2  NOT NULL DEFAULT '0',
  size_max INT4  NOT NULL DEFAULT '0',
  source varchar(10) NOT NULL DEFAULT 'user',
  source_name TEXT DEFAULT '' NOT NULL,
  script TEXT DEFAULT '' NOT NULL,
  type varchar(20) NOT NULL DEFAULT '',
  ord INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `dyna_form_group`
--



--
-- Sequences for table DYNA_FORM_GROUP
--

CREATE SEQUENCE dyna_form_group_id_seq;

CREATE TABLE dyna_form_group (
  id INT4 DEFAULT nextval('dyna_form_group_id_seq'),
  name varchar(20) NOT NULL DEFAULT '',
  type varchar(10) NOT NULL DEFAULT '',
  elements TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (id)
);

--
-- Table structure for table `dyna_form_select`
--



--
-- Sequences for table DYNA_FORM_SELECT
--

CREATE SEQUENCE dyna_form_select_id_seq;

CREATE TABLE dyna_form_select (
  id INT4 DEFAULT nextval('dyna_form_select_id_seq'),
  name TEXT DEFAULT '' NOT NULL,
  value varchar(80) NOT NULL DEFAULT '',
  form_field varchar(80) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `dyna_form_template`
--



--
-- Sequences for table DYNA_FORM_TEMPLATE
--

CREATE SEQUENCE dyna_form_template_id_seq;

CREATE TABLE dyna_form_template (
  id INT4 DEFAULT nextval('dyna_form_template_id_seq'),
  name varchar(40) NOT NULL DEFAULT '',
  template TEXT DEFAULT '' NOT NULL,
  permission INT4  NOT NULL DEFAULT '0',
  has_elements INT2  NOT NULL DEFAULT '1',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `element`
--



--
-- Sequences for table ELEMENT
--

CREATE SEQUENCE element_id_seq;

CREATE TABLE element (
  id INT4 DEFAULT nextval('element_id_seq'),
  interface varchar(25) NOT NULL DEFAULT 'default',
  plugin varchar(25) NOT NULL DEFAULT 'default',
  language INT2 NOT NULL DEFAULT '0',
  name varchar(80) NOT NULL DEFAULT '',
  content TEXT DEFAULT '' NOT NULL,
  code INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `format_color`
--



--
-- Sequences for table FORMAT_COLOR
--

CREATE SEQUENCE format_color_id_seq;

CREATE TABLE format_color (
  id INT4 DEFAULT nextval('format_color_id_seq'),
  color varchar(80) NOT NULL DEFAULT '',
  hex varchar(6) NOT NULL DEFAULT '',
  darkness INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `forum_board`
--



--
-- Sequences for table FORUM_BOARD
--

CREATE SEQUENCE forum_board_id_seq;

CREATE TABLE forum_board (
  id INT4 DEFAULT nextval('forum_board_id_seq'),
  parent INT4 NOT NULL DEFAULT '0',
  main INT4 NOT NULL DEFAULT '0',
  name varchar(80) NOT NULL DEFAULT '',
  title text,
  description text,
  cid INT4 NOT NULL DEFAULT '0',
  total INT4  DEFAULT NULL,
  last_post_dt varchar(14) DEFAULT NULL,
  html_flg INT2 NOT NULL DEFAULT '1',
  markup_flg INT2 NOT NULL DEFAULT '1',
  anon_flg INT2 NOT NULL DEFAULT '0',
  locked_dt varchar(14) NOT NULL DEFAULT '',
  create_dt varchar(14) DEFAULT NULL,
  expire_dt varchar(14) DEFAULT NULL,
  security INT4 DEFAULT '50',
  approve_flg INT2 NOT NULL DEFAULT '0',
  ord INT4 NOT NULL DEFAULT '0'
);

--
-- Table structure for table `forum_board_mod`
--

CREATE TABLE forum_board_mod (
  uid INT4  NOT NULL DEFAULT '0',
  bid INT4  NOT NULL DEFAULT '0'
);

--
-- Table structure for table `forum_category`
--



--
-- Sequences for table FORUM_CATEGORY
--

CREATE SEQUENCE forum_category_id_seq;

CREATE TABLE forum_category (
  id INT4 DEFAULT nextval('forum_category_id_seq'),
  parent INT4 NOT NULL DEFAULT '0',
  main INT4 NOT NULL DEFAULT '0',
  title varchar(255) NOT NULL DEFAULT 'General Discussion',
  ord INT4  DEFAULT '0'
);

--
-- Table structure for table `forum_post`
--



--
-- Sequences for table FORUM_POST
--

CREATE SEQUENCE forum_post_id_seq;

CREATE TABLE forum_post (
  id INT4 DEFAULT nextval('forum_post_id_seq'),
  bid INT4 NOT NULL DEFAULT '0',
  parent INT4  NOT NULL DEFAULT '0',
  main INT4  NOT NULL DEFAULT '0',
  post_dt varchar(14) NOT NULL DEFAULT '',
  last_post_dt varchar(14) NOT NULL DEFAULT '',
  aid INT4  NOT NULL DEFAULT '0',
  uid INT4  NOT NULL DEFAULT '0',
  sid varchar(47) NOT NULL DEFAULT '',
  ip_addr varchar(60) NOT NULL DEFAULT '',
  subject text,
  body text,
  comment TEXT DEFAULT '' NOT NULL,
  mail_flg INT2  NOT NULL DEFAULT '0',
  file varchar(100) NOT NULL DEFAULT '',
  kept_flg INT2  NOT NULL DEFAULT '0',
  status_flg INT2  NOT NULL DEFAULT '0',
  icon INT4  NOT NULL DEFAULT '1',
  views INT4  NOT NULL DEFAULT '1',
  rating INT4  DEFAULT NULL,
  expire_dt varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_dt varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_by INT4  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `forum_post_expire_type`
--



--
-- Sequences for table FORUM_POST_EXPIRE_TYPE
--

CREATE SEQUENCE forum_post_expire_type_id_se;

CREATE TABLE forum_post_expire_type (
  id INT4 DEFAULT nextval('forum_post_expire_type_id_se'),
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `forum_post_icon`
--



--
-- Sequences for table FORUM_POST_ICON
--

CREATE SEQUENCE forum_post_icon_id_seq;

CREATE TABLE forum_post_icon (
  id INT4 DEFAULT nextval('forum_post_icon_id_seq'),
  filename varchar(80) NOT NULL DEFAULT '',
  description varchar(80) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `forum_post_read`
--

CREATE TABLE forum_post_read (
  uid INT4  NOT NULL DEFAULT '0',
  bid INT4  NOT NULL DEFAULT '0',
  last_read_dt varchar(14) NOT NULL DEFAULT '',
  max_read INT4  NOT NULL DEFAULT '0',
  done_read TEXT DEFAULT '' NOT NULL
);

--
-- Table structure for table `forum_post_status`
--

CREATE TABLE forum_post_status (
  id INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `forum_post_type`
--



--
-- Sequences for table FORUM_POST_TYPE
--

CREATE SEQUENCE forum_post_type_id_seq;

CREATE TABLE forum_post_type (
  id INT4 DEFAULT nextval('forum_post_type_id_seq'),
  name varchar(20) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `groups`
--



--
-- Sequences for table GROUPS
--

CREATE SEQUENCE groups_id_seq;

CREATE TABLE groups (
  id INT4 DEFAULT nextval('groups_id_seq'),
  name varchar(80) NOT NULL DEFAULT '',
  description varchar(255) NOT NULL DEFAULT '',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `icon_formatter`
--



--
-- Sequences for table ICON_FORMATTER
--

CREATE SEQUENCE icon_formatter_id_seq;

CREATE TABLE icon_formatter (
  id INT4 DEFAULT nextval('icon_formatter_id_seq'),
  filename varchar(255) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  code TEXT DEFAULT '' NOT NULL,
  type varchar(10) NOT NULL DEFAULT '',
  ord INT4  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `icon_smiley`
--



--
-- Sequences for table ICON_SMILEY
--

CREATE SEQUENCE icon_smiley_id_seq;

CREATE TABLE icon_smiley (
  id INT4 DEFAULT nextval('icon_smiley_id_seq'),
  filename varchar(255) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  code TEXT DEFAULT '' NOT NULL,
  ord INT4  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `interface`
--



--
-- Sequences for table INTERFACE
--

CREATE SEQUENCE interface_id_seq;

CREATE TABLE interface (
  id INT4 DEFAULT nextval('interface_id_seq'),
  name varchar(40) NOT NULL DEFAULT '',
  plugin varchar(40) NOT NULL DEFAULT '',
  title varchar(80) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (id)
);

--
-- Table structure for table `language`
--



--
-- Sequences for table LANGUAGE
--

CREATE SEQUENCE language_id_seq;

CREATE TABLE language (
  id INT4 DEFAULT nextval('language_id_seq'),
  name varchar(25) NOT NULL DEFAULT '',
  description varchar(80) NOT NULL DEFAULT '',
  encoding varchar(6) NOT NULL DEFAULT '',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `locale_country`
--

CREATE TABLE locale_country (
  id INT4 NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `menu`
--



--
-- Sequences for table MENU
--

CREATE SEQUENCE menu_id_seq;

CREATE TABLE menu (
  id INT4 DEFAULT nextval('menu_id_seq'),
  parent INT4  NOT NULL DEFAULT '0',
  main INT4  NOT NULL DEFAULT '0',
  plugin varchar(60) NOT NULL DEFAULT '',
  interface varchar(60) NOT NULL DEFAULT '',
  operation varchar(60) NOT NULL DEFAULT '',
  condition TEXT DEFAULT '' NOT NULL,
  text varchar(80) NOT NULL DEFAULT '',
  url TEXT DEFAULT '' NOT NULL,
  target varchar(60) NOT NULL DEFAULT '_self',
  ord INT2 NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `permission`
--

CREATE TABLE permission (
  id INT4  NOT NULL DEFAULT '0',
  name varchar(40) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `sessions`
--

CREATE TABLE sessions (
  sesskey varchar(32) NOT NULL DEFAULT '',
  expiry INT4  NOT NULL DEFAULT '0',
  data TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (sesskey)
);

--
-- Table structure for table `site`
--



--
-- Sequences for table SITE
--

CREATE SEQUENCE site_id_seq;

CREATE TABLE site (
  id INT4 DEFAULT nextval('site_id_seq'),
  tid INT4  NOT NULL DEFAULT '0',
  name varchar(255) NOT NULL DEFAULT '',
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `theme`
--



--
-- Sequences for table THEME
--

CREATE SEQUENCE theme_id_seq;

CREATE TABLE theme (
  id INT4 DEFAULT nextval('theme_id_seq'),
  name varchar(20) NOT NULL DEFAULT '',
  description text,
  content TEXT DEFAULT '' NOT NULL,
  permission INT2  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `theme_config`
--



--
-- Sequences for table THEME_CONFIG
--

CREATE SEQUENCE theme_config_id_seq;

CREATE TABLE theme_config (
  id INT4 DEFAULT nextval('theme_config_id_seq'),
  theme INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  value varchar(80) NOT NULL DEFAULT '',
  permission INT4  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `theme_meta`
--



--
-- Sequences for table THEME_META
--

CREATE SEQUENCE theme_meta_id_seq;

CREATE TABLE theme_meta (
  id INT4 DEFAULT nextval('theme_meta_id_seq'),
  name varchar(80) NOT NULL DEFAULT '',
  value TEXT DEFAULT '' NOT NULL,
  theme INT4  NOT NULL DEFAULT '0',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `user_ban`
--



--
-- Sequences for table USER_BAN
--

CREATE SEQUENCE user_ban_id_seq;

CREATE TABLE user_ban (
  id INT4 DEFAULT nextval('user_ban_id_seq'),
  uid INT4  NOT NULL DEFAULT '0',
  entry_user INT4  NOT NULL DEFAULT '0',
  ip varchar(15) NOT NULL DEFAULT '',
  entry_date varchar(14) NOT NULL DEFAULT '',
  expiry_date varchar(14) NOT NULL DEFAULT '',
  reason TEXT DEFAULT '' NOT NULL,
  plugin varchar(20) NOT NULL DEFAULT '',
  interface varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `user_block`
--

CREATE TABLE user_block (
  uid INT4  NOT NULL DEFAULT '0',
  bid INT4  NOT NULL DEFAULT '0',
  misc INT2 NOT NULL DEFAULT '0'
);

--
-- Table structure for table `user_groups`
--

CREATE TABLE user_groups (
  uid INT4  NOT NULL DEFAULT '0',
  gid INT4  NOT NULL DEFAULT '0'
);

--
-- Table structure for table `user_preference`
--

CREATE TABLE user_preference (
  id INT4  NOT NULL DEFAULT '0',
  name varchar(40) NOT NULL DEFAULT '',
  value TEXT DEFAULT '' NOT NULL,
  plugin varchar(20) NOT NULL DEFAULT ''
);

--
-- Table structure for table `user_preference_group`
--



--
-- Sequences for table USER_PREFERENCE_GROUP
--

CREATE SEQUENCE user_preference_group_id_seq;

CREATE TABLE user_preference_group (
  id INT4 DEFAULT nextval('user_preference_group_id_seq'),
  name varchar(40) NOT NULL DEFAULT '',
  description TEXT DEFAULT '' NOT NULL,
  PRIMARY KEY  (id)
);

--
-- Table structure for table `user_tracking`
--

CREATE TABLE user_tracking (
  sid varchar(32) NOT NULL DEFAULT '',
  plugin varchar(60) NOT NULL DEFAULT '',
  extra TEXT DEFAULT '' NOT NULL,
  expire_date varchar(14) NOT NULL DEFAULT '',
  login_flag INT2  NOT NULL DEFAULT '0',
  uid INT4  NOT NULL DEFAULT '0',
  create_date varchar(14) NOT NULL DEFAULT '',
  update_date varchar(14) NOT NULL DEFAULT '',
  PRIMARY KEY  (sid)
);

--
-- Table structure for table `users`
--



--
-- Sequences for table USERS
--

CREATE SEQUENCE users_id_seq;

CREATE TABLE users (
  id INT4 DEFAULT nextval('users_id_seq'),
  username varchar(10) NOT NULL DEFAULT '',
  password varchar(80) NOT NULL DEFAULT '',
  name varchar(60) NOT NULL DEFAULT '',
  alias varchar(60) NOT NULL DEFAULT '',
  email varchar(60) NOT NULL DEFAULT '',
  fakeemail varchar(60) NOT NULL DEFAULT '',
  url varchar(100) NOT NULL DEFAULT '',
  locale_city varchar(40) NOT NULL DEFAULT '',
  locale_country INT4  NOT NULL DEFAULT '0',
  icq varchar(15) NOT NULL DEFAULT '',
  aim varchar(15) NOT NULL DEFAULT '',
  yim varchar(15) NOT NULL DEFAULT '',
  msnm varchar(15) NOT NULL DEFAULT '',
  occupation varchar(40) NOT NULL DEFAULT '',
  interests varchar(80) NOT NULL DEFAULT '',
  sig TEXT DEFAULT '' NOT NULL,
  bio TEXT DEFAULT '' NOT NULL,
  birth_date varchar(14) NOT NULL DEFAULT '00000000000000',
  create_date varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_date varchar(14) NOT NULL DEFAULT '00000000000000',
  login_date varchar(14) NOT NULL DEFAULT '00000000000000',
  modify_by INT4 NOT NULL DEFAULT '0',
  login_count INT4 NOT NULL DEFAULT '1',
  last_ip varchar(20) NOT NULL DEFAULT '',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `zone`
--



--
-- Sequences for table ZONE
--

CREATE SEQUENCE zone_id_seq;

CREATE TABLE zone (
  id INT4 DEFAULT nextval('zone_id_seq'),
  theme INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  content TEXT DEFAULT '' NOT NULL,
  active INT2  NOT NULL DEFAULT '1',
  PRIMARY KEY  (id)
);

--
-- Table structure for table `zonebak`
--



--
-- Sequences for table ZONEBAK
--

CREATE SEQUENCE zonebak_id_seq;

CREATE TABLE zonebak (
  id INT4 DEFAULT nextval('zonebak_id_seq'),
  theme INT4  NOT NULL DEFAULT '0',
  name varchar(20) NOT NULL DEFAULT '',
  content TEXT DEFAULT '' NOT NULL,
  blockdef TEXT DEFAULT '' NOT NULL,
  active INT2  NOT NULL DEFAULT '1',
  PRIMARY KEY  (id)
);



--
-- Indexes for table ARTICLE_TOPIC_RELATED
--

CREATE INDEX theme_article_topic_related_index ON article_topic_related (topic);

--
-- Indexes for table FORUM_POST_TYPE
--

CREATE UNIQUE INDEX id_forum_post_type_index ON forum_post_type (id);

--
-- Indexes for table THEME_META
--

CREATE INDEX theme_theme_meta_index ON theme_meta (theme);

--
-- Indexes for table FORUM_POST_READ
--

CREATE INDEX bid_forum_post_read_index ON forum_post_read (bid);
CREATE INDEX uid_forum_post_read_index ON forum_post_read (uid);

--
-- Indexes for table CONFIG_SELECT
--

CREATE INDEX form_field_config_select_index ON config_select (form_field);
CREATE INDEX value_config_select_index ON config_select (value);

--
-- Indexes for table ELEMENT
--

CREATE INDEX name_element_index ON element (name);
CREATE INDEX plugin_element_index ON element (plugin);

--
-- Indexes for table ZONEBAK
--

CREATE INDEX theme_zonebak_index ON zonebak (theme);

--
-- Indexes for table FORUM_POST_EXPIRE_TYPE
--

CREATE UNIQUE INDEX id_forum_post_expire_type_index ON forum_post_expire_type (id);

--
-- Indexes for table CHAT_ROOM
--

CREATE UNIQUE INDEX name_chat_room_index ON chat_room (name);

--
-- Indexes for table ALIAS_ACTIVITY
--

CREATE UNIQUE INDEX id_alias_activity_index ON alias_activity (id);

--
-- Indexes for table USER_BAN
--

CREATE INDEX uid_user_ban_index ON user_ban (uid);

--
-- Indexes for table DYNA_FORM_TEMPLATE
--

CREATE INDEX name_dyna_form_template_index ON dyna_form_template (name);

--
-- Indexes for table PERMISSION
--

CREATE INDEX name_permission_index ON permission (name);

--
-- Indexes for table FORUM_BOARD
--

CREATE UNIQUE INDEX name_forum_board_index ON forum_board (name);
CREATE UNIQUE INDEX id_forum_board_index ON forum_board (id);
CREATE INDEX indx2_forum_board_index ON forum_board (id);

--
-- Indexes for table CHAT_ROOM_PRIVILEGE
--

CREATE UNIQUE INDEX id_chat_room_privilege_index ON chat_room_privilege (id);

--
-- Indexes for table ZONE
--

CREATE INDEX theme_zone_index ON zone (theme);
CREATE INDEX name_zone_index ON zone (name);

--
-- Indexes for table DYNA_FORM_SELECT
--

CREATE INDEX form_field_dyna_form_select_index ON dyna_form_select (form_field);
CREATE INDEX value_dyna_form_select_index ON dyna_form_select (value);

--
-- Indexes for table CHAT_SESSION
--

CREATE INDEX uid_chat_session_index ON chat_session (uid,aid,rid);
CREATE INDEX updated_chat_session_index ON chat_session (updated);

--
-- Indexes for table ALIAS_STATUS
--

CREATE UNIQUE INDEX id_alias_status_index ON alias_status (id);

--
-- Indexes for table THEME_CONFIG
--

CREATE INDEX theme_theme_config_index ON theme_config (theme);

--
-- Indexes for table FORUM_BOARD_MOD
--

CREATE INDEX uid_forum_board_mod_index ON forum_board_mod (uid,bid);

--
-- Indexes for table ARTICLE_TOPIC
--

CREATE INDEX name_article_topic_index ON article_topic (name);

--
-- Indexes for table BLOCK
--

CREATE INDEX theme_block_index ON block (theme);
CREATE INDEX zone_block_index ON block (zone);
CREATE INDEX interface_block_index ON block (interface);

--
-- Indexes for table ALIAS
--

CREATE INDEX userid_alias_index ON alias (uid);

--
-- Indexes for table ARTICLE_USERINFO
--

CREATE INDEX uid_article_userinfo_index ON article_userinfo (uid);

--
-- Indexes for table DYNA_FORM_GROUP
--

CREATE UNIQUE INDEX id_dyna_form_group_index ON dyna_form_group (id);
CREATE INDEX name_dyna_form_group_index ON dyna_form_group (name);

--
-- Indexes for table DYNA_FORM
--

CREATE UNIQUE INDEX id_dyna_form_index ON dyna_form (id);
CREATE INDEX interface_dyna_form_index ON dyna_form (plugin);

--
-- Indexes for table FORUM_POST_ICON
--

CREATE INDEX filename_forum_post_icon_index ON forum_post_icon (filename);

--
-- Indexes for table CHAT_PLUGIN
--

CREATE UNIQUE INDEX name_chat_plugin_index ON chat_plugin (name);

--
-- Indexes for table CHAT_ROOM_EXTRA
--

CREATE INDEX aid_chat_room_extra_index ON chat_room_extra (rid);

--
-- Indexes for table DYNA_FORM_ELEMENT
--

CREATE UNIQUE INDEX id_dyna_form_element_index ON dyna_form_element (id);

--
-- Indexes for table SITE
--

CREATE INDEX name_site_index ON site (name);

--
-- Indexes for table DYNA_FORM_BUTTON
--

CREATE UNIQUE INDEX id_dyna_form_button_index ON dyna_form_button (id);
CREATE INDEX name_dyna_form_button_index ON dyna_form_button (name);

--
-- Indexes for table THEME
--

CREATE INDEX name_theme_index ON theme (name);

--
-- Indexes for table USER_PREFERENCE
--

CREATE INDEX id_user_preference_index ON user_preference (id,name);

--
-- Indexes for table ALIAS_EXTRA
--

CREATE INDEX aid_alias_extra_index ON alias_extra (aid);

--
-- Indexes for table ALIAS_SYSTEM
--

CREATE UNIQUE INDEX id_alias_system_index ON alias_system (id);

--
-- Indexes for table FORUM_CATEGORY
--

CREATE INDEX indx1_forum_category_index ON forum_category (title);
CREATE INDEX indx2_forum_category_index ON forum_category (id);

--
-- Indexes for table FORUM_POST_STATUS
--

CREATE UNIQUE INDEX id_forum_post_status_index ON forum_post_status (id);

--
-- Indexes for table FORUM_POST
--

CREATE INDEX aid_forum_post_index ON forum_post (aid);

--
-- Indexes for table INTERFACE
--

CREATE INDEX name_interface_index ON interface (name);

--
-- Sequences for table ARTICLE_TOPIC_RELATED
--

SELECT SETVAL('article_topic_related_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from article_topic_related));

--
-- Sequences for table FORUM_POST_TYPE
--

SELECT SETVAL('forum_post_type_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from forum_post_type));

--
-- Sequences for table THEME_META
--

SELECT SETVAL('theme_meta_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from theme_meta));

--
-- Sequences for table CONFIG_SELECT
--

SELECT SETVAL('config_select_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from config_select));

--
-- Sequences for table CHAT_LOG
--

SELECT SETVAL('chat_log_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from chat_log));

--
-- Sequences for table ELEMENT
--

SELECT SETVAL('element_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from element));

--
-- Sequences for table ZONEBAK
--

SELECT SETVAL('zonebak_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from zonebak));

--
-- Sequences for table LANGUAGE
--

SELECT SETVAL('language_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from language));

--
-- Sequences for table FORUM_POST_EXPIRE_TYPE
--

SELECT SETVAL('forum_post_expire_type_id_se',(select case when max(id)>0 then max(id)+1 else 1 end from forum_post_expire_type));

--
-- Sequences for table CHAT_ROOM
--

SELECT SETVAL('chat_room_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from chat_room));

--
-- Sequences for table USER_BAN
--

SELECT SETVAL('user_ban_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from user_ban));

--
-- Sequences for table DYNA_FORM_TEMPLATE
--

SELECT SETVAL('dyna_form_template_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from dyna_form_template));

--
-- Sequences for table FORUM_BOARD
--

SELECT SETVAL('forum_board_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from forum_board));

--
-- Sequences for table CHAT_ROOM_PRIVILEGE
--

SELECT SETVAL('chat_room_privilege_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from chat_room_privilege));

--
-- Sequences for table CHAT_MESSAGE
--

SELECT SETVAL('chat_message_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from chat_message));

--
-- Sequences for table ZONE
--

SELECT SETVAL('zone_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from zone));

--
-- Sequences for table DYNA_FORM_SELECT
--

SELECT SETVAL('dyna_form_select_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from dyna_form_select));

--
-- Sequences for table THEME_CONFIG
--

SELECT SETVAL('theme_config_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from theme_config));

--
-- Sequences for table GROUPS
--

SELECT SETVAL('groups_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from groups));

--
-- Sequences for table ARTICLE_TOPIC
--

SELECT SETVAL('article_topic_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from article_topic));

--
-- Sequences for table ARTICLE
--

SELECT SETVAL('article_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from article));

--
-- Sequences for table BLOCK
--

SELECT SETVAL('block_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from block));

--
-- Sequences for table USERS
--

SELECT SETVAL('users_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from users));

--
-- Sequences for table USER_PREFERENCE_GROUP
--

SELECT SETVAL('user_preference_group_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from user_preference_group));

--
-- Sequences for table ALIAS
--

SELECT SETVAL('alias_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from alias));

--
-- Sequences for table ARTICLE_USERINFO
--

SELECT SETVAL('article_userinfo_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from article_userinfo));

--
-- Sequences for table FORMAT_COLOR
--

SELECT SETVAL('format_color_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from format_color));

--
-- Sequences for table DYNA_FORM_GROUP
--

SELECT SETVAL('dyna_form_group_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from dyna_form_group));

--
-- Sequences for table DYNA_FORM
--

SELECT SETVAL('dyna_form_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from dyna_form));

--
-- Sequences for table FORUM_POST_ICON
--

SELECT SETVAL('forum_post_icon_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from forum_post_icon));

--
-- Sequences for table ARTICLE_COMMENT
--

SELECT SETVAL('article_comment_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from article_comment));

--
-- Sequences for table MENU
--

SELECT SETVAL('menu_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from menu));

--
-- Sequences for table CHAT_PLUGIN
--

SELECT SETVAL('chat_plugin_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from chat_plugin));

--
-- Sequences for table CHAT_ROOM_EXTRA
--

SELECT SETVAL('chat_room_extra_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from chat_room_extra));

--
-- Sequences for table DYNA_FORM_ELEMENT
--

SELECT SETVAL('dyna_form_element_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from dyna_form_element));

--
-- Sequences for table SITE
--

SELECT SETVAL('site_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from site));

--
-- Sequences for table DYNA_FORM_BUTTON
--

SELECT SETVAL('dyna_form_button_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from dyna_form_button));

--
-- Sequences for table THEME
--

SELECT SETVAL('theme_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from theme));

--
-- Sequences for table CONFIG_GROUP
--

SELECT SETVAL('config_group_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from config_group));

--
-- Sequences for table ALIAS_EXTRA
--

SELECT SETVAL('alias_extra_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from alias_extra));

--
-- Sequences for table ALIAS_SYSTEM
--

SELECT SETVAL('alias_system_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from alias_system));

--
-- Sequences for table ICON_SMILEY
--

SELECT SETVAL('icon_smiley_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from icon_smiley));

--
-- Sequences for table CONFIG
--

SELECT SETVAL('config_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from config));

--
-- Sequences for table FORUM_CATEGORY
--

SELECT SETVAL('forum_category_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from forum_category));

--
-- Sequences for table INTERFACE
--

SELECT SETVAL('interface_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from interface));

--
-- Sequences for table FORUM_POST
--

SELECT SETVAL('forum_post_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from forum_post));

--
-- Sequences for table ICON_FORMATTER
--

SELECT SETVAL('icon_formatter_id_seq',(select case when max(id)>0 then max(id)+1 else 1 end from icon_formatter));

COMMIT;
