<?php
/* Core table definitions
 *
 * These tables are used by all interfaces or by multiple interfaces.
 */

$prefix = $config[table_prefix];
$dbtable = array();

$tname = $prefix . 'site';
$dbtable[site][table] = $tname;
$dbtable[site][columns] = array ('id' => $tname . '.id',
                                 'tid' => $tname . '.tid',
                                 'name' => $tname . '.name',
                                 'permission' => $tname . '.permission');

$tname = $prefix . 'theme';
$dbtable[theme][table] = $tname;
$dbtable[theme][columns] = array ('id' => $tname . '.id',
                                 'name' => $tname . '.name',
                                 'content' => $tname . '.content',
                                 'description' => $tname . '.description',
                                 'permission' => $tname . '.permission');
$tname = $prefix . 'theme_config';
$dbtable[theme_config][table] = $tname;
$dbtable[theme_config][columns] = array ('id' => $tname . '.id',
                                 'name' => $tname . '.name',
                                 'value' => $tname . '.value',
                                 'theme' => $tname . '.theme',
                                 'permission' => $tname . '.permission');
$tname = $prefix . 'theme_meta';
$dbtable[theme_meta][table] = $tname;
$dbtable[theme_meta][columns] = array ('id' => $tname . '.id',
                                 'name' => $tname . '.name',
                                 'value' => $tname . '.value',
                                 'theme' => $tname . '.theme',
                                 'permission' => $tname . '.permission');
$tname = $prefix . 'zone';
$dbtable[zone][table] = $tname;
$dbtable[zone][columns] = array ('id' => $tname . '.id',
                                 'name' => $tname . '.name',
                                 'content' => $tname . '.content',
                                 'theme' => $tname . '.theme',
                                 'active' => $tname . '.active');
$tname = $prefix . 'block';
$dbtable[block][table] = $tname;
$dbtable[block][columns] = array ('id' => $tname . '.id',
                                 'theme' => $tname . '.theme',
                                 'zone' => $tname . '.zone',
                                 'user_block' => $tname . '.user_block',
                                 'grp' => $tname . '.grp',
                                 'interface' => $tname . '.interface',
                                 'operation' => $tname . '.operation',
                                 'title' => $tname . '.title',
                                 'content' => $tname . '.content',
                                 'code' => $tname . '.code',
                                 'multi' => $tname . '.multi',
                                 'ord' => $tname . '.ord');
$tname = $prefix . 'element';
$dbtable[element][table] = $tname;
$dbtable[element][columns] = array ('id' => $tname . '.id',
                                 'interface' => $tname . '.interface',
                                 'plugin' => $tname . '.plugin',
                                 'language' => $tname . '.language',
                                 'name' => $tname . '.name',
                                 'content' => $tname . '.content',
                                 'code' => $tname . '.code');

$tname = $prefix . 'users';
$dbtable[users][table] = $tname;
$dbtable[users][columns] = array ('id'     => $tname . '.id',
                                  'username'  => $tname . '.username',
                                  'password'  => $tname . '.password',
                                  'name'  => $tname . '.name',
                                  'alias'  => $tname . '.alias',
                                  'email'  => $tname . '.email',
                                  'fakeemail'  => $tname . '.fakeemail',
                                  'url'  => $tname . '.url',
                                  'locale_city'  => $tname . '.locale_city',
                                  'locale_country'  => $tname . '.locale_country',
                                  'icq'  => $tname . '.icq',
                                  'aim'  => $tname . '.aim',
                                  'yim'  => $tname . '.yim',
                                  'msnm'  => $tname . '.msnm',
                                  'occupation'  => $tname . '.occupation',
                                  'interests'  => $tname . '.interests',
                                  'sig'  => $tname . '.sig',
                                  'bio'  => $tname . '.bio',
                                  'create_date'  => $tname . '.create_date',
                                  'modify_date'  => $tname . '.modify_date',
                                  'login_date'  => $tname . '.login_date',
                                  'modify_by'  => $tname . '.modify_by',
                                  'login_count'  => $tname . '.login_count',
                                  'last_ip'  => $tname . '.last_ip',
                                  );

$tname = $prefix . 'user_ban';
$dbtable[user_ban][table] = $tname;
$dbtable[user_ban][columns] = array ('id'     => $tname . '.id',
                                  'uid'  => $tname . '.uid',
                                  'entry_user' => $tname . '.entry_user',
                                  'ip'  => $tname . '.ip',
                                  'entry_date' => $tname . '.entry_date',
                                  'expiry_date' => $tname . '.expiry_date',
                                  'reason'  => $tname . '.reason',
                                  'plugin'  => $tname . '.plugin',
                                  'interface' => $tname . '.interface',
                                  );

$tname = $prefix . 'user_preference';
$dbtable[user_preference][table] = $tname;
$dbtable[user_preference][columns] = array ('id'     => $tname . '.id',
                                  'name' => $tname . '.name',
                                  'value' => $tname . '.value',
                                  'plugin' => $tname . '.plugin',
                                  'permission' => $tname . '.permission');
$tname = $prefix . 'user_block';
$dbtable[user_block][table] = $tname;
$dbtable[user_block][columns] = array ('uid'     => $tname . '.uid',
                                       'bid'  => $tname . '.bid',
                                       'misc' => $tname . '.misc');

$tname = $prefix . 'dyna_form';
$dbtable[dyna_form][table] = $tname;
$dbtable[dyna_form][columns] = array ('id'     => $tname . '.id',
                                      'plugin' => $tname . '.plugin',
                                      'interface' => $tname . '.interface',
                                      'template' => $tname . '.template',
                                      'name' => $tname . '.name',
                                      'action' => $tname . '.action',
                                      'method' => $tname . '.method');
$tname = $prefix . 'dyna_form_element';
$dbtable[dyna_form_element][table] = $tname;
$dbtable[dyna_form_element][columns] = array ('id'     => $tname . '.id',
                                      'name'     => $tname . '.name',
                                      'title'     => $tname . '.title',
                                      'description' => $tname . '.description',
                                      'type'  => $tname . '.type',
                                      'source'  => $tname . '.source',
                                      'source_name' => $tname . '.source_name',
                                      'value'    => $tname . '.value',

                                      'form_name'     => $tname . '.form_name',
                                      'plugin'  => $tname . '.plugin',
                                      'interface' => $tname . '.interface',
                                      'operation' => $tname . '.operation',

                                      'is_required' => $tname . '.is_required',
                                      'is_unique' => $tname . '.is_unique',
                                      'formsize_a'  => $tname . '.formsize_a',
                                      'formsize_b'  => $tname . '.formsize_b',
                                      'size_min'  => $tname . '.size_min',
                                      'size_max'  => $tname . '.size_max',

                                      'script'  => $tname . '.script',
                                      'ord'       => $tname . '.ord');
$tname = $prefix . 'dyna_form_template';
$dbtable[dyna_form_template][table] = $tname;
$dbtable[dyna_form_template][columns] = array('id'  => $tname . '.id',
                                              'name'  => $tname . '.name',
                                              'template'  => $tname . '.template',
                                              'permission'  => $tname . '.permission',
                                              'has_elements'  => $tname . '.has_elements');
$tname = $prefix . 'dyna_form_select';
$dbtable[dyna_form_select][table] = $tname;
$dbtable[dyna_form_select][columns] = array ('id' => $tname . '.id',
                                             'name' => $tname . '.name',
                                             'value'  => $tname . '.value',
                                             'form_field' => $tname . '.form_field');

$tname = $prefix . 'alias';
$dbtable[alias][table] = $tname;
$dbtable[alias][columns] = array ('id'     => $tname . '.id',
                                  'uid'     => $tname . '.uid',
                                  'name'     => $tname . '.name',
                                  'system'     => $tname . '.system',
                                  'status'     => $tname . '.status',
                                  'activity'     => $tname . '.activity',
                                  'url'     => $tname . '.url',
                                  'description'     => $tname . '.description',
                                  'image'     => $tname . '.image',
                                  'entry_message'     => $tname . '.entry_message', // chat-local
                                  'exit_message'     => $tname . '.exit_message', //chat-local
                                  'allow_public'     => $tname . '.allow_public', //sub-table views
                                  'create_date'     => $tname . '.create_date',
                                  'modify_date'     => $tname . '.modify_date',
                                  'login_date'     => $tname . '.login_date', // chat-local
                                  'login_count'     => $tname . '.login_count', // chat-local
                                  'delete_date'     => $tname . '.delete_date',
                                  'inactive_date'     => $tname . '.inactive_date',
                                  'can_modify'     => $tname . '.can_modify', // sub-table
                                  'modify_by'     => $tname . '.modify_by',
                                  );
$tname = $prefix . 'alias_extra';
$dbtable[alias_extra][table] = $tname;
$dbtable[alias_extra][columns] = array ('id'  => $tname . '.id',
                                        'aid' => $tname . '.aid',
                                        'name' => $tname  . '.name',
                                        'value' => $tname . '.value',
                                        'permission'  => $tname . '.permission');
$tname = $prefix . 'alias_status';
$dbtable[alias_status][table] = $tname;
$dbtable[alias_status][columns] = array ('id'  => $tname . '.id',
                                         'name' => $tname . '.name',
                                         'description' => $tname . '.description',
                                         'permission' => $tname . '.permission',
                                          );
$tname = $prefix . 'alias_activity';
$dbtable[alias_activity][table] = $tname;
$dbtable[alias_activity][columns] = array ('id'  => $tname . '.id',
                                         'name' => $tname . '.name',
                                         'description' => $tname . '.description',
                                         'permission' => $tname . '.permission',
                                            );
$tname = $prefix . 'alias_system';
$dbtable[alias_system][table] = $tname;
$dbtable[alias_system][columns] = array ('id'  => $tname . '.id',
                                         'name' => $tname . '.name',
                                         'description' => $tname . '.description',
                                         'permission' => $tname . '.permission',
                                          );

$tname = $prefix . 'icon_smiley';
$dbtable[icon_smiley][table] = $tname;
$dbtable[icon_smiley][columns] = array ('id'     => $tname . '.id',
                                        'filename'     => $tname . '.filename',
                                        'description'     => $tname . '.description',
                                        'code'     => $tname . '.code',
                                        'ord'     => $tname . '.ord',
                                        );

$tname = $prefix . 'icon_formatter';
$dbtable[icon_formatter][table] = $tname;
$dbtable[icon_formatter][columns] = array ('id'     => $tname . '.id',
                                        'filename'     => $tname . '.filename',
                                        'description'     => $tname . '.description',
                                        'code'     => $tname . '.code',
                                        'type'     => $tname . '.type',
                                        'ord'     => $tname . '.ord',
                                        );

$tname = $prefix . 'format_color';
$dbtable[format_color][table] = $tname;
$dbtable[format_color][columns] = array ('id'     => $tname . '.id',
                                        'color'     => $tname . '.color',
                                        'hex'     => $tname . '.hex',
                                        'darkness'     => $tname . '.darkness');

$tname = $prefix . 'format_size';
$dbtable[format_size][table] = $tname;
$dbtable[format_size][columns] = array ('id'     => $tname . '.id',
                                        'size'     => $tname . '.size');

$tname = $prefix . 'format_font';
$dbtable[format_font][table] = $tname;
$dbtable[format_font][columns] = array ('id'     => $tname . '.id',
                                        'font'     => $tname . '.color',
                                        'common_flg'     => $tname . '.common_flg');

?>