<?php
include_once("../function.php");

class Theme {
  var $parser;
  var $depth;
  var $output;
  var $tagmap = array("SITE" => 1,
         "THEME" => 1,
         "ZONE" => 1,
         "BLOCK" => 1,
         "ELEMENT" => 1,
         "DATA" => 2);
  var $data = array();  
  /* Constructor
  */
  function Theme ($themeID = '') {
    global $dbh, $userinfo, $config, $gui;

    // Create the parser object.
    $this->parser = xml_parser_create();
    $this->depth = 0;
    $this->data[tconfig][title] = "HELLO!";
    
    // Setup the XML patser 
    xml_set_object ($this->parser, &$this);
    xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, true);
    xml_set_element_handler($this->parser, 'startElement', 'endElement');
    xml_set_character_data_handler($this->parser, 'characterData');
    xml_set_processing_instruction_handler($this->parser, "PIHandler");
    //xml_set_default_handler($this->parser, "defaultHandler");
    xml_set_external_entity_ref_handler($this->parser, "externalHandler");
    
    // Determine site identity.
    $site_name = getenv('SERVER_NAME');
    list ($dbt,$dbc) = $gui->command->DBGetTable('site');
    $sql = "select $dbc[id], $dbc[tid] from $dbt where $dbc[name] = " . $dbh->qstr($site_name);
    $result = $dbh->Execute($sql) or die( "ADODB: Could not load site definition");
    if (empty($result->fields[id]) || $result->fields[id] == '') {
      die("No site definition found for $site_name.");
    }
    
    // Determine theme to load and extract definition.
    if (isset($themeID) && $themeID != '') { // Static theme 
      $this->id = $themeID;
    } elseif ($config[allow_user_theme] == true && (isset($userinfo[theme]) && $userinfo[theme] != '')) { // theme by user
      $this->id = $userinfo[theme];
    } else { // theme by site default
      $this->id = $result->fields[tid];
    }
    $tid_q = $dbh->qstr($this->id);
    list ($dbt,$dbc) = $gui->command->DBGetTable('theme');
    $sql = <<<END_SQL
select $dbc[name], $dbc[content] from $dbt where $dbc[id] = $tid_q
END_SQL;
    $result = $dbh->Execute($sql) or die ("ADODB: Could not load theme definition");
    if (empty($result->fields[name]) || $result->fields[name] == '') {
      die("No theme definition found for theme ID $tid_q.");
    }
    $this->content = <<<END_XML
<?xml version='1.0'?>
<!DOCTYPE chapter SYSTEM "/just/a/test.dtd" [
]>
{$result->fields[content]}

END_XML;
  }
  
  function resetParser() {
    xml_parser_free($this->parser);
    $this->output = '';
    $this->depth = 0;

    $this->parser = xml_parser_create();
    xml_set_object ($this->parser, &$this);
    xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, true);
    xml_set_element_handler($this->parser, 'startElement', 'endElement');
    xml_set_character_data_handler($this->parser, 'characterData');
    xml_set_processing_instruction_handler($this->parser, "PIHandler");
    //xml_set_default_handler($this->parser, "defaultHandler");
    xml_set_external_entity_ref_handler($this->parser, "externalHandler");
  }
  
  function parse($data) {
    //while (preg_match("/<(data)/", $data)) {
      xml_parse($this->parser, $data);
      $data = $this->output;

      if (preg_match("/<data/", $data)) { 
print $data;
        $this->resetParser(); 
        xml_parse($this->parser, $data);
      }
    //}
  }
  
  function display() {
    $this->parse($this->content);
    return $this->output;
  }
  
  function startElement($parser, $name, $attrs) {
print "$name<br>\n";
    if ($this->tagmap[$name] == 1) {
      $this->loadElement($name, $attrs);
    } elseif ($this->tagmap[$name] == 2) {
      $this->loadData ($name, $attrs); 
    }else { // HTMLize all other output
      $this->output .= "<$name";
      if (sizeof ($attrs) > 0 ) {
        while (list($k, $v) = each ($attrs)) {
          $this->output .= " $k=\"$v\"";
        }
      }
      $this->output .= ">";
    }
  }
  
  function endElement ($parser, $name) {
print "..$name<br>\n";
    if ($this->tagmap[$name] == true) {
      //$this->output .= "$name\n";
      //$this->output .= "</td></tr></table>";
      //$this->depth--;
    } else { // HTMLize all other output
      $this->output .= "</$name>";
    }
  }
  
  function loadElement($name, $attrs) {
    global $dbh;
    
    $table_name = $name;
    while (list($k, $v) = each($attrs)) {
      $sql_w .= " $k = " . $dbh->qstr($v);
    }
    $sql = "select content from $table_name where $sql_w";
    $result = $dbh->Execute($sql);
    
    //$this->parse($this->parser, $result->fields[content]);
    $this->output .= $result->fields[content];
  }
  
  function loadData ($name, $attrs) {
    global $gui;

    $v = $attrs[NAME];
    $sub = explode(".", $v);
    $retval = $this->data[$sub[0]];
    for ($i = 1; $i < sizeof($sub); $i++) {
      $retval = isset($retval[$sub[$i]]) ? $retval[$sub[$i]]: '';
    }
    $var = (empty($retval)) ? "" : $retval;
    $this->output .= $var;
  }
  
  function characterData ($parser, $data) { 
    $this->output .= $data;
  }
  
  function PIHandler ($parser, $target, $data) {
    switch (strtolower($target)) {
      case "php":
        eval($data);
        $this->output .= "<br>\n";
        break;
    }
  }
  
  function defaultHandler ($parser, $data) {
  }
  
  function externalHandler ($parser, $openEntities, $base, $sysID, $pubID) {
    if ($sysID) {
      if (!list($parser, $fp) = new_xml_parser($sysId)) {
        $this->output .= sprintf("Could not open entity %s at %s\n", $openEntities,$sysId);
        return false;
      }
      /*while ($data = fread($fp, 4096)) {
        if (!xml_parse($parser, $data, feof($fp))) {
          $this->output .=f("XML error: %s at line %d while parsing entity %s\n",
            xml_error_string(xml_get_error_code($parser)),
            xml_get_current_line_number($parser), $openEntityNames);
            xml_parser_free($parser);
          return false;
        }
      }*/
      xml_parser_free($parser);
      return true;
    }
  }

  function assign ($name, $value) {
    $this->data[$name] = $value;
  }

}

//<!ENTITY systemEntity SYSTEM "xmltest2.xml">

//$sql = "select content from theme where name='xml'"; 
//$result = $dbh->Execute($sql) or die ($dbh->ErrorMsg());

$var = <<<END_TEXT
<?xml version="1.0"?>
<html>
<body>
<table>
  <tr>
    <td>
  <zone name="header">
    <block name="content"/>
  </zone>
    </td>
  </tr>
  <tr>
    <td>
  <zone name="main">
    <table><tr><td>
    <block name="header"/>
    </td></tr><tr><td>
    <block name="content"/>
    </td></tr><tr><td>
    <block name="footer"/>
    </td></tr></table>
  </zone>
    </td>
  </tr>
  <tr>
    <td>
  <zone name="footer">
    <blockdef>
    </blockdef>
  </zone>
    </td>
  </tr>
</table>
</body>
</html>

END_TEXT;

?>